using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Configuration;
using System.Text.RegularExpressions;
using AGV_WPF_Global;

namespace AGV_WPF
{
    /// <summary>
    /// AGVParaSetting.xaml Ľ߼
    /// </summary>
    public partial class AGVParaSetting : Window
    {
        /// <summary>
        /// 캯ȡļеϵͳ
        /// </summary>
        public AGVParaSetting()
        {
            InitializeComponent();
        }

        /// <summary>
        /// ش壬ʼtextbox
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            tbAGVnum.Text = ConfigurationManager.AppSettings["AGVNUM_MAX"];
            tbMapScale.Text = ConfigurationManager.AppSettings["MapScale"];
            //tbTraffic.Text = ConfigurationManager.AppSettings["TRAFFIC_CONAREA_MAX"];
            //tbMark.Text = ConfigurationManager.AppSettings["TRAFFIC_CONAREA_MARKNUM_MAX"];
            tbWaiting.Text = ConfigurationManager.AppSettings["TRAFFIC_CONAREA_WAITAGVNUM_MAX"];
            txtAGVPicW.Text = GlobalPara.AgvIconW.ToString();
            txtAGVPicH.Text = GlobalPara.AgvIconH.ToString();
            txtAreaName.Text = GlobalPara.areaName;
            checkBox_SavePic.IsChecked = GlobalPara.IsExceptionSavePic;
            DAL.ZSql sqlRequirePara = new DAL.ZSql();
            //޸ڣ2014-1-21
            //ܹͨ޹أʱҲһݣΪ0
            sqlRequirePara.Open("SELECT COUNT(DISTINCT TrafficNum) AS TrafficCount FROM T_Traffic");
            if (sqlRequirePara.rowcount > 0)
            {
                tbTraffic.Text = sqlRequirePara.Rows[0]["TrafficCount"].ToString();
            }
            else
            {
                tbTraffic.Text = "0";
            }

            //޸ڣ2014-1-21
            //ͨ˵رһʱҲһݣûκݣҲΪ
            sqlRequirePara.Open("SELECT MAX(TrafficCount) AS MaxTrafficCount FROM (SELECT COUNT(MarkID) AS TrafficCount FROM T_Traffic GROUP BY TrafficNum) AS T_TrafficCount");
            if (sqlRequirePara.rowcount > 0)
            {
                string oMaxTrafficCount = sqlRequirePara.Rows[0]["MaxTrafficCount"].ToString().Trim();
                tbMark.Text = string.IsNullOrEmpty(oMaxTrafficCount) ? "0" : oMaxTrafficCount;
            }
            else
            {
                tbMark.Text = "0";
            }
            sqlRequirePara.Close();           
        }

        #region ȷ޸
        /// <summary>
        /// ޸ò
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnModify_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                if (string.IsNullOrEmpty(tbAGVnum.Text.Trim()) || string.IsNullOrEmpty(tbWaiting.Text.Trim()) || string.IsNullOrEmpty(txtAGVPicH.Text) || string.IsNullOrEmpty(txtAGVPicW.Text))
                {
                    MessageBox.Show("벻Ϊգ");
                    return;
                }
                Regex regex = new Regex(@"^[0-9]*[1-9][0-9]*$");//ƥ 
                if (regex.IsMatch(tbAGVnum.Text.Trim()) && regex.IsMatch(tbWaiting.Text.Trim()) && regex.IsMatch(txtAGVPicW.Text) && regex.IsMatch(txtAGVPicH.Text))
                {

                    Configuration cfa = ConfigurationManager.OpenExeConfiguration(ConfigurationUserLevel.None);
                    cfa.AppSettings.Settings["AGVNUM_MAX"].Value = tbAGVnum.Text.Trim();
                    cfa.AppSettings.Settings["MapScale"].Value = tbMapScale.Text.Trim();
                    if (!cfa.AppSettings.Settings.AllKeys.Contains(GlobalPara.strAgvIconW))
                    {
                        cfa.AppSettings.Settings.Add(GlobalPara.strAgvIconW, txtAGVPicW.Text);
                    }
                    if (!cfa.AppSettings.Settings.AllKeys.Contains(GlobalPara.strAgvIconH))
                    {
                        cfa.AppSettings.Settings.Add(GlobalPara.strAgvIconH, txtAGVPicH.Text);
                    }
                    if (!cfa.AppSettings.Settings.AllKeys.Contains(GlobalPara.strSavePic))
                    {
                        cfa.AppSettings.Settings.Add(GlobalPara.strSavePic, checkBox_SavePic.IsChecked.ToString());
                    }
                    if (!cfa.AppSettings.Settings.AllKeys.Contains(GlobalPara.strAreaName))
                    {
                        cfa.AppSettings.Settings.Add(GlobalPara.strAreaName, txtAreaName.Text);
                    }
                    cfa.AppSettings.Settings[GlobalPara.strAgvIconW].Value = txtAGVPicW.Text;
                    cfa.AppSettings.Settings[GlobalPara.strAgvIconH].Value = txtAGVPicH.Text;
                    cfa.AppSettings.Settings[GlobalPara.strSavePic].Value = checkBox_SavePic.IsChecked.ToString();
                    cfa.AppSettings.Settings[GlobalPara.strAreaName].Value = txtAreaName.Text;
                    //cfa.AppSettings.Settings["TRAFFIC_CONAREA_MAX"].Value = tbTraffic.Text.Trim();
                    //cfa.AppSettings.Settings["TRAFFIC_CONAREA_MARKNUM_MAX"].Value = tbMark.Text.Trim();
                    cfa.AppSettings.Settings["TRAFFIC_CONAREA_WAITAGVNUM_MAX"].Value = tbWaiting.Text.Trim();
                    cfa.Save(ConfigurationSaveMode.Modified);
                    MessageBox.Show("޸ĳɹЧ");
                    return;
                }
                else
                {
                    MessageBox.Show("֣");
                    return;
                }
            }
            catch (System.Exception ex)
            {
                MessageBox.Show("޸ʧܣ");
                return;
            }
        }
        #endregion

        #region ˳ϵͳ
        /// <summary>
        /// ˳ϵͳ
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnExit_Click(object sender, RoutedEventArgs e)
        {
            this.Close();
        }
        #endregion
    }
}
