﻿
using AGV_WPF;
using AGV_WPF.DLL;
using AGV_WPF.Model;
using AGV_WPF.Models;
using AGV_WPF.Tools;
using AGV_WPF_Global;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Web.Http;
using System.Web.Http.Results;
using WCS.API.Model;


namespace WCS.API.Controller
{
    public class agvController : ApiController
    {
        private String returnMag;
        DataTable table = new DataTable();
        List<int> list = new List<int> { 101, 102, 103, 104, 105 };
        PLCSqlDLL PLCSql = new PLCSqlDLL();
        private static object portLock = new object();

        [HttpGet]
        public string helloworld()
        {

            return "helloworld!";
        }


        [HttpPost]
        public JsonResult<DataResponse> GetStationInfo([FromBody] StationInfo info)
        {

            String Station = info.StationName;

            AGVInfo AgvInfo = GetStationInfo(Station);

            DataResponse dataResponse;

            AgvInfo.stationName = Station;

            AgvInfo.Time = DateTime.Now;

            if (!string.IsNullOrEmpty(AgvInfo.HolderBarCode))
            {
                dataResponse = new DataResponse()
                {
                    Success = true,
                    Msg = "获取AGV信息成功！",
                    //  Response = $"当前站AGV信息：工站名={info.StationName}, AGVID = {AgvInfo.AgvCode}，ProductCode = {AgvInfo.ProductCode}，HolderBarCode = {AgvInfo.HolderBarCode}，返回时间 = {DateTime.Now.ToString()}",//，产品个数 = {products.Count}
                    AGVInfos = AgvInfo
                };
            }
            else
            {
                dataResponse = new DataResponse()
                {
                    Success = false,
                    Msg = "获取AGV信息失败",
                    //  Response = $"当前站AGV信息：工站名={info.StationName}, AGVID = {AgvInfo.AgvCode}，ProductCode = {AgvInfo.ProductCode}，HolderBarCode = {AgvInfo.HolderBarCode}，返回时间 = {DateTime.Now.ToString()}",//，产品个数 = {products.Count}
                    AGVInfos = AgvInfo
                };

            }


            return Json(dataResponse);
        }

        [HttpPost]
        public JsonResult<DataResponseSPS2> AgvRelease([FromBody] ReleaseInfo3 info)
        {

            DispatchSystem7515.AddLog("中控收到放行工位信号,boxParts:" + info.boxParts + ",trigger:"+info.trigger, "放行交互日志");
            DataResponseSPS2 dataResponse = DispatchSystem7515.ReleaseAGV(info);
            DispatchSystem7515.AddLog("回复放行工位信号,  boxParts: " + info.boxParts + ", trigger: "+info.trigger + " 完成，中控返回具体信息：" + JsonConvert.SerializeObject(dataResponse), "放行交互日志");
            return Json(dataResponse);
        }
        [HttpPost]
        public async Task<JsonResult<JObject>> CASUNTrafficCombine([FromBody] JObject info)
        {
            DispatchSystem7515.AddLog("中控收到数据:" + info.ToString(), "联合管制");

            var dataResponse = new JObject();
            if (!GlobalPara.ISsCombineTrafficMain)
            {
                dataResponse["Code"] = 100;
                dataResponse["Success"] = false;
                dataResponse["Msg"] = "请求的主机无效";
            }
            else
            {
                dataResponse = DispatchSystem7515.TrafficCombine(info);
            }
            DispatchSystem7515.AddLog("中控回复数据:" + dataResponse.ToString(), "联合管制");
            await Task.CompletedTask;
            return Json(dataResponse);
        }

        [HttpPost]
        public async Task<JsonResult<JObject>> LockControllerArea([FromBody] JObject info)
        {
            DispatchSystem7515.AddLog("中控收到数据:" + info.ToString(), "联合管制");

            var dataResponse = new JObject();
            if (!GlobalPara.ISsCombineTrafficMain)
            {
                dataResponse["Status"] = "NG";
                dataResponse["Message"] = "请求的主机无效";
            }
            else
            {
                dataResponse = DispatchSystem7515.TrafficCombineLock(info);
            }
            DispatchSystem7515.AddLog("中控回复数据:" + dataResponse.ToString(), "联合管制");
            await Task.CompletedTask;
            return Json(dataResponse);
        }

        [HttpPost]
        public async Task<JsonResult<JObject>> UnlockockControllerArea([FromBody] JObject info)
        {
            DispatchSystem7515.AddLog("中控收到数据:" + info.ToString(), "联合管制");

            var dataResponse = new JObject();
            if (!GlobalPara.ISsCombineTrafficMain)
            {
                dataResponse["Status"] = "NG";
                dataResponse["Message"] = "请求的主机无效";
            }
            else
            {
                dataResponse = DispatchSystem7515.TrafficCombineUnLock(info);
            }
            DispatchSystem7515.AddLog("中控回复数据:" + dataResponse.ToString(), "联合管制");
            await Task.CompletedTask;
            return Json(dataResponse);
        }

        [HttpPost]
        public async Task<JsonResult<JObject>> CASUNTrafficCombineState([FromBody] JObject info)
        {
            //DispatchSystem7515.AddLog("中控收到数据:" + info.ToString(), "联合管制");

            var dataResponse = new JObject();
            if (!GlobalPara.ISsCombineTrafficMain)
            {
                dataResponse["RequestID"] = "0";
                dataResponse["TrafficAGV"] = "UnKown";
                dataResponse["TrafficID"] = info["TrafficID"].ToString();
                dataResponse["RequestTime"] = DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss");
                dataResponse["Msg"] = "请求的主机无效";
            }
            else
            {
                dataResponse = DispatchSystem7515.TrafficCombineState(info);
            }
            //DispatchSystem7515.AddLog("中控回复数据:" + dataResponse.ToString(), "联合管制");
            await Task.CompletedTask;
            return Json(dataResponse);
        }
        /// <summary>
        /// 放行AGV
        /// </summary>

        public JsonResult<DataResponse> ReleaseAGV0([FromBody] ReleaseInfo info)
        {
            int Type = int.Parse(info.ReleaseType);
            string Station = info.Station;
            int AgvCode = info.AgvCode;
            bool flag = false;
            String Message = "";

            flag = ReleaseCar(AgvCode, Station, Type);

            if (flag)
            {
                Message = "MES ReleaseAGV Success!";
            }
            else
            {
                Message = "MES ReleaseAGV Fail! Try Again!";
            }

            AGVInfo Agvinfo = new AGVInfo();

            Agvinfo.stationName = info.Station;
            PLCSql.PLCMESSelect(info.AgvCode.ToString(), "2", ref Agvinfo);


            DataResponse dataResponse = new DataResponse()
            {
                Success = flag,
                Msg = Message,
                Response = "",
                AGVInfos = Agvinfo
            };

            return Json(dataResponse);
        }

        public JsonResult<DataResponse> MESReleaseAGV([FromBody] ReleaseInfo info)
        {
            int Type = int.Parse(info.ReleaseType);

            string Station = info.Station;
            int AgvCode = info.AgvCode;
            bool flag = false;
            String Message = "";

            flag = ReleaseCar(AgvCode, Station, Type);


            if (flag)
            {
                Message = "MES ReleaseAGV Success!";
            }
            else
            {
                Message = "MES ReleaseAGV Fail! Try Again!";
            }

            DataResponse dataResponse = new DataResponse()
            {
                Success = flag,
                Msg = Message,
                Response = ""
            };

            return Json(dataResponse);
        }

        /// <summary>
        /// 重新绑定
        /// </summary>
        [HttpPost]
        public JsonResult<DataResponse> MesBind([FromBody] AGVInfo info)
        {
            String Massage = "";
            string AGVID = info.AgvCode.ToString();
            string ProductCode = info.ProductCode;
            string HolderBarCode = info.HolderBarCode;
            string ProductType = info.ProductType;
            int Behavior = info.Behavior;
            string Responses = "";
            bool flag = false;

            switch (Behavior)
            {
                case 1:
                    if (PLCSql.PLCSqlMES(AGVID, ProductCode, HolderBarCode, ProductType, "1")) //插入数据或更新
                    {
                        WriteFile("绑定SN记录", "AGVID+" + AGVID + "SN1DB+" + ProductCode + ": SN2DB+" + HolderBarCode + ": SN3DB+" + ProductType + DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss"));
                        Massage = "AGVID:" + AGVID + "  绑码成功！";
                        // Responses = $"绑码信息为 ： AGVID = {info.AgvCode}，ProductCode = {info.ProductCode}，HolderBarCode = {info.HolderBarCode}，绑码时间 = {DateTime.Now.ToString()}";

                        flag = true;
                    }
                    else
                    {
                        Massage = "AGVID:" + AGVID + "  绑码失败！请重试！";
                    }


                    break;

                case 2:
                    if (PLCSql.PLCSqlMES(AGVID, ProductCode, HolderBarCode, ProductType, "3"))
                    {
                        WriteFile("解绑SN记录", "AGVID+" + AGVID + "SN1DB+" + ProductCode + ": SN2DB+" + HolderBarCode + ": SN3DB+" + ProductType + DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss"));
                        Massage = "AGVID:" + AGVID + "  解码成功！";
                        Responses = $"解绑信息为 ： AGVID = {info.AgvCode}，ProductCode = {info.ProductCode}，HolderBarCode = {info.HolderBarCode}，绑码时间 = {DateTime.Now.ToString()}";
                        flag = true;
                    }
                    else
                    {
                        Massage = "AGVID:" + AGVID + "  解绑失败！请重试！";
                    }

                    break;

            }

            DataResponse dataResponse = new DataResponse()
            {
                Success = flag,
                Msg = Massage,
                Response = Responses,
                AGVInfos = info
            };

            return Json(dataResponse);

        }


        private JsonResult<DataResponse> Json()
        {
            throw new NotImplementedException();
        }

        private JsonResult<AGVInfo> Json1()
        {
            throw new NotImplementedException();
        }


        public AGVInfo GetStationInfo(string statiom)
        {
            string mark = "";
            AGVInfo Agvinfo = new AGVInfo();
            foreach (DataRow dr in GlobalPara.dtSKQPLCs.Rows)
            {
                if (dr["工位名称"].ToString() == statiom)
                {
                    mark = dr["工位地标"].ToString();
                    break;
                }
            }

            try
            {
                //  while (AGVPosW)
                {
                    List<AGVInfoModel> listModel = GlobalPara.AgvInfoDic.Values.ToList();
                    List<AGVInfoModel> results = listModel.FindAll(o => o.MARKNUM.ToString() == mark && o.ConnectStatus == true); //停止点有车
                    if (results != null && results.Count > 0)
                    {
                        foreach (AGVInfoModel info in results)
                        {
                            if (info != null)
                            {
                                PLCSql.PLCMESSelect(info.AGVNUM.ToString(), "2", ref Agvinfo);
                            }
                        }
                    }
                    Thread.Sleep(500);
                }   //AGVpos为false代表未叫车 才进循环
            }
            catch (Exception ex)
            {

            }

            return Agvinfo;

        }



        public bool ReleaseCar(int AgvCode, string mark, int type)
        {
            Boolean flag = false;
            string station = "";
            string Type = "";
            try
            {

                //  while (AGVPosW)
                {
                    List<AGVInfoModel> listModel = GlobalPara.AgvInfoDic.Values.ToList();
                    List<AGVInfoModel> results = listModel.FindAll(o => o.AGVNUM == AgvCode && o.ConnectStatus == true); //停止点有车
                    if (results != null && results.Count > 0)
                    {
                        foreach (AGVInfoModel info in results)
                        {
                            if (info != null)
                            {
                                foreach (DataRow dr in GlobalPara.dtSKQPLCs.Rows)
                                {
                                    if (dr["工位地标"].ToString() == info.MARKNUM.ToString())
                                    {
                                        station = dr["工位名称"].ToString();
                                        break;
                                    }
                                }

                                switch (type)
                                {
                                    case 1:

                                        MainWindow.ReadingStopPoint(info.MARKNUM, info.ROUTENUM);
                                        if (info.MARKNUM == 63)
                                        {
                                            MainWindow.ReadingStopPoint(36, info.ROUTENUM);
                                        }
                                        info.AllowMesReleaseFlag = true;
                                        flag = true;
                                        Type = "1 点亮放行盒";
                                        break;

                                    case 2:
                                        DispatcherTool.ControlAGVBy1071(info.AGVNUM, 1); //急停
                                        flag = true;
                                        Type = "2 小车急停";
                                        break;
                                    case 3:

                                        DispatcherTool.ControlAGVBy1071(info.AGVNUM, 0); //解除急停放行
                                        Type = "3 释放急停";
                                        flag = true;
                                        break;
                                    case 4:

                                        DispatcherTool.ReleaseAgvOnStop(info.MARKNUM, 0,0,15); //放行
                                        var temp =  GlobalPara.ListReleaseObj.Find(o => o.AGVNUM == info.AGVNUM&&info.ConnectStatus);
                                        if (temp == null)
                                        {
                                            GlobalPara.ListReleaseObj.Add(info);
                                        }
                                        Type = "4 强制放行";
                                        flag = true;
                                        break;

                                }
                                WriteFile("MES放行小车记录" + DateTime.Now.ToString("yyyy-MM-dd"), "工站"+ station+" 放行AGVID为+" + AgvCode + "，Type为：+" + Type + " 放行地标Mark:+" + info.MARKNUM.ToString() + " AGV AllowReleaseFlag为:" + info.AllowMesReleaseFlag + DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss"));
                                //info.AllowReleaseFlag = true;

                            }

                        }
                    }

                }
                Thread.Sleep(500);
            }   //AGVpos为false代表未叫车 才进循环

            catch (Exception ex)
            {

            }

            return flag;

        }


        void WriteFile(string fileName, string context)
        {
            try
            {
                lock (portLock)
                {
                    DateTime time = DateTime.Now;
                    //MessageBox.Show("线程异常:"+e.ExceptionObject);
                    FileStream stream = File.Open(@"Exception\" + fileName + ".txt", FileMode.Append, FileAccess.Write);
                    StreamWriter writer = new StreamWriter(stream);


                    {
                        string msg = string.Format("[{0}]Test:\r\nMessage:{1}\r\n", time.ToString("yyyy-MM-dd HH:mm:ss"), context);
                        writer.WriteLine(msg);
                        writer.Close();
                        stream.Close();
                    }
                }
            }
            catch (Exception)
            {
            }
        }


    }



}

