﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Text.RegularExpressions;
using AGV_WPF_Global;
using System.Configuration;

namespace AGV_WPF.ExtraUI
{
    /// <summary>
    /// ManagerWindow.xaml 的交互逻辑
    /// </summary>
    public partial class ManagerWindow : Window
    {
        public ManagerWindow()
        {
            InitializeComponent();
            this.WindowStartupLocation = WindowStartupLocation.CenterScreen;
        }

        private void btnSave_Click(object sender, RoutedEventArgs e)
        {
            Configuration config = ConfigurationManager.OpenExeConfiguration(ConfigurationUserLevel.None);
            string numStr = @"^\d+$";
            string ipStr = @"^(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])\.(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])\.(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])\.(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])$";
            if (!Regex.IsMatch(txtComTimes.Text, numStr) || !Regex.IsMatch(txtComCycle.Text, numStr) || !Regex.IsMatch(txtDebugIP.Text, ipStr) || string.IsNullOrEmpty(comBoxDataHandle.Text))
            {
                MessageBox.Show("输入错误");
                return;
            }
            else
            {
                GlobalPara.OffLineCount = int.Parse(txtComTimes.Text);
                GlobalPara.ComCycle = int.Parse(txtComCycle.Text);
                GlobalPara.DataHandleType = comBoxDataHandle.Text == "老式" ? 0 : 1;
                GlobalPara.DebugFlag = (bool)chBoxDebug.IsChecked;
                GlobalPara.DebugIP = txtDebugIP.Text;
                config.AppSettings.Settings[GlobalPara.strOffLineCount].Value = GlobalPara.OffLineCount.ToString();
                config.AppSettings.Settings[GlobalPara.strComCycle].Value = GlobalPara.ComCycle.ToString();
                config.AppSettings.Settings[GlobalPara.strDataHandleType].Value = GlobalPara.DataHandleType.ToString();
                config.AppSettings.Settings[GlobalPara.strDebugFlag].Value = GlobalPara.DebugFlag.ToString();
                config.AppSettings.Settings[GlobalPara.strDebugIP].Value = GlobalPara.DebugIP;
                config.Save();
                MessageBox.Show("保存成功");
                this.Close();

            }
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            txtComCycle.Text = GlobalPara.ComCycle.ToString();
            txtComTimes.Text = GlobalPara.OffLineCount.ToString();
            chBoxDebug.IsChecked = GlobalPara.DebugFlag;
            txtDebugIP.Text = GlobalPara.DebugIP;
            comBoxDataHandle.Text = GlobalPara.DataHandleType == 0 ? "老式" : "新式";
        }
    }
}
