using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace WCS.API.Helper
{
    public class MsgDisplayHelper
    {
        private static MsgDisplayHelper instance;
        private static object locker = new object();

        public event Action<string, EventArgs> DisplayMessageEvent;

        private MsgDisplayHelper()
        {

        }

        public static MsgDisplayHelper Instance
        {
            get
            {
                if(instance == null)
                {
                    lock(locker)
                    {
                        if(instance==null)
                        {
                            instance = new MsgDisplayHelper();
                        }
                    }
                }
                return instance;
            }
        }

        public void HandleMsg(string msg)
        {
            DisplayMessageEvent?.Invoke(msg, EventArgs.Empty);  //Ϊnullʱע
        }

        public void DisplayError(string err)
        {
            string msg = "======================================================== error ========================================================\r\n"
                + err + "\r\n";
            HandleMsg(msg);
        }
    }
}
