﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Configuration;
using System.Windows.Navigation;
using DAL;
using System.Data.SqlClient;
using AGV_WPF;
using AGV_WPF_Global;
using Casun_SoftKey;
using NS_SoftKey_Win;
using System.Runtime.InteropServices;
using System.Windows.Interop;
using System.Threading;


namespace AGV_WPF
{
    /// <summary>
    /// Login.xaml 的交互逻辑
    /// </summary>
   
    public partial class Login : Window
    {

        #region 类变量
        /// <summary>
        /// softkey
        /// </summary>
        SoftKey ytsoftkey;
        public bool IsExist = false;
        public static string KeyPath;
        #endregion

        #region 构造函数
        public Login()
        {
            InitializeComponent();
            this.UserNametextBox.Text = Properties.Settings.Default.UserName;
            this.passwordBox.Focus();
        }
        #endregion

        #region 退出系统
        private void Exitbutton_Click(object sender, RoutedEventArgs e)
        {
            Application.Current.Shutdown();
        }
        #endregion

        #region 设置快捷键
        private void Window_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.Key == Key.Enter)
            {
                this.Loginbutton_Click(sender, null);
            }
            if (e.Key == Key.Escape)
            {
                Application.Current.Shutdown();
            }
        }
        #endregion

        #region 登录系统
        private void Loginbutton_Click(object sender, RoutedEventArgs e)
        {
            string UserName = this.UserNametextBox.Text.ToLower().Trim();
            string PassWord = this.passwordBox.Password.ToLower().Trim();
            //string UserName = "admin";
            //string PassWord = "admin";
            DAL.ZSql sql =new DAL.ZSql();
            int i = sql.Open("select * from T_UserInfo where UserName=@username and Pwd=@password",new SqlParameter[]{new SqlParameter("username",UserName),new SqlParameter("password",PassWord)});
            if (i < 0)
            {
                sql.Close();
                return;
            }
            if (sql.Rows.Count>0)
            {
                if (sql.Rows[0]["IsManager"].ToString()=="True")
                {
                    GlobalPara.IsManager = true;
                } 
                else
                {
                    GlobalPara.IsManager = false;
                }
                GlobalPara.strName = UserName;
                GlobalPara.userid = sql.Rows[0]["ID"].ToString();
                sql.Close();
                MainWindow mn = new MainWindow();
                mn.Show();        
                this.Close();
            }
            else
            {
                MessageBox.Show("用户名或密码错误，请检查", "警告");
                this.UserNametextBox.Clear();
                this.passwordBox.Clear();
                this.UserNametextBox.Focus();
            }
            sql.Close();
        }
        #endregion

        #region 加密狗设置
        void RegisterDeviceNotification()
        {
            Win32.DEV_BROADCAST_DEVICEINTERFACE dbi = new
                Win32.DEV_BROADCAST_DEVICEINTERFACE();
            int size = Marshal.SizeOf(dbi);
            dbi.dbcc_size = size;
            dbi.dbcc_devicetype = Win32.DBT_DEVTYP_DEVICEINTERFACE;
            dbi.dbcc_reserved = 0;
            dbi.dbcc_classguid = Win32.GUID_DEVINTERFACE_USB_DEVICE;
            dbi.dbcc_name = 0;
            IntPtr buffer = Marshal.AllocHGlobal(size);
            Marshal.StructureToPtr(dbi, buffer, true);
            WindowInteropHelper helper = new WindowInteropHelper(this);
            IntPtr ptr = helper.Handle;
            IntPtr r = Win32.RegisterDeviceNotification(ptr, buffer,
                Win32.DEVICE_NOTIFY_WINDOW_HANDLE);
            if (r == IntPtr.Zero)
                MessageBox.Show(Win32.GetLastError().ToString());
        }

        void win_SourceInitialized(object sender, EventArgs e)
        {
            HwndSource hwndSource = PresentationSource.FromVisual(this) as HwndSource;
            if (hwndSource != null)
            {
                hwndSource.AddHook(new HwndSourceHook(WndProc));
            }
        }

        protected override void OnSourceInitialized(EventArgs e)
        {
            base.OnSourceInitialized(e);
            this.win_SourceInitialized(this, e);
        }

        protected virtual IntPtr WndProc(IntPtr hwnd, int msg, IntPtr wParam, IntPtr lParam, ref bool handled)
        {
            switch (msg)
            {
                case Win32.WM_DEVICECHANGE:
                    OnDeviceChange(msg);
                    break;
            }
            return IntPtr.Zero;
        }

        void OnDeviceChange(int msg)
        {
            int wParam = 32772;
            int lParam = 170714116;
            if ((int)wParam == Win32.DBT_DEVICEARRIVAL)
            {
                int devType = Marshal.ReadInt32((int)lParam, 4);
                if (devType == Win32.DBT_DEVTYP_DEVICEINTERFACE)
                {
                    Win32.DEV_BROADCAST_DEVICEINTERFACE1 DeviceInfo = (Win32.DEV_BROADCAST_DEVICEINTERFACE1)Marshal.PtrToStructure((IntPtr)lParam, typeof(Win32.DEV_BROADCAST_DEVICEINTERFACE1));
                }
            }
            if ((int)wParam == Win32.DBT_DEVICEREMOVECOMPLETE && IsExist)//收到硬件拨出信息后，调用检查锁函数来检查是否锁被拨出
            {
                Win32.DEV_BROADCAST_DEVICEINTERFACE1 DeviceInfo = (Win32.DEV_BROADCAST_DEVICEINTERFACE1)Marshal.PtrToStructure((IntPtr)lParam, typeof(Win32.DEV_BROADCAST_DEVICEINTERFACE1));
                // 这里使用 CheckKeyByFindort_2检查加密锁是否被拨出，也可以使用其它检查锁函数来检查加密锁是否被拨出
                if (ytsoftkey.CheckKeyByFindort_2() != 0)
                {
                    IsExist = false;
                    MessageBox.Show("加密锁被拨出。");
                    Application.Current.Shutdown();
                }
            }
        }

        /// <summary>
        /// 使用增强算法二来检查是否存在指定的加密锁
        /// </summary>
        /// <returns>
        /// returns value: 3-1:未找到插入的加密锁 0：找到指定的加密锁 -1-2:未找到指定的加密锁 2-3:当前锁不支持这个功能 4:生成加密代码时没有设置该函数
        /// 5：未通过通算法一 6:增强算法一 7-读写储存器来检查 8:普通算法二 9:增强算法二
        /// 5-9:生成加密代码时没有设置该函数
        /// </returns>
        private int CheckSoftKey()
        {
            //初始化我们的操作加密锁的类
            if (ytsoftkey == null)
            {
                ytsoftkey = new SoftKey();
            }
            //这个用于判断系统中是否存在着加密锁。不需要是指定的加密锁,
            if (ytsoftkey.FindPort(0, ref KeyPath) != 0)
            {
                return 1;
            }
            IsExist = true;
            RegisterDeviceNotification();//注册加密锁事件插拨通知
            //使用增强算法一来检查是否存在指定的加密锁
            int ret;
            ret = ytsoftkey.CheckKeyByEncstring();
            if (ret == 1)
            {
                return 64;
            }
            if (ret != 0)
            {
                return 62;
            }
            //使用读写储存器来检查是否存在指定的加密锁
            ret = ytsoftkey.CheckKeyByReadEprom();
            if (ret == 1)
            {
                return 74;
            }
            if (ret != 0)
            {
                return 72;
            }

            //使用增强算法二来检查是否存在指定的加密锁
            ret = ytsoftkey.CheckKeyByEncstring_New();
            if (ret != 0)
            {
                if (ret < 0)
                {
                    return 92;
                }
                else
                {
                    if (ret == 2)
                    {
                        return 93;
                    }
                }
            }
            return 0;
        }

        #endregion

        #region 窗体加载与退出
        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            //if (CheckSoftKey() != 0)
            //{
            //    MessageBox.Show("未能找到指定的加密锁", "错误", MessageBoxButton.OK, MessageBoxImage.Error);
            //    Application.Current.Shutdown();
            //    return;
            //}
            //this.passwordBox.Password = "admin";
            //this.Loginbutton_Click(sender, e);
        }

        private void Window_Closing(object sender, System.ComponentModel.CancelEventArgs e)
        {
            Properties.Settings.Default.UserName = this.UserNametextBox.Text.ToLower().Trim();
            Properties.Settings.Default.Save();//使用Save方法保存更改
        }
        #endregion

    }
}

