﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Configuration;
using System.Data.SqlClient;
using System.Threading;
using AGV_WPF.NewCotent;
using AGV_WPF_Global;

namespace UseRate
{
    public class AgvStatusTimeSpan
    {
        public AgvStatusTimeSpan()
        {
            CreateTable(tableName);
            StartTime = DateTime.Now;
        }
        private int agvNum;

        public int AgvNum
        {
            get { return agvNum; }
            set
            {
                if (agvNum != value)
                {
                    agvNum = value;
                }
            }
        }
        
        private DateTime startTime;

        public DateTime StartTime
        {
            get { return startTime; }
            set
            {
                if (startTime != value)
                {
                    startTime = value;
                }
            }
        }
        private DateTime endTime;

        public DateTime EndTime
        {
            get { return endTime; }
            set
            {
                if (endTime != value)
                {
                    endTime = value;
                }
            }
        }
        private int statusType;

        public int StatusType
        {
            get { return statusType; }
            set
            {
                if (statusType != value)
                {
                    DateTime time = DateTime.Now;
                    //状态变化，开始计时
                    if (StartTime != null)
                    {
                        //ErrorLog.WriteErrorLog(GlobalPara.areaName, this.agvNum, statusType, StartTime, time);//群创用异常日志
                        if (time > startTime)
                        {
                        }
                        //  Update(this.agvNum, this.startTime, time, (int)(time.Subtract(startTime).TotalSeconds),statusType);
                        else
                        {
                        }
                       //     Update(this.agvNum, this.startTime, time, 0, statusType);                        
                        StartTime = time;

                      //  Insert(this.agvNum, time, 0, value);

                    }
                    else//没有开始时间
                    {
                        StartTime = time;
                    //    Insert(this.agvNum, time, 0, statusType);
                    }
                    statusType = value;
                }
            }
        }
        
        static string tableName = "T_UseRate";
        static Mutex m_Mutex = new Mutex();
        /// <summary>
        /// 创建表
        /// </summary>
        /// <param name="table"></param>
        public void CreateTable(string table)
        {
            try
            {
                string strCon = ConfigurationManager.AppSettings["ConnString"];
                using (SqlConnection con = new SqlConnection(strCon))
                {
                    con.Open();
                    
                    string sql = string.Format("select count(1) from sysobjects where xtype='U' and name='{0}'", tableName);
                    using (SqlCommand com = new SqlCommand(sql, con))
                    {
                        object o = com.ExecuteScalar();
                        if (int.Parse(o.ToString()) <= 0)//不存在则创建
                        {
                            sql = string.Format("create table {0}(AgvNum int not null,StartTime varchar(20) not null,EndTime varchar(20),Type int not null,Seconds int not null)", tableName);
                            com.CommandText = sql;
                            com.ExecuteNonQuery();
                        }
                        
                    }

                }
            }
            catch (System.Exception ex)
            {
                Console.WriteLine("Message:{0}\r\nStackTrace:{1}", ex.Message, ex.StackTrace);
            }
        }
        /// <summary>
        /// 更新表
        /// </summary>
        /// <param name="agvNum"></param>
        /// <param name="start"></param>
        /// <param name="end"></param>
        /// <param name="seconds"></param>
        /// <param name="type"></param>
        public void Update(int agvNum, DateTime start, DateTime end, int seconds, int type)
        {
            try
            {
                m_Mutex.WaitOne();
                string strCon = ConfigurationManager.AppSettings["ConnString"];
                using (SqlConnection con = new SqlConnection(strCon))
                {
                    con.Open();
                    string sql = string.Format("update {0} set EndTime='{1}',Seconds={2} where AgvNum={3} and StartTime='{4}' and Type={5}", tableName, end.ToString("yyyy-MM-dd HH:mm:ss"), seconds, agvNum, start.ToString("yyyy-MM-dd HH:mm:ss"), type);
                    using (SqlCommand com = new SqlCommand(sql, con))
                    {
                        com.ExecuteNonQuery();
                    }
                    
                }
            }
            catch (System.Exception ex)
            {
                Console.WriteLine("Message:{0}\r\nStackTrace:{1}", ex.Message, ex.StackTrace);
            }
            finally
            {
                m_Mutex.ReleaseMutex();
            }
        }
        /// <summary>
        /// 插入表
        /// </summary>
        /// <param name="agvNum"></param>
        /// <param name="start"></param>
        /// <param name="seconds"></param>
        /// <param name="type"></param>
        public void Insert(int agvNum, DateTime start, int seconds, int type)
        {
            try
            {
                m_Mutex.WaitOne();
                string strCon = ConfigurationManager.AppSettings["ConnString"];
                using (SqlConnection con = new SqlConnection(strCon))
                {
                    con.Open();
                    string sql = string.Format("select count(1) from {0} where AgvNum={1} and StartTime='{2}' and Type={3}",tableName,agvNum,start.ToString("yyyy-MM-dd HH:mm:ss"),type);
                    using (SqlCommand com = new SqlCommand(sql, con))
                    {
                        object o = com.ExecuteScalar();
                        if (int.Parse(o.ToString()) > 0)//存在更新
                        {
                            sql = string.Format("update {0} set AgvNum={1},StartTime='{2}',Seconds={3} where AgvNum={4} and StartTime='{5}' and Type={6}", tableName, agvNum, start.ToString("yyyy-MM-dd HH:mm:ss"), seconds, agvNum, start.ToString("yyyy-MM-dd HH:mm:ss"), type);
                            com.CommandText = sql;
                            com.ExecuteNonQuery();
                        }
                        else//否则插入
                        {
                            sql = string.Format("insert into {0}(AgvNum,StartTime,Seconds,Type) values({1},'{2}',{3},{4})", tableName, agvNum, start.ToString("yyyy-MM-dd HH:mm:ss"), seconds, type);
                            com.CommandText = sql;
                            com.ExecuteNonQuery();
                        }
                    }

                }
            }
            catch (System.Exception ex)
            {
                Console.WriteLine("Message:{0}\r\nStackTrace:{1}", ex.Message, ex.StackTrace);
            }
            finally
            {
                m_Mutex.ReleaseMutex();
            }

        }
        /// <summary>
        /// 清空表
        /// </summary>
        public static void ClearNull()
        {
            try
            {
                m_Mutex.WaitOne();
                string strCon = ConfigurationManager.AppSettings["ConnString"];
                using (SqlConnection con = new SqlConnection(strCon))
                {
                    con.Open();
                    string sql = string.Format("delete from {0} where EndTime is null",tableName);
                    using (SqlCommand com = new SqlCommand(sql, con))
                    {
                        com.ExecuteNonQuery();
                    }

                }
            }
            catch (System.Exception ex)
            {
                Console.WriteLine("Message:{0}\r\nStackTrace:{1}", ex.Message, ex.StackTrace);
            }
            finally
            {
                m_Mutex.ReleaseMutex();
            }
        }
        public void Close()
        {
            DateTime time = DateTime.Now;
            if (time > startTime)
                Update(this.agvNum, startTime, time, (int)(time.Subtract(startTime).TotalSeconds), this.StatusType);
        }
    }
    
}
