﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Tools
{
    public class DataControl
    {
        public DataControl()
        {
            receiveBuffer = new List<byte>(maxBufferSize);
            lockObject = new object();
        }
        static CBlackBoxFile m_boxFile = new CBlackBoxFile();
        private object lockObject;// 缓冲数据操作锁
        
        private int maxBufferSize;
        /// <summary>
        /// 最大缓冲区大小（可设置其大小）
        /// </summary>
        public int MaxBufferSize
        {
            get { return maxBufferSize; }
            set
            {
                if (maxBufferSize != value)
                {
                    maxBufferSize = value;
                }
            }
        }
        private List<byte> receiveBuffer;
        /// <summary>
        /// 缓冲区数据
        /// </summary>
        public List<byte> ReceiveBuffer
        {
            get { return receiveBuffer; }
            set
            {
                if (receiveBuffer != value)
                {
                    receiveBuffer = value;
                }
            }
        }
        byte headByte = 0x10;//头码
        //byte endByte = 0x03;//尾码
        /// <summary>
        /// 数据处理函数（解析数据用）
        /// </summary>
        /// <returns>协议类型</returns>
        public int DataHandler(out byte[] data)
        {
            int type = -1;

            if (receiveBuffer != null && receiveBuffer.Count > 0)
            {
                while (receiveBuffer.Count >= 10)
                {
                    if (receiveBuffer[0] == headByte && receiveBuffer.Count>=16)
                    {
                        
                    }
                    else
                    {
                        ArrangeBuffer(receiveBuffer, headByte);
                    }
                }
            }
            data = new byte[1] { 0 };
            return type;
        }
        public static string Byte2HexString(byte[] buffer)
        {
            StringBuilder builder = new StringBuilder(buffer.Length * 3);
            foreach (byte data in buffer)
            {
                builder.Append(Convert.ToString(data, 16).PadLeft(2, '0').PadRight(3, ' '));

            }
            return builder.ToString().ToUpper();
        }
        public static byte XOR_Check(byte[] buffer, int count, int index = 0)
        {
            byte b = 0;
            for (int i = 0; i < count; i++)
            {
                b ^= buffer[index + i];
            }
            return b;
        }
        public void ArrangeBuffer(List<byte> buffer, byte targeByte)
        {
            int index = buffer.FindIndex(c => c == targeByte);
            lock(lockObject)
            {
                if (index == -1)
                {
                    lock (lockObject)
                    {
                        buffer.Clear();//不存在目标字节则清空之前数据
                    }
                    
                }
                else if(index > 0)
                {
                    lock (lockObject)
                    {
                        buffer.RemoveRange(0, index - 1);
                    }
                }

            }
        }

        public void AddBuffer(byte[] buffer, int length)
        {
            lock (lockObject)
            {
                for (int i = 0; i < length;i++ )
                {
                    receiveBuffer.Add(buffer[i]);
                }
            }
        }
        public void RemoveBuffer(int startIndex, int count)
        {
            lock (lockObject)
            {
                receiveBuffer.RemoveRange(startIndex, count);
            }
        }
        public void RemoveAt(int index)
        {
            lock (lockObject)
            {
                receiveBuffer.RemoveAt(index);
            }
        }
    }
}
