﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;

namespace AgvAlarmServiceLibrary
{
    [ServiceBehavior(InstanceContextMode=InstanceContextMode.Single)]
    public class AgvAlarmService:IAgvAlarmService
    {
        public static List<ISrvToClientCallBack> userCallBackList = new List<ISrvToClientCallBack>();
        private static object lockObject = new object();
        public string InitClient()
        {
            try
            {
                ISrvToClientCallBack userCallBack = OperationContext.Current.GetCallbackChannel<ISrvToClientCallBack>();
                lock (lockObject)
                {
                    userCallBackList.Add(userCallBack);
                }
                OperationContext.Current.Channel.Closed += new EventHandler(Channel_Closed);
                OperationContext.Current.Channel.Faulted += new EventHandler(Channel_Closed);
                return "成功";
            }
            catch (System.Exception ex)
            {
                return ex.Message;
            }

        }

        void Channel_Closed(object sender, EventArgs e)
        {
            ISrvToClientCallBack callBack = sender as ISrvToClientCallBack;
            lock (lockObject)
            {
                userCallBackList.Remove(callBack);
            }
        }
    }
}
