﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using AGV_WPF_Global;
using System.Data.OleDb;
using System.Xml.Serialization;
using System.IO;
using System.Threading.Tasks;
using AGV_WPF.Models;
using HslCommunication;
using AGV_WPF.Tools;
using System.Diagnostics;
using HslCommunication.Profinet.Siemens;
using Newtonsoft.Json.Linq;
using AGV_WPF.DLL;
using AGV_WPF.ExtraUI;
using AGV_WPF.Services;
using WCS.API;
using AGV_WPF.Model;
using WCS.API.WebApiClient;

namespace AGV_WPF
{
    public partial class DispatchSystem : Form
    {
        DataTable dtConfig = new DataTable();
        HslCommunication.OperateResult result;// HslCommunication.OperateResult result2;
        int HeartBitCount = 1; //int HeartBitCount2 = 1;
        private delegate void InvokeDelegate();
        Dictionary<int, string> checkPosDic = new Dictionary<int, string>();
        Dictionary<int, int> AGVIDWithPosByCheckPos = new Dictionary<int, int>();
        Dictionary<int, int> AGVIDWithPosByCheckPosReal = new Dictionary<int, int>();
        Dictionary<int, int> AGVIDWithRouteByCheckPos = new Dictionary<int, int>();
        Dictionary<string, byte> DBWithByteValue = new Dictionary<string, byte>();
        private static object portLock = new object();
        Stopwatch sw = new Stopwatch();
        Dictionary<string, CFDClass> dicReleaseArea = new Dictionary<string, CFDClass>();
        public int CurCFDRoute = -1;
        Dictionary<string, bool> InitOK = new Dictionary<string, bool>();
        List<int> CFDRoutes = new List<int>();
        int index = 0;
        int CFDWaitTimes = 15;
        int CFDCheckTimes = 0;
        Dictionary<string, List<string>> dicCheck = new Dictionary<string, List<string>>();
        DataTable DtTraffic = new DataTable();
        List<string> listTra = new List<string>();
        byte PLCHeartBitCount = 0;
        bool HeartBitFlag = true;
        OperateResult<byte> PLCResult;
        bool IsPLCChangeOff = false;
        DataTable LineDt = new DataTable();
        DataTable ProductTypeDt = new DataTable();

        bool DockingOK = false;
        int lastSWAGVNum = -1;
        SocketTcpServer Server;
        // SocketTcpServer Server;
        bool isChoseMat = false;
        static List<JObject> MesStations = new List<JObject>();
        List<string> afterRelease = new List<string>();
        System.Timers.Timer timer = new System.Timers.Timer(); System.Timers.Timer timer2 = new System.Timers.Timer();
        Dictionary<string, SiemensS7Net> DicPLC = new Dictionary<string, SiemensS7Net>();
        List<string> heartBitList = new List<string>(); List<string> heartBitList2 = new List<string>();
        Dictionary<SiemensS7Net, OperateResult> DicPLCResult = new Dictionary<SiemensS7Net, OperateResult>();
        List<string> BoxMarkList = new List<string>();
        DataTable dtSKQPLC = new DataTable();
        DataTable dtTestPLC = new DataTable();
        DataTable dtBigzPLC = new DataTable();

        bool PLCPackAlarm = false;
        bool PLCTestAlarm = false;
        List<string> AlarmPackStations = new List<string>();
        int AlarmNumber = 1;
        public DispatchSystem()
        {
            InitializeComponent();
        }

        private void DispatchSystem_Load(object sender, EventArgs e)
        {

            LoadConfig();
            if (!isChoseMat)
            {
                this.FormClosing += new FormClosingEventHandler(DispatchSystem_FormClosing);
                Thread thread2 = new Thread(HeartBit); thread2.IsBackground = true;
                thread2.Start();
                //  Thread thread = new Thread(Analzye); thread.IsBackground = true;
                //  thread.Start();
                timer.Enabled = true;
                timer.Interval = 200;
                timer.Elapsed += new System.Timers.ElapsedEventHandler(timer_Elapsed);
                timer.Start();
                timer2.Enabled = true;
                timer2.Interval = 2000;
                timer2.Elapsed += new System.Timers.ElapsedEventHandler(timer2_Elapsed);
                timer2.Start();
            }


            //MES通讯
            if (Server == null)
            {
                Server = new SocketTcpServer(int.Parse(dtConfig.Rows[12][1].ToString()));
                Server.ReceiveDataDeal = ExcuteSKQMES;
                Server.StartListener(1000, Int32.MaxValue);

            }

        }

        void timer2_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
        {
            //throw new NotImplementedException();
            try
            {
                if (AlarmPackStations.Count == 0) { PLCPackAlarm = false; }
                else { PLCPackAlarm = true; }
                if (PLCPackAlarm)
                {
          //          DispatcherTool.AlarmStartOrStop(3, AlarmNumber);
                }
                else if (PLCTestAlarm)
                {
         //          DispatcherTool.AlarmStartOrStop(2, AlarmNumber);
                }
                else if (!PLCTestAlarm && !PLCPackAlarm)
                {
           //         DispatcherTool.AlarmStartOrStop(1, AlarmNumber);
                }


            }
            catch (Exception) { }
        }

        void DispatchSystem_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (!isChoseMat)
            {
                e.Cancel = true;
            }
            else
            {

                DispatchSystem ds = new DispatchSystem();
                ds.Show();

            }
        }


        /// <summary>
        /// 加载配置
        /// </summary>
        public void LoadConfig()
        {
            sw.Restart();
            tabControl1.TabPages.Clear();
            物料设置ToolStripMenuItem.DropDownItems.Clear();
            checkPosDic.Clear();
            AGVIDWithPosByCheckPos.Clear();
            DBWithByteValue.Clear();
            HeartBitCount = 1;
            XmlSerializer deserializer1 = new XmlSerializer(GlobalPara.gs_configInfo.GetType());
            try
            {
                using (TextReader tr = new StreamReader("CConfig.xml"))
                {
                    GlobalPara.gs_configInfo = (AGV_WPF.Tools.CConfigData)deserializer1.Deserialize(tr);
                }
            }
            catch (Exception ex)
            { }
            string currPath = System.AppDomain.CurrentDomain.BaseDirectory;
            string dataPath = currPath + @"data";
            string dataFile = dataPath + @"\基础配置表.xls";
            try
            {

                string confStr1 = @"Provider=Microsoft.ACE.OLEDB.12.0;";
                string confStr2 = @"Persist Security Info=false;";
                string confStr3 = @"Data Source=" + dataFile + ";";
                string confStr4 = @"Extended Properties=" + "'Excel 12.0;HDR=YES;IMEX=1'";
                string connStr = confStr1 + confStr2 + confStr3 + confStr4;

                OleDbConnection oleDC = new OleDbConnection(connStr);
                OleDbDataAdapter oleDDA1 = new OleDbDataAdapter("Select * From [参数配置$]", oleDC);
                oleDDA1.Fill(dtConfig);
                OleDbDataAdapter oleDDA2 = new OleDbDataAdapter("Select * From [物料类型$]", oleDC);
                DataTable temp = new DataTable();
                oleDDA2.Fill(temp);

                if (temp.Rows.Count > 0)
                {
                    for (int i = 0; i < temp.Rows.Count; i++)
                    {

                        ToolStripMenuItem tsm = new ToolStripMenuItem(temp.Rows[i][1].ToString());
                        物料设置ToolStripMenuItem.DropDownItems.Add(tsm);
                        tsm.Font = new Font("黑体", 15);
                        if (GlobalPara.gs_configInfo.CurrentMatName == temp.Rows[i][1].ToString())
                        {
                            tsm.CheckState = CheckState.Checked;
                        }
                        tsm.Click += new EventHandler(tsm_Click);
                    }
                }
                string temo = dtConfig.Rows[10][1].ToString();
                BoxMarkList = dtConfig.Rows[10][1].ToString().Split(';').ToList();
                GlobalPara.BoxMarkLists = BoxMarkList;
                tabControl1.DrawMode = TabDrawMode.Normal;
                tabControl1.SizeMode = TabSizeMode.Fixed;
                tabControl1.DrawItem += new DrawItemEventHandler(tabControl1_DrawItem);
                GlobalPara.s701 = new HslCommunication.Profinet.Siemens.SiemensS7Net(HslCommunication.Profinet.Siemens.SiemensPLCS.S1500,
                dtConfig.Rows[0][1].ToString());
                GlobalPara.s701.Rack = (byte)Convert.ToInt16(dtConfig.Rows[2][1].ToString());
                GlobalPara.s701.Slot = (byte)Convert.ToInt16(dtConfig.Rows[3][1].ToString());
                GlobalPara.s701.ConnectTimeOut = 300;
                GlobalPara.s701.ReceiveTimeOut = 200;
                GlobalPara.s701.ConnectServer();
                GlobalPara.s701.SetPersistentConnection();
                if (!DicPLC.ContainsKey(dtConfig.Rows[0][2].ToString().Trim()))
                {
                    DicPLC.Add(dtConfig.Rows[0][2].ToString().Trim(), GlobalPara.s701);   //1，
                    DicPLCResult.Add(GlobalPara.s701, null);
                }

                if (dtConfig.Rows[1][2] != null && !string.IsNullOrEmpty(dtConfig.Rows[1][2].ToString()))
                {
                    GlobalPara.Gloal1063Flag = true;
                }

                //GlobalPara.s702 = new HslCommunication.Profinet.Siemens.SiemensS7Net(HslCommunication.Profinet.Siemens.SiemensPLCS.S1500,
                //dtConfig.Rows[5][1].ToString());
                //GlobalPara.s702.Rack = (byte)Convert.ToInt16(dtConfig.Rows[7][1].ToString());
                //GlobalPara.s702.Slot = (byte)Convert.ToInt16(dtConfig.Rows[8][1].ToString());
                //GlobalPara.s702.ConnectTimeOut = 500;
                //GlobalPara.s702.ReceiveTimeOut = 200;
                //GlobalPara.s702.ConnectServer();
                //GlobalPara.s702.SetPersistentConnection();
                //if (!DicPLC.ContainsKey(dtConfig.Rows[5][2].ToString().Trim()))
                //{
                //    DicPLC.Add(dtConfig.Rows[5][2].ToString().Trim(), GlobalPara.s702);
                //    DicPLCResult.Add(GlobalPara.s702, null);
                //}

                // result = GlobalPara.s701.ConnectServer();
                heartBitList.Add(dtConfig.Rows[1][1].ToString()); heartBitList2.Add(dtConfig.Rows[4][1].ToString());
                heartBitList.Add(dtConfig.Rows[6][1].ToString()); heartBitList2.Add(dtConfig.Rows[9][1].ToString());
                if (dtConfig.Rows.Count >= 11)
                {
                    AlarmNumber = int.Parse(dtConfig.Rows[11][1].ToString());
                }
                if (File.Exists(@"Exception\判断点放行信息.txt"))
                {
                    string[] texts = File.ReadAllLines(@"Exception\判断点放行信息.txt");
                    if (texts != null && texts.Length > 0)
                    {
                        foreach (string str in texts)
                        {
                            string[] context = str.Split(',');
                            if (context.Length > 1)
                            {
                                int num = int.Parse(context[0]);
                                if (!AGVIDWithPosByCheckPos.ContainsKey(num))
                                {
                                    AGVIDWithPosByCheckPos.Add(num, int.Parse(context[1]));
                                }
                                if (context.Length > 2)
                                {
                                    if (!AGVIDWithRouteByCheckPos.ContainsKey(num))
                                    {
                                        AGVIDWithRouteByCheckPos.Add(num, int.Parse(context[2]));
                                    }
                                }
                            }
                        }
                    }
                }
                sw.Stop();
                Console.WriteLine("配置初始化总共花费{0}s.", sw.Elapsed.TotalSeconds);
                sw.Restart();
                InitView();
                sw.Stop();
                Console.WriteLine("界面初始化总共花费{0}s.", sw.Elapsed.TotalSeconds);

            }
            catch (System.Exception ex)
            {
                MessageBox.Show(ex.StackTrace);



            }
        }

        void tsm_Click(object sender, EventArgs e)
        {
            for (int i = 0; i < 物料设置ToolStripMenuItem.DropDownItems.Count; i++)
            {
                if (((ToolStripMenuItem)物料设置ToolStripMenuItem.DropDownItems[i]).Text == ((ToolStripMenuItem)sender).Text
                    && ((ToolStripMenuItem)sender).CheckState == CheckState.Checked)
                {
                    return;
                }
                ((ToolStripMenuItem)物料设置ToolStripMenuItem.DropDownItems[i]).CheckState = CheckState.Unchecked;

            }
            ((ToolStripMenuItem)sender).Checked = true;
            GlobalPara.gs_configInfo.CurrentMatName = ((ToolStripMenuItem)sender).Text;
            XmlSerializer serializer2 = new XmlSerializer(GlobalPara.gs_configInfo.GetType());
            using (TextWriter tw = new StreamWriter("CConfig.xml"))
            {
                serializer2.Serialize(tw, GlobalPara.gs_configInfo);
            }
            //     this.DispatchSystem_Load(null, null);
            isChoseMat = true;
            this.Close();



        }

        void tsm_CheckedChanged(object sender, EventArgs e)
        {


            //throw new NotImplementedException();
        }

        void tsm_CheckStateChanged(object sender, EventArgs e)
        {
            //throw new NotImplementedException();
        }


        public void Releasetest()
        {


            bool flag = false;
            string ProductType = "2500010EDG";

            if (!string.IsNullOrEmpty(ProductType) && ProductType.Length > 3)
            {
                for (int i1 = 0; i1 < ProductTypeDt.Rows.Count; i1++)  //循环表
                {

                    string route = "";
                    List<string> list1 = new List<string>();

                    if (ProductTypeDt.Rows[i1][0] != null)
                    {
                        route = ProductTypeDt.Rows[i1][0].ToString().Trim();
                    }

                    list1 = ProductTypeDt.Rows[i1][1].ToString().Trim().Split(';').ToList();

                    foreach (string type1 in list1)
                    {
                        int length = ProductType.Length;
                        String Type = ProductType.Substring(length - 3);
                        if (Type.StartsWith(type1) && route != "")
                        {
                            int route1 = int.Parse(route);
                            //DispatcherTool.ReleaseAgvOnStop(info.MARKNUM, int.Parse(route)); //根据路线放行
                            flag = true;
                        }
                    }

                    if (flag)
                    {
                        break;
                    }

                }
            }
        }

        PLCSqlDLL PLCSql = new PLCSqlDLL();

        /// <summary>
        /// 界面初始化
        /// </summary>
        /// <param name="temp"></param>
        public void InitView()
        {
            StartHttpServer();
            string currPath = System.AppDomain.CurrentDomain.BaseDirectory;
            string dataPath = currPath + @"data\";
            string dataFile = dataPath + GlobalPara.gs_configInfo.CurrentMatName + ".xls";
            if (false == File.Exists(dataFile))
            {
                DirectoryInfo di = new DirectoryInfo(dataPath);
                foreach (FileInfo f in di.GetFiles())
                {
                    if (!f.Name.Contains("基础配置表") && f.Extension.Contains(".xls"))
                    {
                        GlobalPara.gs_configInfo.CurrentMatName = f.Name.Replace(".xls", "");
                        for (int i = 0; i < 物料设置ToolStripMenuItem.DropDownItems.Count; i++)
                        {

                            if (物料设置ToolStripMenuItem.DropDownItems[i].Text == GlobalPara.gs_configInfo.CurrentMatName)
                            {
                                ((ToolStripMenuItem)物料设置ToolStripMenuItem.DropDownItems[i]).CheckState = CheckState.Checked;
                            }
                        }
                        dataFile = f.FullName;
                        break;
                    }
                }
            }
            try
            {

                string confStr1 = @"Provider=Microsoft.ACE.OLEDB.12.0;";
                string confStr2 = @"Persist Security Info=false;";
                string confStr3 = @"Data Source=" + dataFile + ";";
                string confStr4 = @"Extended Properties=" + "'Excel 12.0;HDR=YES;IMEX=1'";
                string connStr = confStr1 + confStr2 + confStr3 + confStr4;

                OleDbConnection oleDC = new OleDbConnection(connStr);
                OleDbDataAdapter oleDDA2 = new OleDbDataAdapter("Select * From [线体信息$]", oleDC);
                oleDDA2.Fill(LineDt);


                OleDbDataAdapter oleDDA5 = new OleDbDataAdapter("Select * From [产品类型$]", oleDC);
                oleDDA5.Fill(ProductTypeDt);



                OleDbDataAdapter oleDDA33 = new OleDbDataAdapter("Select * From [PACK线$]", oleDC);

                oleDDA33.Fill(dtSKQPLC);
                GlobalPara.dtSKQPLCs = dtSKQPLC;


                //OleDbDataAdapter oleDDA44 = new OleDbDataAdapter("Select * From [PLC工站$]", oleDC);
                //oleDDA44.Fill(dtTestPLC);

                // Releasetest();
                //if (!string.IsNullOrEmpty(dtConfig.Rows[13][1].ToString()))
                //{
                //    AGVInfo Agvinfo = new AGVInfo();

                //    string ProductType = "";
                //    bool flag = false;
                //    string MARKNUM = "65";
                //    string ss = dtConfig.Rows[13][1].ToString();
                //    if (MARKNUM.Equals(dtConfig.Rows[13][1].ToString()))  //到达分配点地标
                //    {
                //        PLCSql.PLCMESSelect("4", "2", ref Agvinfo); //查询数据
                //        ProductType = Agvinfo.ProductType;
                //    }
                //}
                //OleDbDataAdapter oleDDA55 = new OleDbDataAdapter("Select * From [大族焊房$]", oleDC);

                //oleDDA55.Fill(dtBigzPLC);

                //OleDbDataAdapter oleDDA44 = new OleDbDataAdapter("Select * From [先惠测试$]", oleDC);

                //oleDDA44.Fill(dtTestPLC);

                Dictionary<Thread, object[]> listThread = new Dictionary<Thread, object[]>();
                for (int i = 0; i < LineDt.Rows.Count; i++)
                {
                    int ConnectType = int.Parse(LineDt.Rows[i]["对接方式"].ToString());
                    string lineName = LineDt.Rows[i]["线体名称"].ToString();
                    TabPage tb = new TabPage(lineName);
                    tb.Font = new System.Drawing.Font("楷体", tb.Font.Size + 5);



                    oleDDA2 = new OleDbDataAdapter("Select * From [" + lineName + "$]", oleDC);
                    DataTable temp2 = new DataTable();
                    temp2.TableName = lineName;
                    oleDDA2.Fill(temp2);

                    if (LineDt.Rows[i]["判断点"] != null && !string.IsNullOrEmpty(LineDt.Rows[i]["判断点"].ToString()) && LineDt.Rows[i]["判断点"].ToString() != "0")
                    {
                        if (!checkPosDic.ContainsKey(int.Parse(LineDt.Rows[i]["判断点"].ToString())))
                        {
                            checkPosDic.Add(int.Parse(LineDt.Rows[i]["判断点"].ToString()), lineName);
                        }
                    }

                    int X = 10, Y = 10;
                    List<Button> listBtn = new List<Button>();
                    if (lineName == "充放电测试")
                    {
                        DataView dv = temp2.DefaultView;
                        dv.Sort = " 优先级 asc";
                        temp2 = dv.ToTable();
                    }
                    for (int j = 1; j <= temp2.Rows.Count; j++)
                    {
                        //if (temp2.Columns.Contains("组号") && !dicReleaseArea.ContainsKey(int.Parse(temp2.Rows[j - 1]["组号"].ToString())))
                        //{
                        //    dicReleaseArea.Add(int.Parse(temp2.Rows[j - 1]["组号"].ToString()), null);
                        //}
                        if (temp2.Rows[j - 1]["放行DB"] != null && !string.IsNullOrEmpty(temp2.Rows[j - 1]["放行DB"].ToString()) && temp2.Rows[j - 1]["放行DB"].ToString() != "0")
                        {
                            if (!DBWithByteValue.ContainsKey((temp2.Rows[j - 1]["放行DB"].ToString())))
                            {
                                DBWithByteValue.Add((temp2.Rows[j - 1]["放行DB"].ToString()), (byte)255);
                            }
                        }
                        if (temp2.Columns.Contains("判断地标"))
                        {
                            if (temp2.Rows[j - 1]["判断地标"] != null && !string.IsNullOrEmpty(temp2.Rows[j - 1]["判断地标"].ToString()))
                            {
                                if (!dicCheck.ContainsKey(temp2.Rows[j - 1]["工位地标"].ToString()))
                                {
                                    dicCheck.Add(temp2.Rows[j - 1]["工位地标"].ToString(), temp2.Rows[j - 1]["判断地标"].ToString().Split(',').ToList());
                                }
                            }
                        }
                        Button btn = new Button();
                        btn.Text = temp2.Rows[j - 1][1].ToString();
                        btn.Location = new Point(X, Y);
                        btn.Font = new Font("宋体", 15);
                        btn.Size = new Size(100, 80);
                        btn.Click
                            += new EventHandler(btn_Click);
                        btn.BackColor = Color.FromKnownColor(KnownColor.Control);
                        X += btn.Size.Width + 20;
                        if (j % 8 == 0)
                        {
                            X = 10; Y += btn.Height + 20;
                        }
                        btn.Tag = temp2.Rows[j - 1][2].ToString();
                        tb.Controls.Add(btn);


                        if (!string.IsNullOrEmpty(temp2.Rows[j - 1][2].ToString()) && AGVIDWithPosByCheckPos.ContainsValue(int.Parse(temp2.Rows[j - 1][2].ToString())))
                        {
                            List<int> keys = AGVIDWithPosByCheckPos.Keys.ToList();
                            for (int a = 0; a < keys.Count; a++)
                            {
                                if (AGVIDWithPosByCheckPos[keys[a]] == int.Parse(temp2.Rows[j - 1][2].ToString()))
                                {
                                    btn.Text = btn.Text.Replace("\n", "") + "\n" + keys[a];
                                    btn.BackColor = Color.Blue;
                                    break;
                                }
                            }
                        }
                        listBtn.Add(btn);
                        if (lineName == "充放电测试")
                        {
                            if (!CFDRoutes.Contains(int.Parse(temp2.Rows[j - 1]["放行路线"].ToString())))
                            {
                                CFDRoutes.Add(int.Parse(temp2.Rows[j - 1]["放行路线"].ToString()));
                            }
                        }
                    }
                    Tools.TabPageTag tt = new Tools.TabPageTag();
                    tt.Table = temp2.Copy();
                    tt.ListBtn = new List<Button>();
                    string PLCNumber = LineDt.Rows[i][4].ToString().Trim();
                    if (DicPLC.ContainsKey(PLCNumber))
                    {
                        tt.S7 = DicPLC[PLCNumber];
                    }
                    else
                    {
                        tt.S7 = null;
                    }
                    tt.ListBtn.AddRange(listBtn);
                    tt.ConnectType = ConnectType;
                    listAllBtns.AddRange(listBtn);
                    tb.Tag = tt;
                    tabControl1.TabPages.Add(tb);
                    object[] obj = new object[3];
                    obj[0] = listBtn; obj[1] = 0; obj[2] = lineName;
                    if (lineName == "充放电测试")
                    {
                        CurCFDRoute = CFDRoutes[index];
                    }
                    //    if (lineName == "充放电测试") { tabControl1.SelectedTab = tb; }
                    if (ConnectType == 2)
                    {
                        //          MesDts.Add(temp2.Copy()); //初始化MES对接工站
                        for (int a = 0; a < tt.Table.Rows.Count; a++)
                        {
                            JObject jobj = new JObject();
                            jobj["ID"] = tt.Table.Rows[a]["ID"].ToString();
                            jobj["Mark"] = tt.Table.Rows[a]["工位地标"].ToString();
                            if (a + 1 < tt.Table.Rows.Count)
                            {
                                jobj["NextMark"] = tt.Table.Rows[a + 1]["工位地标"].ToString();
                            }
                            else
                            {
                                jobj["NextMark"] = 0;
                            }
                            jobj["Status"] = 0;
                            jobj["AGVID"] = 0;
                            jobj["AGVStatus"] = 0;
                            jobj["TargetStation"] = 0;
                            MesStations.Add(jobj);
                        }
                    }

                    listThread.Add(new Thread(new ParameterizedThreadStart(DockingOpeare0)), obj);//.Start(listBtn);
                                                                                                  //  DockingOpeare0(obj);               
                }

                OleDbDataAdapter oleDDA3 = new OleDbDataAdapter("Select * From [管制信息$]", oleDC);

                oleDDA3.Fill(DtTraffic);
                if (File.Exists(@"Exception\管制点放行信息.txt"))
                {
                    string[] texts = File.ReadAllLines(@"Exception\管制点放行信息.txt");
                    listTra.AddRange(texts.ToList());
                    if (listTra.Count < DtTraffic.Rows.Count)
                    {
                        for (int i = 0; i < DtTraffic.Rows.Count - listTra.Count; i++)
                        {
                            listTra.Add("0");
                        }
                    }
                }
                else
                {
                    if (DtTraffic.Rows.Count > 0)
                    {
                        listTra = new List<string>(DtTraffic.Rows.Count);
                        for (int i = 0; i < DtTraffic.Rows.Count; i++)
                        {
                            listTra.Add("0");
                        }
                    }
                }
                foreach (Thread t in listThread.Keys)
                {
                    t.Priority = ThreadPriority.Highest; t.IsBackground = true;
                    t.Start(listThread[t]);

                }
                //  Thread.Sleep(8000);
                //Thread t2 =  new Thread(new ThreadStart(checkingOperate));
                //t2.Priority = ThreadPriority.BelowNormal;
                //t2.Start();
                //   new Thread(new ThreadStart(CFDCheck)).Start();
                //  new Thread(new ThreadStart(checkingRelease2)).Start();
                //Thread t3 = new Thread(new ThreadStart(TrafficByDispatch));
                //t3.Priority = ThreadPriority.AboveNormal;
                //t3.Start();
                //Thread t5 = new Thread(new ThreadStart(CFDCheck)); t5.IsBackground = true;
                //t5.Priority = ThreadPriority.Normal;
                //t5.Start();

                //test(dtSKQPLC.Rows[0]);


                SKQPLC();
                Thread t4 = new Thread(new ThreadStart(PLCHeartBit)); t4.IsBackground = true;
                t4.Priority = ThreadPriority.Lowest;
              //  t4.Start();         220713 XDL注释

                Thread t5 = new Thread(new ThreadStart(ReleaseBoxLight)); t5.IsBackground = true;
                t5.Priority = ThreadPriority.Normal;
                t5.Start();


            }
            catch (System.Exception ex)
            {

                WriteFile("调度程序异常" + DateTime.Now.ToString("yyyy-MM-dd"), ex.Message + ex.StackTrace);

                MessageBox.Show(ex.StackTrace);
            }
        }


        public void StartHttpServer()
        {
            string address = "http://localhost:3350";
            if (WcsServerHost.Instance.StartServer(address))
            {
                //  lb_Address.Text = address;
            }
            else
            {
                //  lb_Address.Text = $"Http服务启动失败，地址:{address}";
            }
        }

        void btn_Click(object sender, EventArgs e)
        {
            //throw new NotImplementedException();
            Button btn = (Button)sender;
            if (btn.BackColor == Color.Blue)
            {
                if (MessageBox.Show("该工位已被分配锁定,是否解除锁定?", "警告", MessageBoxButtons.YesNo) == System.Windows.Forms.DialogResult.Yes)
                {
                    btn.Invoke(new InvokeDelegate(delegate
                    {

                        if (AGVIDWithPosByCheckPos.ContainsValue(int.Parse(btn.Tag.ToString())))
                        {
                            int num = AGVIDWithPosByCheckPos.Keys.ToList()[AGVIDWithPosByCheckPos.Values.ToList().IndexOf(int.Parse(btn.Tag.ToString()))];
                            if (AGVIDWithPosByCheckPos.ContainsKey(num))
                            {
                                lock (AGVIDWithPosByCheckPos)
                                {
                                    AGVIDWithPosByCheckPos.Remove(num);
                                }

                            }
                            if (AGVIDWithRouteByCheckPos.ContainsKey(num))
                            {
                                lock (AGVIDWithRouteByCheckPos)
                                {
                                    AGVIDWithRouteByCheckPos.Remove(num);
                                    recordReleaseInfo();
                                }
                            }
                            if (AGVIDWithPosByCheckPosReal.ContainsKey(num))
                            {
                                lock (AGVIDWithPosByCheckPosReal)
                                {
                                    AGVIDWithPosByCheckPosReal.Remove(num);
                                }
                            }
                            btn.BackColor = Color.FromKnownColor(KnownColor.Control);
                            if (btn.Text.Contains("("))
                            {
                                btn.Text = btn.Text.Replace("\n", "").Substring(0, btn.Text.LastIndexOf("(") - 1);
                            }
                        }
                        else
                        {
                            int num = int.Parse(btn.Tag.ToString());
                            if (AGVIDWithPosByCheckPos.Values.Contains(num))
                            {
                                lock (AGVIDWithPosByCheckPos)
                                {
                                    var temp = AGVIDWithPosByCheckPos.First(o => o.Value == num);
                                    if (AGVIDWithPosByCheckPos.ContainsKey(temp.Key))
                                    {
                                        AGVIDWithPosByCheckPos.Remove(temp.Key);
                                    }
                                }
                            }
                            if (AGVIDWithRouteByCheckPos.Values.Contains(num))
                            {
                                lock (AGVIDWithRouteByCheckPos)
                                {
                                    var temp = AGVIDWithRouteByCheckPos.First(o => o.Value == num);
                                    if (AGVIDWithRouteByCheckPos.ContainsKey(temp.Key))
                                    {
                                        AGVIDWithRouteByCheckPos.Remove(temp.Key);
                                        recordReleaseInfo();
                                    }
                                }
                            }
                            if (AGVIDWithPosByCheckPosReal.Values.Contains(num))
                            {
                                lock (AGVIDWithPosByCheckPosReal)
                                {
                                    var temp = AGVIDWithPosByCheckPosReal.First(o => o.Value == num);
                                    if (AGVIDWithPosByCheckPosReal.ContainsKey(temp.Key))
                                    {
                                        AGVIDWithPosByCheckPosReal.Remove(temp.Key);
                                    }
                                }
                            }

                            btn.BackColor = Color.FromKnownColor(KnownColor.Control);
                            if (btn.Text.Contains("("))
                            {
                                btn.Text = btn.Text.Replace("\n", "").Substring(0, btn.Text.LastIndexOf("(") - 1);
                            }
                        }
                    }
                    ));
                }
                else if (btn.BackColor == Color.Red)
                {
                    if (MessageBox.Show("该工位AGV已故障,是否解除状态，并将AGV移到故障?", "警告", MessageBoxButtons.YesNo) == System.Windows.Forms.DialogResult.Yes)
                    {
                        List<AGVInfoModel> listModel = GlobalPara.AgvInfoDic.Values.ToList();
                        IEnumerable<AGVInfoModel> temp = listModel.Where(o => o.MARKNUM.ToString() == btn.Tag.ToString());
                        if (temp.Count() > 0)
                        {
                            AGVInfoModel info = temp.ToList()[0];
                            info.MARKNUM = 0;
                            GlobalPara.AgvInfoDic[info.AGVNUM] = info;
                        }
                        btn.Invoke(new InvokeDelegate(delegate
                        {
                            btn.BackColor = Color.FromKnownColor(KnownColor.Control);
                            if (btn.Text.Contains("("))
                            {
                                btn.Text = btn.Text.Replace("\n", "").Substring(0, btn.Text.LastIndexOf("(") - 1);
                            }
                        }));
                    }
                }
            }


        }
        /// <summary>
        /// 记录放行后的情况
        /// </summary>
        public void recordReleaseInfo()
        {
            if (AGVIDWithPosByCheckPos.Count > 0)
            {
                string[] textArray = new string[AGVIDWithPosByCheckPos.Count];
                int aryIndex = 0;
                foreach (int num in AGVIDWithPosByCheckPos.Keys)
                {
                    if (AGVIDWithPosByCheckPos.ContainsKey(num))
                    {
                        textArray[aryIndex] = num + "," + AGVIDWithPosByCheckPos[num];
                    }
                    if (AGVIDWithRouteByCheckPos.ContainsKey(num))
                    {
                        textArray[aryIndex] += "," + AGVIDWithRouteByCheckPos[num];
                    }
                    ++aryIndex;
                }
                File.WriteAllLines(@"Exception\判断点放行信息.txt", textArray);
            }
            else
            {
                ClearTxt(@"Exception\判断点放行信息.txt");
            }
        }

        public void ClearTxt(string path)
        {
            try
            {
                FileStream stream = File.Open(path, FileMode.OpenOrCreate, FileAccess.Write);
                stream.Seek(0, SeekOrigin.Begin);
                stream.SetLength(0);
                stream.Close();
            }
            catch (Exception)
            {

            }
        }


        /// <summary>
        /// 调度管制
        /// </summary>
        public void TrafficByDispatch()
        {
            if (isChoseMat) { return; }
            if (DtTraffic.Rows.Count > 0)
            {
                bool b = true;
                while (b)
                {
                    try
                    {
                        //          if (!GlobalPara.IsOneKeySleep)
                        {
                            List<AGVInfoModel> listModel = GlobalPara.AgvInfoDic.Values.ToList();
                            for (int i = 0; i < DtTraffic.Rows.Count; i++)
                            {
                                List<string> listIn = DtTraffic.Rows[i][0].ToString().Split(',').ToList();
                                List<string> listTraffic = DtTraffic.Rows[i][1].ToString().Split(',').ToList();
                                //List<AGVInfoModel> results = listModel.FindAll(o => listTra[i].Equals(o.MARKNUM.ToString()) && o.ConnectStatus == true);
                                //if (results != null && results.Count > 0)
                                //{

                                //}
                                //else
                                // {
                                List<AGVInfoModel> results = listModel.FindAll(o => listIn.Contains(o.MARKNUM.ToString()) && o.ConnectStatus == true);
                                //  }
                                if (results != null && results.Count > 0)
                                {
                                    AGVInfoModel result = results.OrderBy(o => o.LastModifyMarkTime).ToList()[0];
                                    List<AGVInfoModel> results2 = listModel.FindAll(o => listTraffic.Contains(o.MARKNUM.ToString()) && o.ConnectStatus == true);
                                    if (listIn.Count == 1 && results.Count > 1)
                                    {
                                        continue;
                                    }
                                    if (results == null || results2.Count <= 0)
                                    {
                                        List<AGVInfoModel> results3 = listModel.FindAll(o => result.MARKNUM == o.MARKNUM && o.RUNSTATUS_Cur != 0x41 && o.ConnectStatus == true);
                                        if (results3 != null && results3.Count <= 0)
                                        {
                                            int route = 0; int targetMark = 0;
                                            if (AGVIDWithPosByCheckPos.Keys.Contains(result.AGVNUM))
                                            {
                                                targetMark = AGVIDWithPosByCheckPos[result.AGVNUM];
                                            }
                                            if (AGVIDWithRouteByCheckPos.Keys.Contains(result.AGVNUM))
                                            {
                                                route = AGVIDWithRouteByCheckPos[result.AGVNUM];
                                            }

                                            //List<int> markList = new List<int>() { 5,19,34};



                                            Thread.Sleep(1000);
                                            DispatcherTool.ReleaseAgvOnStop(result.MARKNUM, route, targetMark, 1);



                                            if (listTra[i] != result.MARKNUM.ToString())
                                            {
                                                listTra[i] = result.MARKNUM.ToString();
                                                File.WriteAllLines(@"Exception\管制点放行信息.txt", listTra.ToArray());
                                            }
                                            WriteFile("管制记录" + DateTime.Now.ToString("yyyy-MM-dd"), result.AGVNUM + "号AGV符合放行条件，地标为：" + result.MARKNUM + "，路线为" + route + "，目的地标为" + targetMark);
                                        }
                                    }
                                }
                            }
                        }
                    }
                    catch (Exception)
                    {
                        b = false;
                        //Thread.Sleep(200);
                        //new Thread(new ThreadStart(TrafficByDispatch)).Start();
                    }
                    finally
                    {
                        //if (!b)
                        //{
                        //    Thread.Sleep(500);
                        //    Thread t2 = new Thread(new ThreadStart(TrafficByDispatch)); t2.IsBackground = true;
                        //    t2.Priority = ThreadPriority.AboveNormal;
                        //    t2.Start();
                        //    WriteFile("线程重启", "TrafficByDispatch报错，已重启!");
                        //}
                    }
                    Thread.Sleep(500);
                }
            }
        }

        /// <summary>
        /// 收到PLC放行信号继续发送放行
        /// </summary>
        public void checkingRelease()
        {
            bool b = true;
            while (b)
            {
                try
                {
                    //          if (!GlobalPara.IsOneKeySleep)
                    {
                        //  if (result != null && result.IsSuccess)
                        {
                            for (int j = 0; j < tabControl1.TabPages.Count; j++)  //当前页码
                            {
                                if (tabControl1.TabPages[j].Tag != null)
                                {
                                    TabPageTag tt = (TabPageTag)tabControl1.TabPages[j].Tag;
                                    SiemensS7Net s7 = tt.S7;
                                    //result = s7.ConnectServer();
                                    // result = DicPLCResult[s7];
                                    //  if (result != null && result.IsSuccess)
                                    {
                                        for (int k = 0; k < tt.Table.Rows.Count; k++)
                                        {
                                            DataRow dr = tt.Table.Rows[k];
                                            string releaseAddress = dr["放行DB"].ToString();
                                            if (!string.IsNullOrEmpty(releaseAddress))
                                            {
                                                OperateResult<byte> resultRead = s7.ReadByte(releaseAddress);
                                                if (resultRead != null && result.IsSuccess)
                                                {
                                                    if (resultRead.Content == (byte)GlobalPara.DBControlValues.OKRelease)
                                                    {
                                                        DispatcherTool.ReleaseAgvOnStop(int.Parse(dr["工位地标"].ToString()), 0, int.Parse(dr["目的地标"].ToString()));
                                                    }
                                                    else if (resultRead.Content == (byte)GlobalPara.DBControlValues.NGRelease)
                                                    {
                                                        DispatcherTool.ReleaseAgvOnStop(int.Parse(dr["工位地标"].ToString()), int.Parse(dr["NG路线"].ToString()));
                                                    }
                                                }
                                            }
                                            Thread.Sleep(10);
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
                catch (Exception)
                {
                    b = false;
                    //Thread.Sleep(500);
                    //new Thread(new ThreadStart(checkingRelease)).Start();
                }
                finally
                {
                    if (!b)
                    {
                        Thread.Sleep(500);
                        Thread t2 = new Thread(new ThreadStart(checkingRelease)); t2.IsBackground = true;
                        t2.Priority = ThreadPriority.BelowNormal;
                        t2.Start();
                        WriteFile("线程重启", "checkingRelease报错，已重启!");
                    }
                }
                Thread.Sleep(500);
            }
        }

        /// <summary>
        /// 收到PLC放行信号继续发送放行
        /// </summary>
        public void checkingRelease2()
        {
            bool b = true;
            while (b)
            {
                try
                {
                    //   if (result != null && result.IsSuccess)
                    {
                        List<string> keys = DBWithByteValue.Keys.ToList();
                        for (int i = 0; i < keys.Count; i++)
                        {
                            if (DBWithByteValue[keys[i]] == (byte)GlobalPara.DBControlValues.OKRelease ||
                                DBWithByteValue[keys[i]] == (byte)GlobalPara.DBControlValues.NGRelease)
                            {
                                for (int j = 0; j < tabControl1.TabPages.Count; j++)
                                {
                                    if (tabControl1.TabPages[j].Tag != null)
                                    {
                                        TabPageTag tt = (TabPageTag)tabControl1.TabPages[j].Tag;
                                        SiemensS7Net s7 = tt.S7;
                                        //result = s7.ConnectServer();
                                        result = DicPLCResult[s7];
                                        if (result != null && result.IsSuccess)
                                        {
                                            DataRow[] drs = tt.Table.Select("放行DB='" + keys[i] + "'");

                                            if (drs != null && drs.Length > 0)
                                            {
                                                if (DBWithByteValue[keys[i]] == (byte)GlobalPara.DBControlValues.OKRelease)
                                                {
                                                    DispatcherTool.ReleaseAgvOnStop(int.Parse(drs[0]["工位地标"].ToString()), 0, int.Parse(drs[0]["目的地标"].ToString()));
                                                    break;
                                                }
                                                else if (DBWithByteValue[keys[i]] == (byte)GlobalPara.DBControlValues.NGRelease)
                                                {
                                                    DispatcherTool.ReleaseAgvOnStop(int.Parse(drs[0]["工位地标"].ToString()), int.Parse(drs[0]["NG路线"].ToString()));
                                                    break;
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
                catch (Exception)
                {
                    b = false;
                    //Thread.Sleep(500);
                    //new Thread(new ThreadStart(checkingRelease2)).Start();
                }
                finally
                {
                    if (!b)
                    {
                        Thread.Sleep(500);
                        new Thread(new ThreadStart(checkingRelease2)).Start();
                        WriteFile("线程重启", "checkingRelease报错，已重启!");
                    }
                }
                Thread.Sleep(500);
            }
        }

        /// <summary>
        /// 判断点事件
        /// </summary>
        public void checkingOperate()
        {
            while (true)
            {
                if (isChoseMat) { return; }
                bool bb = false;
                Stopwatch sw2 = new Stopwatch();
                List<AGVInfoModel> listModel = GlobalPara.AgvInfoDic.Values.ToList();
                ParallelLoopResult result;

                try
                {

                    result = Parallel.ForEach<int>(checkPosDic.Keys, new ParallelOptions { MaxDegreeOfParallelism = 1 }, pos =>
                    {
                        //     if (!GlobalPara.IsOneKeySleep)
                        {
                            //  && !AGVIDWithPosByCheckPos.ContainsKey(o.AGVNUM)
                            AGVInfoModel temp = listModel.Find(o => o.MARKNUM == pos && (o.RUNSTATUS_Cur == 0x41 || (o.MARKFUN == 1 && o.ALARMINFO == "低电压报警")) && o.ConnectStatus == true);
                            if (temp != null)
                            {
                                int num = temp.AGVNUM;
                                int checkRoute = temp.ROUTENUM;
                                lock (listModel)
                                {
                                    //if (temp.EollFlag == false)
                                    //{
                                    //    temp.EollFlag = true;
                                    //    WriteFile("EOL1-EOL2", "(地标：" + temp.MARKNUM + ", " + ",车号:" + temp.AGVNUM + ") ,开关打开,原因:读到判断点");
                                    //}
                                }
                                if (!AGVIDWithPosByCheckPos.ContainsKey(num))
                                {
                                    string lineName = checkPosDic[pos];
                                    bool b2 = false;
                                    for (int i = 0; i < this.tabControl1.TabPages.Count; i++)
                                    {
                                        if (this.tabControl1.TabPages[i].Text == lineName && InitOK.ContainsKey(lineName) && InitOK[lineName])
                                        {
                                            TabPageTag tag = this.tabControl1.TabPages[i].Tag as TabPageTag;
                                            DataRow[] drs = null;
                                            {
                                                drs = tag.Table.Select("优先级>0", "优先级 asc");
                                            }
                                            if (lineName.ToLower().Contains("pack线"))
                                            {
                                                drs = tag.Table.Select("优先级>0 and 判断路线<>'0'", "优先级 asc");
                                                List<DataRow> listDr = new List<DataRow>();
                                                foreach (DataRow dr in drs)
                                                {
                                                    if (dr["判断路线"].ToString().Split(';').Contains(checkRoute.ToString()))
                                                    {
                                                        listDr.Add(dr);
                                                    }
                                                }
                                                drs = listDr.ToArray();
                                            }
                                            for (int j = 0; j < drs.Length; j++)
                                            {
                                                //  IEnumerable<DataRow> query =
                                                //from data in tag.Table.AsEnumerable()
                                                //group data by data["路线"] into g
                                                //select g.First();
                                                if (tag.Table.Columns.Contains("通道DB"))
                                                {
                                                    string releaseAddress = drs[j]["通道DB"].ToString();
                                                    if (releaseAddress != "0")
                                                    {
                                                        OperateResult<byte> resultRead = tag.S7.ReadByte(releaseAddress);
                                                        if (resultRead.IsSuccess)
                                                        {
                                                            if (resultRead.Content == (byte)1)
                                                            {

                                                            }
                                                            else
                                                            {
                                                                continue;
                                                            }
                                                        }
                                                    }
                                                }
                                                Button btn = tag.ListBtn.Find(o => o.Tag.ToString() == drs[j]["工位地标"].ToString() && !AGVIDWithPosByCheckPos.ContainsValue(int.Parse(o.Tag.ToString()))
                                                      && (o.BackColor == Color.FromKnownColor(KnownColor.Control) || o.BackColor == Color.FromKnownColor(KnownColor.Green)
                                                      ) && o.BackColor != Color.FromKnownColor(KnownColor.Blue));
                                                if (btn != null)
                                                {
                                                    //找到目的站点，放行路线
                                                    bool b = true;
                                                    if (dicCheck.ContainsKey(drs[j]["工位地标"].ToString()))
                                                    {
                                                        List<string> tempList = dicCheck[drs[j]["工位地标"].ToString()];
                                                        for (int a = 0; a < tempList.Count; a++)
                                                        {
                                                            int iindex = listModel.FindIndex(o => o.MARKNUM.ToString() == tempList[a] && o.ConnectStatus == true);
                                                            if (iindex > -1)
                                                            {
                                                                b = false;
                                                                break;
                                                            }
                                                        }
                                                    }
                                                    if (b)
                                                    {
                                                        AGVIDWithPosByCheckPos.Add(num, int.Parse(drs[j]["工位地标"].ToString()));
                                                        AGVIDWithRouteByCheckPos.Add(num, int.Parse(drs[j]["放行路线"].ToString()));
                                                        AGVIDWithPosByCheckPosReal.Add(num, pos);
                                                        DispatcherTool.ReleaseAgvOnStop(pos, int.Parse(drs[j]["放行路线"].ToString()), int.Parse(drs[j]["工位地标"].ToString()));
                                                        WriteFile("判断点记录-" + DateTime.Now.ToString("yyyy-MM-dd"), "(判断点地标：" + pos + ",放行路线：" + drs[j]["放行路线"].ToString() + ",目的地标:" + int.Parse(drs[j]["工位地标"].ToString()) + ",车号:" + num + ",工位颜色为" + btn.BackColor.Name + ") ");
                                                        if (!dicReleaseArea.ContainsKey(num.ToString()))
                                                        {
                                                            CFDClass cfd = new CFDClass();
                                                            cfd.agvID = num;
                                                            cfd.mark = pos;
                                                            cfd.targetMark = int.Parse(drs[j]["工位地标"].ToString());
                                                            cfd.route = int.Parse(drs[j]["放行路线"].ToString());
                                                            cfd.IsRelease = false;
                                                            dicReleaseArea.Add(num.ToString(), cfd);
                                                        }
                                                        recordReleaseInfo();
                                                        btn.Invoke(new InvokeDelegate(delegate
                                                        {
                                                            if (btn.BackColor != Color.FromKnownColor(KnownColor.Blue))
                                                            {
                                                                btn.BackColor = Color.Blue;
                                                                if (btn.Text.Contains("("))
                                                                {
                                                                    int textIndex = btn.Text.LastIndexOf("(");
                                                                    string orignName = btn.Text.Substring(0, textIndex).Replace("\n", "");
                                                                    btn.Text = orignName + "\n" + "(" + num + ")";
                                                                }
                                                                else
                                                                {
                                                                    btn.Text = btn.Text.Replace("\n", "") + "\n" + "(" + num + ")";
                                                                }
                                                            }
                                                        }));
                                                        b2 = true;
                                                        break;
                                                    }
                                                }
                                            }
                                        }
                                        if (b2)
                                        {
                                            break;
                                        }


                                    }
                                }
                                else //AGVIDWithPosByCheckPos 包含当前AGVID
                                {
                                    if (AGVIDWithPosByCheckPosReal.ContainsKey(num))
                                    {
                                        if (AGVIDWithPosByCheckPosReal[num] != pos)
                                        {
                                            if (AGVIDWithPosByCheckPos.ContainsKey(num))
                                            {
                                                AGVIDWithPosByCheckPos.Remove(num);
                                            }
                                            if (AGVIDWithRouteByCheckPos.ContainsKey(num))
                                            {
                                                AGVIDWithRouteByCheckPos.Remove(num);
                                            }
                                            AGVIDWithPosByCheckPosReal.Remove(num);

                                            recordReleaseInfo();
                                            for (int i = 0; i < tabControl1.TabPages.Count; i++)
                                            {
                                                Button tempBtn = (tabControl1.TabPages[i].Tag as TabPageTag).ListBtn.Find(o => o.Text.Contains("(" + num + ")") && o.BackColor == Color.Blue);
                                                if (tempBtn != null)
                                                {
                                                    tempBtn.BackColor = Color.FromKnownColor(KnownColor.Control);
                                                    if (tempBtn.Text.Contains("("))
                                                    {
                                                        tempBtn.Text = tempBtn.Text.Replace("\n", "").Substring(0, tempBtn.Text.LastIndexOf("(") - 1);
                                                    }
                                                    break;
                                                }
                                            }
                                            WriteFile("判断点异常自解除记录" + DateTime.Now.ToString("yyyy-MM-dd"), num + "号车在" + pos + "地标判断点解除上次锁定");
                                        }
                                        else  //AGVIDWithPosByCheckPosReal[num] == pos
                                        {
                                            // AGVIDWithPosByCheckPosReal
                                            //int route = -1; int target = -1;
                                            //if (AGVIDWithPosByCheckPos.ContainsKey(num))
                                            //{
                                            //    target = AGVIDWithPosByCheckPos[num];
                                            //}
                                            //if (AGVIDWithRouteByCheckPos.ContainsKey(num))
                                            //{
                                            //    route = AGVIDWithRouteByCheckPos[num];
                                            //}
                                            //if (route != -1 && target != -1)
                                            //{
                                            //    DispatcherTool.ReleaseAgvOnStop(pos, route, target, 1);
                                            //}
                                        }
                                    }
                                }
                            }
                        }
                    });

                    //     if (result.IsCompleted)
                    {
                        sw2.Stop();
                        Console.WriteLine("判断点任务总共花费{0}s.", sw.Elapsed.TotalSeconds);
                        //Thread.Sleep(50);
                        //Thread t2 = new Thread(new ThreadStart(checkingOperate)); t2.IsBackground = true;
                        //t2.Priority = ThreadPriority.BelowNormal;
                        //t2.Start();
                    }
                }
                catch (Exception ex)
                {
                    //DateTime time = DateTime.Now;
                    ////MessageBox.Show("线程异常:"+e.ExceptionObject);
                    //FileStream stream = File.Open(@"Exception\调度程序异常.txt", FileMode.Append, FileAccess.Write);
                    //StreamWriter writer = new StreamWriter(stream);

                    //if (ex != null)
                    //{
                    //    string msg = string.Format("[{0}]Test:\r\nMessage:{1}\r\nStackTrace:\r\n{2}", time.ToString("yyyy-MM-dd HH:mm:ss"), ex.Message, ex.StackTrace);
                    //    writer.WriteLine(msg);
                    //    writer.Close();
                    //    stream.Close();
                    //}
                    //bb = true;
                    //Thread.Sleep(500);
                    //new Thread(new ThreadStart(checkingOperate)).Start();
                }
                finally
                {
                    //if (bb)
                    //{
                    //    Thread.Sleep(500);
                    //    Thread t2 = new Thread(new ThreadStart(checkingOperate)); t2.IsBackground = true;
                    //    t2.Priority = ThreadPriority.BelowNormal;
                    //    t2.Start();
                    //    WriteFile("线程重启", "checkingOperate报错，已重启!");
                    //}
                }
                Thread.Sleep(500);
            }
        }

        public void CFDCheck()
        {
            if (isChoseMat) { return; }
            bool bb = false;
            ParallelLoopResult result2;
            try
            {
                List<string> list = dicReleaseArea.Keys.ToList();
                List<AGVInfoModel> listModel = GlobalPara.AgvInfoDic.Values.ToList();
                result2 = Parallel.ForEach<string>(list, new ParallelOptions { MaxDegreeOfParallelism = 2 }, key =>
                {
                    if (dicReleaseArea[key] != null)
                    {
                        //    List<Button> listBtn = dicReleaseArea[key].btns;
                        //      if (listBtn != null && listBtn.Count > 0)
                        {
                            CFDClass cfd = dicReleaseArea[key];
                            if (listModel.FindIndex(o => o.AGVNUM == cfd.agvID && cfd.mark == o.MARKNUM && o.ConnectStatus == true
                                && ((o.RUNSTATUS_Cur == 0x43 || o.RUNSTATUS_Cur == 0x44 || (o.MARKFUN == 1 && o.ALARMINFO == "低电压报警")))) > -1)
                            {
                                if (listModel.FindAll(o => cfd.mark == o.MARKNUM && o.ConnectStatus == true).Count() == 1)
                                {
                                    DispatcherTool.ReleaseAgvOnStop(cfd.mark, cfd.route, cfd.targetMark, 2);
                                    if (!cfd.IsRelease)
                                    {
                                        cfd.IsRelease = true;
                                        lock (dicReleaseArea)
                                        {
                                            dicReleaseArea[key] = cfd;
                                        }
                                    }
                                }
                            }
                            else
                            {
                                lock (dicReleaseArea)
                                {
                                    dicReleaseArea.Remove(key);
                                }
                                if (cfd.IsRelease)
                                {
                                    WriteFile("补充放行记录" + DateTime.Now.ToString("yyyy-MM-dd"), key + "号AGV放行完成");
                                }
                            }
                        }
                    }
                });
                //   if (result2.IsCompleted)
                {
                    Thread.Sleep(2000);
                    Thread t2 = new Thread(new ThreadStart(CFDCheck));
                    t2.Priority = ThreadPriority.Normal; t2.IsBackground = true;
                    t2.Start();
                }
            }
            catch (Exception ex)
            {
                DateTime time = DateTime.Now;
                //MessageBox.Show("线程异常:"+e.ExceptionObject);
                FileStream stream = File.Open(@"Exception\调度程序异常.txt", FileMode.Append, FileAccess.Write);
                StreamWriter writer = new StreamWriter(stream);

                if (ex != null)
                {
                    string msg = string.Format("[{0}]Test:\r\nMessage:{1}\r\nStackTrace:\r\n{2}", time.ToString("yyyy-MM-dd HH:mm:ss"), ex.Message, ex.StackTrace);
                    writer.WriteLine(msg);
                    writer.Close();
                    stream.Close();
                }
                bb = true;

            }
            finally
            {
                if (bb)
                {
                    Thread.Sleep(2000);
                    Thread t2 = new Thread(new ThreadStart(CFDCheck)); t2.IsBackground = true;
                    t2.Priority = ThreadPriority.BelowNormal;
                    t2.Start();
                    WriteFile("线程重启", "CFDCheck报错，已重启!");
                }
            }
        }

        public void DockingOpeare0(object o)
        {
            object[] obj = (object[])o;
            DockingOpeare((List<Button>)obj[0], (int)obj[1], (string)obj[2]);
        }

        public void ReleaseLot()
        {
            try
            {
                List<string> list = new List<string>();
                for (int i = 0; i < dtConfig.Rows.Count; i++)
                {
                    if (dtConfig.Rows[i][0] != null && dtConfig.Rows[i][1] != null && dtConfig.Rows[i][0].ToString().Trim() == "解绑地标")
                    {
                        list = dtConfig.Rows[i][1].ToString().Trim().Split(';').ToList();
                    }
                }
                if (list != null && list.Count > 0)
                {
                    while (true)
                    {
                        List<AGVInfoModel> listModel = GlobalPara.AgvInfoDic.Values.ToList();
                        List<AGVInfoModel> results = listModel.FindAll(o => list.Contains(o.MARKNUM.ToString()) && o.ConnectStatus == true);
                        if (results != null && results.Count > 0)
                        {
                            foreach (AGVInfoModel info in results)
                            {
                                if (info != null)
                                {
                                    PLCSql.PLCSql(info.AGVNUM.ToString(), "", "", "3");
                                }
                            }
                        }
                        Thread.Sleep(500);
                    }
                }
            }
            catch (Exception ex)
            {
                FileStream stream = File.Open(@"Exception\调度程序异常lot.txt", FileMode.Append, FileAccess.Write);
                StreamWriter writer = new StreamWriter(stream);

                if (ex != null)
                {
                    string msg = string.Format("[{0}]Test:\r\nMessage:{1}\r\nStackTrace:\r\n{2}", DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss"), ex.Message, ex.StackTrace);
                    writer.WriteLine(msg);
                    writer.Close();
                    stream.Close();
                }
            }
        }

        /// <summary>
        /// 工位事件
        /// </summary>
        /// <param name="listBtn"></param>
        public void DockingOpeare(List<Button> listBtn, int tag, string lineName)
        {
            while (true)
            {
                if (isChoseMat) { return; }
                ParallelLoopResult result2;
                bool bb = false;
                try
                {
                    Stopwatch sw2 = new Stopwatch();
                    List<Button> list = (List<Button>)listBtn;
                    //   TabPageTag tag = this.tabControl1.TabPages[i].Tag as TabPageTag;
                    DataTable dt = (list[0].Parent.Tag as TabPageTag).Table; //当前table  pack线.table
                    SiemensS7Net s7 = (list[0].Parent.Tag as TabPageTag).S7;
                    int type = (list[0].Parent.Tag as TabPageTag).ConnectType;
                    //     s7.SetPersistentConnection();
                    List<int> list2 = AGVIDWithPosByCheckPos.Values.ToList();
                    // while (true)
                    {
                        for (int i = 0; i < list.Count; i++)
                        //     result2 = Parallel.ForEach<Button>(list, new ParallelOptions { MaxDegreeOfParallelism = 8 }, btn =>
                        {
                            //if (list2.Contains((int)btn.Tag))
                            //{
                            //    IEnumerable<AGVInfoModel> temp = listModel.Where(o => o.MARKNUM.ToString() == btn.Tag.ToString() && o.ConnectStatus == true);
                            //    btn.Invoke(new InvokeDelegate(delegate
                            //    {
                            //        if (btn.BackColor != Color.FromKnownColor(KnownColor.Blue))
                            //        {
                            //            btn.BackColor = Color.Blue;


                            //        }
                            //    }));
                            //}
                            //else
                            List<AGVInfoModel> listModel = GlobalPara.AgvInfoDic.Values.ToList();

                            {

                                Button btn = list[i];
                                if (btn.Tag != null)
                                {
                                    //到站集合
                                    List<AGVInfoModel> temp = listModel.FindAll(o => o.MARKNUM.ToString() == btn.Tag.ToString() && o.ConnectStatus == true);

                                    IEnumerable<DataRow> query =  //当前table中到站集合
                                             from order in dt.AsEnumerable()
                                             where order["工位地标"].ToString() == btn.Tag.ToString()
                                             select order;
                                    if (temp != null && temp.Count() > 0)
                                    {

                                        if (lineName.Contains("气密"))
                                        {
                                            foreach (AGVInfoModel info in temp)
                                            {
                                                if (info.EollFlag == false)
                                                {
                                                    info.EollFlag = true;
                                                    WriteFile("EOL1-EOL2", "(地标：" + info.MARKNUM + ", " + ",车号:" + info.AGVNUM + ") ,开关打开,原因:读到整包地标");
                                                }
                                            }
                                        }
                                        //到站停止集合
                                        List<AGVInfoModel> temp2 = temp.FindAll(o => ((o.RUNSTATUS_Cur == 0x41 || o.RUNSTATUS_Cur == 0x46 || o.RUNSTATUS_Cur == 0x44 || (o.MARKFUN == 1 && o.ALARMINFO == "低电压报警"))
                                            && o.ConnectStatus == true && o.AGVNUM != 0));
                                        if (temp2.Count() > 0)
                                        {
                                            List<AGVInfoModel> infos = temp2.ToList();
                                            infos = infos.OrderByDescending(o => o.LastModifyMarkTime).ToList();
                                            AGVInfoModel info = infos[0];
                                            bool agvSame = true;
                                            bool needToNext = false;
                                            info.IsOutFlag = false;

                                            if (info.IsReachFlag == false && (info.MARKNUM != 65))
                                            {
                                                #region  MES 到岗上报
                                                StationInfo info1 = new StationInfo();
                                                info1.Mark = info.MARKNUM.ToString();
                                                info1.AGVNum = info.AGVNUM;
                                                info1.StationName = query.ToList()[0]["工位名称"].ToString();
                                                string address = "/AgvInfo/AgvArrival";
                                                PostPelletIdStatus(info1, address);
                                                info.IsReachFlag = true;

                                                info.AllowReleaseFlag = false;
                                                #endregion
                                                WriteFile("MES工位点记录-" + DateTime.Now.ToString("yyyy-MM-dd"), "小车到港记录:" + info.AGVNUM + ",地标:" + info1.Mark + "车号:" + info.AGVNUM + ",当前路线为:" + info.ROUTENUM + ",状态为" + info.RUNSTATUS_Cur);

                                            }

                                            string Test = "";
                                            #region 根据产品类型判断放行方法
                                            if (!string.IsNullOrEmpty(dtConfig.Rows[13][1].ToString()))
                                            {
                                                AGVInfo Agvinfo = new AGVInfo();

                                                string ProductType = "";
                                                bool flag = false;
                                                //        WriteFile("进站记录-" + DateTime.Now.ToString("yyyy-MM-dd"), "小车进站记录2:" + info.AGVNUM + ",地标:" + info.MARKNUM + ",ProductType" + Test + ",当前路线为:" + info.ROUTENUM + ",状态为" + info.RUNSTATUS_Cur + "dtConfig.Rows[13][1].ToString()" + dtConfig.Rows[13][1].ToString());

                                                if (info.MARKNUM.ToString().Equals(dtConfig.Rows[13][1].ToString()))  //到达分配点地标
                                                {


                                                    PLCSql.PLCMESSelect(info.AGVNUM.ToString(), "2", ref Agvinfo); //查询数据
                                                    ProductType = Agvinfo.ProductType;
                                                    Test = Agvinfo.ProductType;

                                                    WriteFile("65判断放行记录-" + DateTime.Now.ToString("yyyy-MM-dd"), "小车放行记录3:" + info.AGVNUM + ",地标:" + info.MARKNUM + ",ProductType" + Test + ",放行路线为:" + info.ROUTENUM + ",状态为" + info.RUNSTATUS_Cur + "dtConfig.Rows[13][1].ToString()" + dtConfig.Rows[13][1].ToString());

                                                    if (!string.IsNullOrEmpty(ProductType) && ProductType.Length > 3)
                                                    {
                                                        for (int i1 = 0; i1 < ProductTypeDt.Rows.Count; i1++)  //循环表
                                                        {
                                                            string route = "";
                                                            List<string> list1 = new List<string>();

                                                            if (ProductTypeDt.Rows[i1][0] != null)
                                                            {
                                                                route = ProductTypeDt.Rows[i1][0].ToString().Trim();
                                                            }

                                                            list1 = ProductTypeDt.Rows[i1][1].ToString().Trim().Split(';').ToList();

                                                            foreach (string type1 in list1)
                                                            {
                                                                int length = ProductType.Length;
                                                                String Type = ProductType.Substring(length - 3);
                                                                if (Type.StartsWith(type1) && route != "")
                                                                {
                                                                    DispatcherTool.ReleaseAgvOnStop(info.MARKNUM, int.Parse(route)); //根据路线放行
                                                                    flag = true;
                                                                }
                                                            }

                                                            if (flag)
                                                            {
                                                                break;
                                                            }

                                                        }
                                                    }

                                                }
                                            }
                                            #endregion

                                            //     WriteFile("进站记录-" + DateTime.Now.ToString("yyyy-MM-dd"), "小车进站记录4:" + info.AGVNUM + ",地标:" + info.MARKNUM + ",ProductType" + Test + ",当前路线为:" + info.ROUTENUM + ",状态为" + info.RUNSTATUS_Cur + "dtConfig.Rows[13][1].ToString()" + dtConfig.Rows[13][1].ToString());


                                            for (int ii = 0; ii < BoxMarkList.Count; ii++)
                                            {
                                                if (BoxMarkList[ii] == (info.MARKNUM.ToString()))
                                                {
                                                    MainWindow.ReadingStopPoint(info.MARKNUM, info.ROUTENUM);
                                                    break;
                                                }
                                            }

                                            if (lineName.Contains("EOL"))
                                            {
                                                if (dt.Columns.Contains("下一地标") && dt.Columns.Contains("随同地标"))
                                                {
                                                    if (query.ToList()[0]["下一地标"].ToString().Trim() != "0")
                                                    {
                                                        List<string> listCheck = query.ToList()[0]["随同地标"].ToString().Trim().Split(',').ToList();
                                                        listCheck.Add(query.ToList()[0]["下一地标"].ToString());

                                                        List<AGVInfoModel> temp3 = listModel.FindAll(o => listCheck.Contains(o.MARKNUM.ToString()) && o.ConnectStatus == true);
                                                        if (temp3.Count < 1)
                                                        {
                                                            if (info.EollFlag == true)
                                                            {
                                                                //   if ((DateTime.Now - info.LastStopMarkTime).TotalSeconds <= GlobalPara.EOLCheckSecs)
                                                                {
                                                                    needToNext = true;
                                                                    info.EollFlag = false;
                                                                    DispatcherTool.ReleaseAgvOnStop(info.MARKNUM, 0, int.Parse(query.ToList()[0]["下一地标"].ToString()), 5);
                                                                    WriteFile("EOL1-EOL2", "(放行地标：" + info.MARKNUM + ",放行路线：0" + ",下一地标:" + (query.ToList()[0]["下一地标"].ToString()) + ",车号:" + info.AGVNUM + ") ,开关:打开→关闭,原因:EOL1-EOL2");
                                                                }
                                                                //else
                                                                //{
                                                                //    info.EollFlag = false;
                                                                //    WriteFile("EOL1-EOL2", "(地标：" + info.MARKNUM + ", " + ",车号:" + info.AGVNUM + ") ,开关关闭,原因:判定时间超时");
                                                                //}
                                                            }
                                                            else
                                                            {
                                                                //        WriteFile("EOL1-EOL2", "(地标：" + info.MARKNUM + ", " + ",车号:" + info.AGVNUM + ") ,开关关闭,EOL1无法前往EOL2,原因:该AGV的开关为关闭状态");
                                                            }
                                                        }
                                                        else
                                                        {
                                                            if (info.EollFlag == true)
                                                            {
                                                                info.EollFlag = false;
                                                                WriteFile("EOL1-EOL2", "(地标：" + info.MARKNUM + ", " + ",车号:" + info.AGVNUM + ") ,开关:打开→关闭,原因:下一地标或者随同地标有车");
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                            //到站方法
                                            if (!needToNext)
                                            {
                                                btn.Invoke(new InvokeDelegate(delegate
                                                {


                                                    if (btn.Text.Contains("("))
                                                    {
                                                        int textIndex = btn.Text.LastIndexOf("(");
                                                        string agvnum = btn.Text.Substring(textIndex + 1).Replace(")", "");
                                                        if (agvnum != info.AGVNUM.ToString())
                                                        {
                                                            agvSame = false;
                                                        }
                                                    }
                                                    // if (btn.BackColor != Color.FromKnownColor(KnownColor.Yellow) || !agvSame)
                                                    {
                                                        if (AGVIDWithPosByCheckPos.ContainsKey(info.AGVNUM))
                                                        {
                                                            AGVIDWithPosByCheckPos.Remove(info.AGVNUM);
                                                        }
                                                        if (AGVIDWithRouteByCheckPos.ContainsKey(info.AGVNUM))
                                                        {

                                                            AGVIDWithRouteByCheckPos.Remove(info.AGVNUM);

                                                        }
                                                        if (AGVIDWithPosByCheckPosReal.ContainsKey(info.AGVNUM))
                                                        {
                                                            AGVIDWithPosByCheckPosReal.Remove(info.AGVNUM);
                                                        }
                                                        if (AGVIDWithPosByCheckPos.ContainsValue(info.MARKNUM))
                                                        {
                                                            for (int ab = AGVIDWithPosByCheckPos.Keys.Count - 1; ab >= 0; ab--)
                                                            {
                                                                if (AGVIDWithPosByCheckPos[AGVIDWithPosByCheckPos.Keys.ToList()[ab]] == info.MARKNUM)
                                                                {
                                                                    AGVIDWithPosByCheckPos.Remove(AGVIDWithPosByCheckPos.Keys.ToList()[ab]);
                                                                }
                                                            }
                                                        }
                                                        recordReleaseInfo();
                                                        //   result = s7.ConnectServer();
                                                        // result = DicPLCResult[s7];
                                                        // if (result != null && result.IsSuccess)
                                                        {
                                                            if (type == 1)
                                                            {
                                                                if (s7 != null)
                                                                {
                                                                    OperateResult rs = s7.Write(query.ToList()[0]["AGVDB"].ToString(), (byte)info.AGVNUM);

                                                                    OperateResult rs2 = null;
                                                                    if (info.ALARMCODE != "5")
                                                                    {
                                                                        rs2 = s7.Write(query.ToList()[0]["行驶状态DB"].ToString(), (byte)GlobalPara.DBRunValues.StopOnStation);
                                                                    }
                                                                    else //在工位上时 障碍物的状态也给停站状态
                                                                    {
                                                                        rs2 = s7.Write(query.ToList()[0]["行驶状态DB"].ToString(), (byte)GlobalPara.DBRunValues.StopOnStation);
                                                                    }
                                                                    s7.Write(query.ToList()[0]["故障DB"].ToString(), (byte)(int.Parse(info.ALARMCODE) - 1));

                                                                }
                                                            }
                                                            //  if (rs.IsSuccess && rs2.IsSuccess)
                                                            else if (type == 2)
                                                            {
                                                                //btn.BackColor = Color.Yellow;
                                                                //if (btn.Text.Contains("("))
                                                                //{
                                                                //    int textIndex = btn.Text.LastIndexOf("(");
                                                                //    string orignName = btn.Text.Substring(0, textIndex).Replace("\n", "");
                                                                //    btn.Text = orignName + "\n" + "(" + info.AGVNUM + ")";
                                                                //}
                                                                //else
                                                                //{
                                                                //    btn.Text = btn.Text.Replace("\n", "") + "\n" + "(" + info.AGVNUM + ")";
                                                                //}
                                                                lock (MesStations)
                                                                {
                                                                    var station = MesStations.Find(o => o["Mark"].ToString() == info.MARKNUM.ToString());
                                                                    if (station != null)
                                                                    {
                                                                        station["AGVID"] = info.AGVNUM;
                                                                        station["AGVStatus"] = 3;
                                                                        if (dt.Columns.Contains("目的地标"))
                                                                        {
                                                                            station["TargetMark"] = query.ToList()[0]["目的地标"].ToString();
                                                                        }
                                                                    }
                                                                }
                                                            }


                                                            {
                                                                btn.BackColor = Color.Yellow;
                                                                if (btn.Text.Contains("("))
                                                                {
                                                                    int textIndex = btn.Text.LastIndexOf("(");
                                                                    string orignName = btn.Text.Substring(0, textIndex).Replace("\n", "");
                                                                    btn.Text = orignName + "\n" + "(" + info.AGVNUM + ")";
                                                                }
                                                                else
                                                                {
                                                                    btn.Text = btn.Text.Replace("\n", "") + "\n" + "(" + info.AGVNUM + ")";
                                                                }
                                                            }
                                                        }

                                                    }
                                                    //   else

                                                    {



                                                        //OperateResult rs = GlobalPara.s7.Write(query.ToList()[0]["AGVDB"].ToString(), (byte)info.AGVNUM);
                                                        //OperateResult rs2 = null;
                                                        //if (info.ALARMCODE != "5")
                                                        //{
                                                        //    rs2 = GlobalPara.s7.Write(query.ToList()[0]["行驶状态DB"].ToString(), (byte)GlobalPara.DBRunValues.StopOnStation);
                                                        //}
                                                        //else //在工位上时 障碍物的状态也给停站状态
                                                        //{
                                                        //    rs2 = GlobalPara.s7.Write(query.ToList()[0]["行驶状态DB"].ToString(), (byte)GlobalPara.DBRunValues.StopOnStation);
                                                        //}
                                                        //GlobalPara.s7.Write(query.ToList()[0]["故障DB"].ToString(), (byte)(int.Parse(info.ALARMCODE) - 1));
                                                    }

                                                }));

                                                //  result = s7.ConnectServer();
                                                // result = DicPLCResult[s7];
                                                //   if (result != null && result.IsSuccess)
                                                if (s7 != null && type == 1)
                                                {

                                                    //if (dt.Columns.Contains("允许进入") && dt.Columns.Contains("正在进入"))
                                                    //{
                                                    //    var result1 = s7.ReadBool(query.ToList()[0]["允许进入"].ToString());
                                                    //    if (result1 != null && result1.IsSuccess)
                                                    //    {
                                                    //        s7.Write(query.ToList()[0]["正在进入"].ToString(), true);

                                                    //    }
                                                    //}

                                                    string releaseAddress = query.ToList()[0]["放行DB"].ToString();
                                                    OperateResult<byte> resultRead = s7.ReadByte(releaseAddress);
                                                    //if (resultRead.IsSuccess && DBWithByteValue.Keys.Contains(releaseAddress) &&
                                                    //   DBWithByteValue[releaseAddress] != resultRead.Content)
                                                    {
                                                        if (resultRead.Content == (byte)GlobalPara.DBControlValues.OKRelease)
                                                        {

                                                            {
                                                                DispatcherTool.ReleaseAgvOnStop(int.Parse(btn.Tag.ToString()),
                                                                    0, int.Parse(query.ToList()[0]["目的地标"].ToString()), 5);
                                                                lock (afterRelease)
                                                                {
                                                                    string tempStr = info.AGVNUM + ",1000,64";
                                                                    if (!afterRelease.Contains(tempStr))
                                                                    {
                                                                        afterRelease.Add(tempStr);
                                                                    }
                                                                }
                                                                lock (DBWithByteValue)
                                                                {
                                                                    DBWithByteValue[releaseAddress] = resultRead.Content;
                                                                }
                                                                WriteFile("工位点记录-" + DateTime.Now.ToString("yyyy-MM-dd"), "(放行地标：" + btn.Tag.ToString() + ",放行路线：0" + ",目的地标:" + (query.ToList()[0]["目的地标"].ToString()) + ",车号:" + info.AGVNUM + ") ");
                                                            }

                                                            //走OK放行路线
                                                        }
                                                        else if (resultRead.Content == (byte)GlobalPara.DBControlValues.NGRelease)
                                                        {

                                                            {

                                                                DispatcherTool.ReleaseAgvOnStop(int.Parse(btn.Tag.ToString()),
                                                                int.Parse(query.ToList()[0]["NG路线"].ToString()), 0, 5);
                                                                lock (afterRelease)
                                                                {
                                                                    string tempStr = info.AGVNUM + ",1000,64";
                                                                    if (!afterRelease.Contains(tempStr))
                                                                    {
                                                                        afterRelease.Add(tempStr);
                                                                    }
                                                                }
                                                                lock (DBWithByteValue)
                                                                {
                                                                    DBWithByteValue[releaseAddress] = resultRead.Content;
                                                                }
                                                                WriteFile("工位点记录-" + DateTime.Now.ToString("yyyy-MM-dd"), "(放行地标：" + btn.Tag.ToString() + ",放行路线：" + query.ToList()[0]["NG路线"].ToString() + ",车号:" + info.AGVNUM + ") ");

                                                            }
                                                        }
                                                        else
                                                        {
                                                            if (resultRead.Content != (byte)GlobalPara.DBControlValues.StopImmediate)
                                                            {
                                                                DBWithByteValue[releaseAddress] = resultRead.Content;
                                                            }

                                                        }
                                                    }
                                                }

                                            }
                                        }
                                        else //temp2.Count() < 0 不是停车状态
                                        {
                                            //停止点状态集合
                                            List<AGVInfoModel> temp3 = temp.FindAll(o => ((o.RUNSTATUS_Cur == 0x43 && o.ALARMCODE != "5") || o.RUNSTATUS_Cur == 0x47 || (o.MARKFUN == 1 && o.ALARMINFO == "低电压停机")) && o.ConnectStatus == true && o.AGVNUM != 0);
                                            if (temp3 != null && temp3.Count() > 0)
                                            {
                                                List<AGVInfoModel> infos = temp3.ToList();
                                                infos = infos.OrderByDescending(o => o.LastModifyMarkTime).ToList();
                                                AGVInfoModel info = infos[0];
                                                bool agvSame = true;
                                                btn.Invoke(new InvokeDelegate(delegate
                                                {
                                                    if (btn.Text.Contains("("))
                                                    {
                                                        int textIndex = btn.Text.LastIndexOf("(");
                                                        string agvnum = btn.Text.Substring(textIndex + 1).Replace(")", "");
                                                        if (agvnum != info.AGVNUM.ToString())
                                                        {
                                                            agvSame = false;
                                                        }
                                                    }
                                                    // if (btn.BackColor != Color.FromKnownColor(KnownColor.Red) || !agvSame)
                                                    {

                                                        //if (AGVIDWithPosByCheckPos.ContainsKey(info.AGVNUM))
                                                        //{
                                                        //    AGVIDWithPosByCheckPos.Remove(info.AGVNUM);
                                                        //}
                                                        //if (AGVIDWithRouteByCheckPos.ContainsKey(info.AGVNUM))
                                                        //{
                                                        //    AGVIDWithRouteByCheckPos.Remove(info.AGVNUM);
                                                        //}
                                                        //if (AGVIDWithPosByCheckPosReal.ContainsKey(info.AGVNUM))
                                                        //{
                                                        //    AGVIDWithPosByCheckPosReal.Remove(info.AGVNUM);
                                                        //}
                                                        //result = s7.ConnectServer();
                                                        //  result = DicPLCResult[s7];
                                                        if (type == 1)
                                                        {
                                                            if (info.RUNSTATUS_Cur == 0x43 || info.ALARMCODE != "")
                                                            {
                                                                if (s7 != null)
                                                                {
                                                                    OperateResult rs = s7.Write(query.ToList()[0]["AGVDB"].ToString(), (byte)info.AGVNUM);
                                                                    OperateResult rs2 = null;
                                                                    if (info.ALARMCODE != "5" && info.ALARMCODE != "0" && info.ALARMCODE != "9")
                                                                    {
                                                                        rs2 = s7.Write(query.ToList()[0]["行驶状态DB"].ToString(), (byte)GlobalPara.DBRunValues.Pause);
                                                                    }
                                                                    else
                                                                    {
                                                                        rs2 = s7.Write(query.ToList()[0]["行驶状态DB"].ToString(), (byte)GlobalPara.DBRunValues.Running);
                                                                    }
                                                                    s7.Write(query.ToList()[0]["故障DB"].ToString(), (byte)(int.Parse(info.ALARMCODE) - 1));
                                                                }
                                                                if (btn.BackColor != Color.FromKnownColor(KnownColor.Blue))
                                                                {
                                                                    //   if (rs.IsSuccess && rs2.IsSuccess)
                                                                    {
                                                                        btn.BackColor = Color.Red;
                                                                        if (btn.Text.Contains("("))
                                                                        {
                                                                            int textIndex = btn.Text.LastIndexOf("(");
                                                                            string orignName = btn.Text.Substring(0, textIndex).Replace("\n", "");
                                                                            btn.Text = orignName + "\n" + "(" + info.AGVNUM + ")";
                                                                        }
                                                                        else
                                                                        {
                                                                            btn.Text = btn.Text.Replace("\n", "") + "\n" + "(" + info.AGVNUM + ")";
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                        else if (type == 2)
                                                        {
                                                            //btn.BackColor = Color.Red;
                                                            //if (btn.Text.Contains("("))
                                                            //{
                                                            //    int textIndex = btn.Text.LastIndexOf("(");
                                                            //    string orignName = btn.Text.Substring(0, textIndex).Replace("\n", "");
                                                            //    btn.Text = orignName + "\n" + "(" + info.AGVNUM + ")";
                                                            //}
                                                            //else
                                                            //{
                                                            //    btn.Text = btn.Text.Replace("\n", "") + "\n" + "(" + info.AGVNUM + ")";
                                                            //}
                                                            lock (MesStations)
                                                            {
                                                                var station = MesStations.Find(o => o["Mark"].ToString() == info.MARKNUM.ToString());
                                                                if (station != null)
                                                                {
                                                                    station["AGVID"] = info.AGVNUM;
                                                                    if (info.ALARMCODE == "2")  //急停
                                                                    {
                                                                        station["AGVStatus"] = 4;
                                                                    }
                                                                    else if (info.ALARMCODE == "3") //机械防撞
                                                                    {
                                                                        station["AGVStatus"] = 5;
                                                                    }
                                                                    else if (info.ALARMCODE == "4") //驱动故障
                                                                    {
                                                                        station["AGVStatus"] = 6;
                                                                    }
                                                                    else if (info.ALARMCODE == "5")//传感器错误
                                                                    {
                                                                        station["AGVStatus"] = 7;
                                                                    }
                                                                    else if (info.ALARMCODE == "8") //脱线
                                                                    {
                                                                        station["AGVStatus"] = 8;
                                                                    }
                                                                    else
                                                                    {
                                                                        station["AGVStatus"] = 2; //暂停
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                    //   else
                                                    {
                                                        //OperateResult rs = GlobalPara.s7.Write(query.ToList()[0]["AGVDB"].ToString(), (byte)info.AGVNUM);
                                                        //OperateResult rs2 = null;
                                                        //if (info.ALARMCODE != "5" && info.ALARMCODE != "0" && info.ALARMCODE != "9")
                                                        //{
                                                        //    rs2 = GlobalPara.s7.Write(query.ToList()[0]["行驶状态DB"].ToString(), (byte)GlobalPara.DBRunValues.Pause);
                                                        //}
                                                        //else
                                                        //{
                                                        //    rs2 = GlobalPara.s7.Write(query.ToList()[0]["行驶状态DB"].ToString(), (byte)GlobalPara.DBRunValues.Running);
                                                        //}
                                                        //GlobalPara.s7.Write(query.ToList()[0]["故障DB"].ToString(), (byte)(int.Parse(info.ALARMCODE) - 1));
                                                    }
                                                }));
                                                if (info.RUNSTATUS_Cur == 0x43 || info.ALARMCODE == "1")
                                                {

                                                    if (info.AllowReleaseFlag == false)
                                                    {

                                                        #region  MES 急停上报
                                                        StationInfo info1 = new StationInfo();
                                                        info1.Mark = info.MARKNUM.ToString();
                                                        info1.AGVNum = info.AGVNUM;
                                                        info1.StationName = "ZBPL03_00R";
                                                        string address = "/AgvInfo/AgvOut";
                                                        PostPelletIdStatus3(info1, address);
                                                        info.AllowReleaseFlag = true;
                                                        #endregion
                                                        WriteFile("MES工位点记录-" + DateTime.Now.ToString("yyyy-MM-dd"), "小车急停记录:" + info.AGVNUM + ",地标:" + info1.Mark + "车号:" + info.AGVNUM + ",当前路线为:" + info.ROUTENUM + ",状态为" + info.RUNSTATUS_Cur);

                                                    }

                                                    //result = s7.ConnectServer();
                                                    //  result = DicPLCResult[s7];
                                                    //  if (result != null && result.IsSuccess)
                                                    if (s7 != null && type == 1)
                                                    {
                                                        string releaseAddress = query.ToList()[0]["放行DB"].ToString();
                                                        OperateResult<byte> resultRead = s7.ReadByte(releaseAddress);
                                                        //       if (resultRead.IsSuccess && DBWithByteValue.Keys.Contains(releaseAddress) &&
                                                        //          DBWithByteValue[releaseAddress] != resultRead.Content)
                                                        {
                                                            if (resultRead.Content == (byte)GlobalPara.DBControlValues.StopRelease)
                                                            {
                                                                lock (DBWithByteValue)
                                                                {
                                                                    DBWithByteValue[releaseAddress] = resultRead.Content;
                                                                }
                                                                DispatcherTool.ControlAGVBy1071(info.AGVNUM, 0);
                                                                //放行被暂停的车
                                                                WriteFile("急停记录", btn.Text + "工位被放行,已生成消息,当前放行地标:" + btn.Tag.ToString() + ",车号为:" + info.AGVNUM);
                                                            }
                                                            else if (resultRead.Content == (byte)GlobalPara.DBControlValues.OKRelease)
                                                            {
                                                                lock (DBWithByteValue)
                                                                {
                                                                    DBWithByteValue[releaseAddress] = resultRead.Content;
                                                                }
                                                                DispatcherTool.ReleaseAgvOnStop(int.Parse(btn.Tag.ToString()), int.Parse(query.ToList()[0]["放行路线"].ToString()));
                                                                //放行被暂停的车
                                                                WriteFile("工位点记录" + DateTime.Now.ToString("yyyy-MM-dd"), btn.Text + "工位被放行,已生成消息,当前放行地标:" + btn.Tag.ToString() + ",车号为:" + info.AGVNUM);
                                                            }
                                                            else
                                                            {
                                                                DBWithByteValue[releaseAddress] = resultRead.Content;
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                            else  //temp3.Count() < 0  不是停止点
                                            {
                                                //运行集合
                                                List<AGVInfoModel> temp4 = temp.FindAll(o => (o.RUNSTATUS_Cur == 0x40 || (o.RUNSTATUS_Cur == 0x41 && o.ALARMCODE == "5")) && o.ConnectStatus == true && o.AGVNUM != 0);
                                                if (temp4 != null && temp4.Count() > 0)
                                                {

                                                    List<AGVInfoModel> infos = temp4.ToList();
                                                    infos = infos.OrderByDescending(o => o.LastModifyMarkTime).ToList();
                                                    AGVInfoModel info = infos[0];
                                                    bool agvSame = true;

                                                    info.IsReachFlag = false;  //运行就解除

                                                    info.AllowMesReleaseFlag = false; //放行锁住


                                                    #region  MES 离港上报
                                                    StationInfo info1 = new StationInfo();
                                                    info1.Mark = info.MARKNUM.ToString();

                                                    foreach (DataRow dr in GlobalPara.dtSKQPLCs.Rows)
                                                    {
                                                        if (dr["工位地标"].ToString() == info.MARKNUM.ToString() && GlobalPara.ReleaseMarkList.Contains(info.MARKNUM.ToString()))   //
                                                        {
                                                            info1.StationName = dr["工位名称"].ToString();

                                                            if (info.MARKNUM == 63)
                                                            {
                                                                MainWindow.ReleaseStopPoint(36, 0);
                                                            }
                                                            else
                                                            {
                                                                MainWindow.ReleaseStopPoint(info.MARKNUM, 0);
                                                            }


                                                            GlobalPara.ReleaseMarkList.Remove(info.MARKNUM.ToString());

                                                            WriteFile("点灭放行盒记录" + DateTime.Now.ToString("yyyy-MM-dd"), btn.Text + "工位点灭2222,当前放行地标:" + btn.Tag.ToString() + ",车号为:" + info.AGVNUM);
                                                            break;

                                                        }
                                                    }

                                                    if (info.IsOutFlag == false && info.MARKNUM != 65)
                                                    {
                                                        string address = "/AgvInfo/AgvOut";
                                                        PostPelletIdStatus1(info1, address);

                                                        info.IsOutFlag = true;
                                                    }

                                                    #endregion

                                                    //foreach (string mark in GlobalPara.ReleaseMarkList)
                                                    //{
                                                    //    if (info.MARKNUM.ToString().Equals(mark))
                                                    //    {
                                                    //        MainWindow.ReleaseStopPoint(int.Parse(mark), 0);

                                                    //        GlobalPara.ReleaseMarkList.Remove(mark);

                                                    //        WriteFile("点灭放行盒记录" + DateTime.Now.ToString("yyyy-MM-dd"), btn.Text + "工位点灭2222,当前放行地标:" + btn.Tag.ToString() + ",车号为:" + info.AGVNUM);

                                                    //    }
                                                    //}




                                                    for (int i2 = 0; i2 < BoxMarkList.Count; i2++)
                                                    {
                                                        if (BoxMarkList[i2] == (info.MARKNUM.ToString()))
                                                        {
                                                            MainWindow.ReleaseStopPoint(info.MARKNUM, info.ROUTENUM);
                                                            break;
                                                        }
                                                    }

                                                    //  GlobalPara.ReleaseMarkList.Add(Mark);




                                                    btn.Invoke(new InvokeDelegate(delegate
                                                    {
                                                        if (btn.Text.Contains("("))
                                                        {
                                                            int textIndex = btn.Text.LastIndexOf("(");
                                                            string agvnum = btn.Text.Substring(textIndex + 1).Replace(")", "");
                                                            if (agvnum != info.AGVNUM.ToString())
                                                            {
                                                                agvSame = false;
                                                            }
                                                        }
                                                        //    if (( info.AGVRunningCount > 1) || !agvSame || (info.RUNSTATUS_Cur == 0x43 && info.ALARMCODE == "5"))
                                                        {

                                                            //if (AGVIDWithPosByCheckPos.ContainsKey(info.AGVNUM))
                                                            //{
                                                            //    AGVIDWithPosByCheckPos.Remove(info.AGVNUM);
                                                            //}
                                                            //if (AGVIDWithRouteByCheckPos.ContainsKey(info.AGVNUM))
                                                            //{
                                                            //    AGVIDWithRouteByCheckPos.Remove(info.AGVNUM);
                                                            //}
                                                            //if (AGVIDWithPosByCheckPosReal.ContainsKey(info.AGVNUM))
                                                            //{
                                                            //    AGVIDWithPosByCheckPosReal.Remove(info.AGVNUM);
                                                            //}
                                                            // if (info.AGVNUM != 0)
                                                            //{
                                                            //result = s7.ConnectServer();
                                                            // result = DicPLCResult[s7];
                                                            //  if (result != null && result.IsSuccess)
                                                            if (type == 1)
                                                            {
                                                                if (s7 != null)
                                                                {
                                                                    OperateResult rs = s7.Write(query.ToList()[0]["AGVDB"].ToString(), (byte)info.AGVNUM);
                                                                    OperateResult rs2 = null;
                                                                    rs2 = s7.Write(query.ToList()[0]["行驶状态DB"].ToString(), (byte)GlobalPara.DBRunValues.Running);
                                                                    s7.Write(query.ToList()[0]["故障DB"].ToString(), (byte)(int.Parse(info.ALARMCODE) - 1));
                                                                }
                                                                //}

                                                            }
                                                            else if (type == 2)
                                                            {
                                                                lock (MesStations)
                                                                {
                                                                    var station = MesStations.Find(o => o["Mark"].ToString() == info.MARKNUM.ToString());
                                                                    if (station != null)
                                                                    {
                                                                        station["AGVID"] = info.AGVNUM;
                                                                        station["AGVStatus"] = 1;
                                                                    }
                                                                }

                                                            }

                                                            if (btn.BackColor != Color.FromKnownColor(KnownColor.Blue))
                                                            {
                                                                //      if (rs.IsSuccess && rs2.IsSuccess)
                                                                {
                                                                    btn.BackColor = Color.Green;
                                                                    if (btn.Text.Contains("("))
                                                                    {
                                                                        int textIndex = btn.Text.LastIndexOf("(");
                                                                        string orignName = btn.Text.Substring(0, textIndex).Replace("\n", "");
                                                                        btn.Text = orignName + "\n" + "(" + info.AGVNUM + ")";
                                                                    }
                                                                    else
                                                                    {
                                                                        btn.Text = btn.Text.Replace("\n", "") + "\n" + "(" + info.AGVNUM + ")";
                                                                    }
                                                                }
                                                            }

                                                        }
                                                        //     else
                                                        {
                                                            //OperateResult rs = GlobalPara.s7.Write(query.ToList()[0]["AGVDB"].ToString(), (byte)info.AGVNUM);
                                                            //OperateResult rs2 = null;
                                                            //rs2 = GlobalPara.s7.Write(query.ToList()[0]["行驶状态DB"].ToString(), (byte)GlobalPara.DBRunValues.Running);
                                                            //GlobalPara.s7.Write(query.ToList()[0]["故障DB"].ToString(), (byte)(int.Parse(info.ALARMCODE) - 1));
                                                        }
                                                        if (query.ToList()[0]["放行DB"].ToString() == "DB200.2")
                                                        {
                                                            //           MessageBox.Show(info.AGVNUM.ToString() + ":" + info.RUNSTATUS_Cur.ToString());
                                                        }
                                                        if (info.RUNSTATUS_Cur == 0x40 || info.ALARMCODE == "1")
                                                        {
                                                            //result = s7.ConnectServer();
                                                            // result = DicPLCResult[s7];
                                                            // if (result != null && result.IsSuccess)
                                                            if (s7 != null)
                                                            {
                                                                string releaseAddress = query.ToList()[0]["放行DB"].ToString();
                                                                OperateResult<byte> resultRead = s7.ReadByte(releaseAddress);
                                                                //       if (resultRead.IsSuccess && DBWithByteValue.Keys.Contains(releaseAddress) &&
                                                                //           DBWithByteValue[releaseAddress] != resultRead.Content)
                                                                {
                                                                    if (resultRead.Content == (byte)GlobalPara.DBControlValues.StopImmediate)
                                                                    {
                                                                        lock (DBWithByteValue)
                                                                        {
                                                                            DBWithByteValue[releaseAddress] = resultRead.Content;
                                                                        }
                                                                        DispatcherTool.ControlAGVBy1071(info.AGVNUM, 1);
                                                                        //立刻暂停行驶中的车
                                                                        WriteFile("急停记录", btn.Text + "工位被暂停,已生成消息,当前急停地标:" + btn.Tag.ToString() + ",车号为:" + info.AGVNUM);
                                                                    }
                                                                    else
                                                                    {
                                                                        lock (DBWithByteValue)
                                                                        {
                                                                            DBWithByteValue[releaseAddress] = (byte)resultRead.Content;
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }));

                                                }
                                                else //temp4.Count() < 0
                                                {
                                                    btn.Invoke(new InvokeDelegate(delegate
                                                    {
                                                        if (tag >= 1)
                                                        {

                                                            if (AGVIDWithPosByCheckPos.ContainsValue(int.Parse(query.ToList()[0]["工位地标"].ToString())))
                                                            {
                                                                List<int> keys = AGVIDWithPosByCheckPos.Keys.ToList();
                                                                for (int a = 0; a < keys.Count; a++)
                                                                {
                                                                    if (AGVIDWithPosByCheckPos[keys[a]] == int.Parse(query.ToList()[0]["工位地标"].ToString()))
                                                                    {
                                                                        //       btn.Text = query.ToList()[0]["工位名称"].ToString() + "\n(" + keys[a] + ")";
                                                                        //       btn.BackColor = Color.Blue;
                                                                        break;
                                                                    }
                                                                }
                                                            }
                                                            else
                                                            {
                                                                if (btn.BackColor != Color.Blue && btn.BackColor != Color.FromKnownColor(KnownColor.Control))
                                                                {
                                                                    if (s7 != null)
                                                                    {
                                                                        OperateResult rs = s7.Write(query.ToList()[0]["AGVDB"].ToString(), (byte)0);
                                                                        OperateResult rs2 =
                                                                        s7.Write(query.ToList()[0]["行驶状态DB"].ToString(), (byte)GlobalPara.DBRunValues.Unknow);
                                                                        s7.Write(query.ToList()[0]["故障DB"].ToString(), (byte)0);
                                                                    }

                                                                    if (btn.BackColor != Color.FromKnownColor(KnownColor.Blue))
                                                                    {
                                                                        //     if (rs.IsSuccess && rs2.IsSuccess)
                                                                        {
                                                                            btn.BackColor = Color.FromKnownColor(KnownColor.Control);
                                                                            if (btn.Text.Contains("("))
                                                                            {
                                                                                int textIndex = btn.Text.LastIndexOf("(");
                                                                                string orignName = btn.Text.Substring(0, textIndex).Replace("\n", "");
                                                                                btn.Text = orignName;
                                                                            }

                                                                        }
                                                                    }


                                                                }
                                                            }
                                                        }
                                                        else if (tag == 0)
                                                        {


                                                            //result = s7.ConnectServer();
                                                            //result = DicPLCResult[s7];
                                                            //if (result != null && result.IsSuccess)
                                                            if (btn.BackColor != Color.FromKnownColor(KnownColor.Blue) && (btn.BackColor != Color.FromKnownColor(KnownColor.Control)))
                                                            {
                                                                btn.BackColor = Color.FromKnownColor(KnownColor.Control);
                                                                if (s7 != null)
                                                                {
                                                                    s7.Write(query.ToList()[0]["AGVDB"].ToString(), (byte)0);
                                                                    s7.Write(query.ToList()[0]["行驶状态DB"].ToString(), (byte)GlobalPara.DBRunValues.Unknow);
                                                                    s7.Write(query.ToList()[0]["故障DB"].ToString(), (byte)0);
                                                                }
                                                            }
                                                            if (AGVIDWithPosByCheckPos.ContainsValue(int.Parse(query.ToList()[0]["工位地标"].ToString())))
                                                            {
                                                                List<int> keys = AGVIDWithPosByCheckPos.Keys.ToList();
                                                                for (int a = 0; a < keys.Count; a++)
                                                                {
                                                                    if (AGVIDWithPosByCheckPos[keys[a]] == int.Parse(query.ToList()[0]["工位地标"].ToString()))
                                                                    {
                                                                        //  btn.Text = query.ToList()[0]["工位名称"].ToString() + "\n(" + keys[a] + ")";
                                                                        //  btn.BackColor = Color.Blue;
                                                                        break;
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }));
                                                    //result = s7.ConnectServer();
                                                    // result = DicPLCResult[s7];
                                                    // if (result != null && result.IsSuccess)
                                                    {
                                                        //string releaseAddress = query.ToList()[0]["放行DB"].ToString();
                                                        //OperateResult<byte> resultRead = s7.ReadByte(releaseAddress);
                                                        ////if (resultRead.IsSuccess && DBWithByteValue.Keys.Contains(releaseAddress) &&
                                                        ////   DBWithByteValue[releaseAddress] != resultRead.Content)
                                                        //{

                                                        //    {
                                                        //        if (resultRead.Content != (byte)GlobalPara.DBControlValues.StopImmediate)
                                                        //        {
                                                        //            DBWithByteValue[releaseAddress] = resultRead.Content;
                                                        //        }
                                                        //    }
                                                        //}
                                                    }
                                                }
                                            }
                                        }

                                    }
                                    else //emp.Count()< 0   不是到站集合
                                    {
                                        btn.Invoke(new InvokeDelegate(delegate
                                        {
                                            if (tag >= 1)
                                            {
                                                //if (btn.BackColor != Color.FromKnownColor(KnownColor.Control) &&
                                                //    btn.BackColor != Color.FromKnownColor(KnownColor.Blue))
                                                //  var rs3 = s7.ReadByte(query.ToList()[0]["AGVDB"].ToString());
                                                // if (rs3.Content != (byte)0)

                                                if (btn.BackColor != Color.FromKnownColor(KnownColor.Blue) && btn.BackColor != Color.FromKnownColor(KnownColor.Control))
                                                {
                                                    btn.BackColor = Color.FromKnownColor(KnownColor.Control);

                                                }
                                                if (btn.Text.Contains("("))
                                                {
                                                    int textIndex = btn.Text.LastIndexOf("(");
                                                    string orignName = btn.Text.Substring(0, textIndex).Replace("\n", "");
                                                    btn.Text = orignName;
                                                }

                                                {
                                                    if (type == 1)
                                                    {
                                                        if (s7 != null)
                                                        {
                                                            OperateResult rs = s7.Write(query.ToList()[0]["AGVDB"].ToString(), (byte)0);
                                                            OperateResult rs2 =
                                                            s7.Write(query.ToList()[0]["行驶状态DB"].ToString(), (byte)GlobalPara.DBRunValues.Unknow);
                                                            s7.Write(query.ToList()[0]["故障DB"].ToString(), (byte)0);
                                                        }
                                                    }
                                                    else if (type == 2)
                                                    {
                                                        lock (MesStations)
                                                        {
                                                            var station = MesStations.Find(o => o["Mark"].ToString() == btn.Tag.ToString());
                                                            if (station != null)
                                                            {
                                                                station["AGVID"] = 0;
                                                                station["AGVStatus"] = 0;
                                                            }
                                                        }

                                                    }

                                                }
                                            }
                                            else if (tag <= 0)
                                            {
                                                if (btn.BackColor != Color.FromKnownColor(KnownColor.Blue))
                                                {
                                                    btn.BackColor = Color.FromKnownColor(KnownColor.Control);
                                                }
                                                //result = s7.ConnectServer();
                                                // result = DicPLCResult[s7];
                                                // if (result != null && result.IsSuccess)
                                                if (s7 != null && type == 1)
                                                {
                                                    s7.Write(query.ToList()[0]["AGVDB"].ToString(), (byte)0);
                                                    s7.Write(query.ToList()[0]["行驶状态DB"].ToString(), (byte)GlobalPara.DBRunValues.Unknow);
                                                    s7.Write(query.ToList()[0]["故障DB"].ToString(), (byte)0);
                                                }
                                                if (type == 1 && AGVIDWithPosByCheckPos.ContainsValue(int.Parse(query.ToList()[0]["工位地标"].ToString())))
                                                {
                                                    List<int> keys = AGVIDWithPosByCheckPos.Keys.ToList();
                                                    for (int a = 0; a < keys.Count; a++)
                                                    {
                                                        if (AGVIDWithPosByCheckPos[keys[a]] == int.Parse(query.ToList()[0]["工位地标"].ToString()))
                                                        {
                                                            //    btn.Text = query.ToList()[0]["工位名称"].ToString() + "\n(" + keys[a] + ")";
                                                            //    btn.BackColor = Color.Blue;
                                                            break;
                                                        }
                                                    }
                                                }
                                            }
                                        }));
                                        //result = s7.ConnectServer();
                                        // result = DicPLCResult[s7];
                                        // if (result != null && result.IsSuccess)
                                        {
                                            //string releaseAddress = query.ToList()[0]["放行DB"].ToString();
                                            //OperateResult<byte> resultRead = s7.ReadByte(releaseAddress);
                                            ////if (resultRead.IsSuccess && DBWithByteValue.Keys.Contains(releaseAddress) &&
                                            ////   DBWithByteValue[releaseAddress] != resultRead.Content)
                                            //{
                                            //    if (resultRead.Content != (byte)GlobalPara.DBControlValues.StopImmediate)
                                            //    {
                                            //        DBWithByteValue[releaseAddress] = resultRead.Content;
                                            //    }
                                            //}
                                        }
                                    }
                                }
                            }
                        }//);
                        //     if (result2.IsCompleted)
                        {
                            sw2.Stop();
                            Console.WriteLine(dt.TableName + "任务总共花费{0}s.", sw.Elapsed.TotalSeconds);
                            object[] obj = new object[3];
                            obj[0] = listBtn; obj[1] = ++tag; obj[2] = lineName;
                            if (tag == 5)
                            {
                                if (!InitOK.ContainsKey(lineName))
                                {
                                    InitOK.Add(lineName, true);
                                    //        tag = 1;
                                }
                            }
                            if (tag > 5)
                            {
                                tag = 11;
                            }
                            //Thread.Sleep(20);
                            //Thread t2 = new Thread(new ParameterizedThreadStart(DockingOpeare0)); t2.IsBackground = true;
                            //t2.Priority = ThreadPriority.Highest;
                            //t2.Start(obj);

                            // DockingOpeare(list);
                        }

                    }
                }
                catch (Exception ex)
                {
                    //try
                    //{
                    //    DateTime time = DateTime.Now;
                    //    //MessageBox.Show("线程异常:"+e.ExceptionObject);
                    //    FileStream stream = File.Open(@"Exception\调度程序异常.txt", FileMode.Append, FileAccess.Write);
                    //    StreamWriter writer = new StreamWriter(stream);

                    //    //if (ex != null)
                    //    //{
                    //    //    string msg = string.Format("[{0}]Test:\r\nMessage:{1}\r\nStackTrace:\r\n{2}", time.ToString("yyyy-MM-dd HH:mm:ss"), ex.Message, ex.StackTrace);
                    //    //    writer.WriteLine(msg);
                    //    //    writer.Close();
                    //    //    stream.Close();
                    //    //}
                    //    bb = true;
                    //}
                    //catch (Exception)
                    //{
                    //}
                    //object[] obj = new object[3];
                    //obj[0] = listBtn; obj[1] = 0; obj[2] = lineName;
                    //Thread.Sleep(500);
                    //new Thread(new ParameterizedThreadStart(DockingOpeare0)).Start(obj);
                }
                finally
                {
                    //if (bb)
                    //{
                    //    object[] obj = new object[3];
                    //    obj[0] = listBtn; obj[1] = 0; obj[2] = lineName;
                    //    Thread.Sleep(500);
                    //    Thread t2 = new Thread(new ParameterizedThreadStart(DockingOpeare0)); t2.IsBackground = true;
                    //    t2.Priority = ThreadPriority.Highest;
                    //    t2.Start(obj);
                    //    //     WriteFile("线程重启", "DockingOpeare0报错，已重启!");
                    //}
                    if (!DockingOK)// && InitOK.Count == LineDt.Rows.Count)
                    {
                        DockingOK = true;
                        Thread t2 = new Thread(new ThreadStart(checkingOperate)); t2.IsBackground = true;
                        t2.Priority = ThreadPriority.BelowNormal;
                        t2.Start();
                        Thread t3 = new Thread(new ThreadStart(TrafficByDispatch)); t3.IsBackground = true;
                        t3.Priority = ThreadPriority.AboveNormal;
                        t3.Start();
                        //Thread t4 = new Thread(new ThreadStart(ReleaseBoxLight)); t4.IsBackground = true;
                        //t4.Priority = ThreadPriority.AboveNormal;
                        //t4.Start();
                    }
                }
                Thread.Sleep(500);
            }
        }


        /// <summary>
        /// 下线上传方法
        /// </summary>
        /// <param name="agvNum"></param>
        public void AGVDownMethod(StationInfo infos)
        {
            string url = "http://10.197.244.100:10057/AgvInfo/AgvBindMes";

            AGVInfo info = new AGVInfo();
            PLCSql.PLCMESSelect(infos.AGVNum.ToString(), "2", ref info);  //查询数据

            info.Time = DateTime.Now;
            info.Behavior = 2;

            bool res = WcsApi.Post(url, null, info, out string data, out string msg);
            string str = $"下线上报：{res}，信息：{msg}，数据：{data}";

            if (!string.IsNullOrEmpty(info.ProductType))
            {
                PLCSql.PLCSqlMES(infos.AGVNum.ToString(), "", "", "", "3");  //解绑
            }

            if (GlobalPara.AgvInfoDic.ContainsKey(infos.AGVNum))
            {
                var agv = GlobalPara.AgvInfoDic.FirstOrDefault(o => o.Key == infos.AGVNum).Value;
                OutTraffic(agv);
            }

            string Responses = $"当前下线AGV信息：工站名={info.stationName},mark ={infos.Mark}, AGVID = {info.AgvCode}，ProductCode = {info.ProductCode}，HolderBarCode = {info.HolderBarCode}，ProductType = {info.ProductType},返回时间 = {DateTime.Now.ToString()}";//，产品个数 = {products.Count}

            WriteFile("下线上报-" + DateTime.Now.ToString("yyyy-MM-dd"), Responses);

        }

        public void OutTraffic(AGVInfoModel agv)
        {
            if (agv.TRAFFICNUM.Count > 0)
            {
                List<TrafficAreaModel> templist = new List<TrafficAreaModel>();
                templist.AddRange(agv.TRAFFICNUM);
                foreach (TrafficAreaModel traffic in templist)
                {
                    //踢出管制区
                    //tt.OutTraffic(agv);
                    int a1 = agv.ReleaseCount;
                    traffic.AGVLEAVE(agv);//管制区有AGV离开
                    int a = agv.ReleaseCount;
                    if (traffic.listAgvQueue.Count > 0)
                    {
                        traffic.ReleaseAgv(); //调用放行事件
                    }
                    agv.TRAFFICNUM.Remove(traffic);//清空之前，先做一些处理。让AGV退出的那些管制区解除管制状态。

                    string astr = string.Format("管制状态{0}--{1}", agv.TrafficFlag, agv.ReleaseCount);
                }
            }

        }



        public void ReleaseBoxLight()
        {
            try
            {

                while (true)
                {
                    for (int i = 0; i < GlobalPara.dtSKQPLCs.Rows.Count; i++)
                    {
                        DataRow dr = (DataRow)GlobalPara.dtSKQPLCs.Rows[i];

                        string mark = dr["工位地标"].ToString();

                        List<AGVInfoModel> listModel = GlobalPara.AgvInfoDic.Values.ToList();

                        var results = listModel.Find(o => o.MARKNUM.ToString() == mark && o.ConnectStatus == true && (o.RUNSTATUS_Cur == 0x40));  //工位运行就发

                        if (results != null)
                        {

                            MainWindow.ReleaseStopPoint(int.Parse(mark), 0);  //点灭放行盒

                            if (GlobalPara.ReleaseMarkList.Contains(mark))
                            {
                                GlobalPara.ReleaseMarkList.Remove(mark);

                            }

                            WriteFile("点灭放行盒记录" + DateTime.Now.ToString("yyyy-MM-dd"), "ReleaseBoxLight点灭放行盒,当前放行地标:" + results.MARKNUM + ",车号为:" + results.AGVNUM);
                        }

                        Thread.Sleep(500);
                    }
                }
            }
            //}
            catch (Exception ex)
            {
                WriteFile("调度程序异常" + DateTime.Now.ToString("yyyy-MM-dd"), "ReleaseBoxLight点灭放行盒失败" + ex.Message);

            }
        }

        public void PostPelletIdStatus1(StationInfo infos, string ApiAdress)
        {
            string address = "http://10.197.244.100:10057";

            string url = address + ApiAdress;
            string id = DateTime.Now.ToString("yyyyMMddhhmmssffff");
            string s = $"123 {id}";

            AGVInfo info = GetStationInfo1(infos.Mark);

            if (info.AgvCode != 0)
            {
                info.stationName = infos.StationName;
                info.Time = DateTime.Now;


                bool res = WcsApi.Post(url, null, info, out string data, out string msg);

                string str = $"离港上报：{res}，信息：{msg}，数据：{data}";

                string Responses = $"离港AGV信息：工站名={info.stationName},mark ={infos.Mark}, AGVID = {info.AgvCode}，ProductCode = {info.ProductCode}，HolderBarCode = {info.HolderBarCode}，ProductType = {info.ProductType},返回时间 = {DateTime.Now.ToString()}";//，产品个数 = {products.Count}


                WriteFile("离港上报-" + DateTime.Now.ToString("yyyy-MM-dd"), Responses);

                WriteFile("MES工位点记录-" + DateTime.Now.ToString("yyyy-MM-dd"), Responses + str);
            }


        }

        public AGVInfo GetStationInfo1(string statiom)
        {
            AGVInfo Agvinfo = new AGVInfo();

            try
            {

                {
                    List<AGVInfoModel> listModel = GlobalPara.AgvInfoDic.Values.ToList();

                    List<AGVInfoModel> temp4 = listModel.FindAll(o => (o.MARKNUM.ToString() == statiom && o.ConnectStatus == true && o.AGVNUM != 0));
                    if (temp4 != null && temp4.Count() > 0)
                    {
                        List<AGVInfoModel> infos = temp4.ToList();
                        infos = infos.OrderByDescending(o => o.LastModifyMarkTime).ToList();

                        AGVInfoModel info = infos[0];

                        if (info != null)  //&& info.IsOutFlag
                        {
                            PLCSql.PLCMESSelect(info.AGVNUM.ToString(), "2", ref Agvinfo);
                        }

                    }

                }
            }
            catch (Exception ex)
            {

            }

            return Agvinfo;

        }


        void WriteFile(string fileName, string context)
        {
            try
            {
                lock (portLock)
                {
                    DateTime time = DateTime.Now;
                    //MessageBox.Show("线程异常:"+e.ExceptionObject);
                    FileStream stream = File.Open(@"Exception\" + fileName + ".txt", FileMode.Append, FileAccess.Write);
                    StreamWriter writer = new StreamWriter(stream);


                    {
                        string msg = string.Format("[{0}]Test:\r\nMessage:{1}\r\n", time.ToString("yyyy-MM-dd HH:mm:ss"), context);
                        writer.WriteLine(msg);
                        writer.Close();
                        stream.Close();
                    }
                }
            }
            catch (Exception)
            {
            }
        }

        void tabControl1_DrawItem(object sender, DrawItemEventArgs e)
        {
            Graphics g = e.Graphics;
            Font font = new Font("微软雅黑", 16f, System.Drawing.GraphicsUnit.Pixel);
            SolidBrush brush = new SolidBrush(Color.Black);
            if (e.Index == this.tabControl1.SelectedIndex)
            {
                brush = new SolidBrush(Color.Blue);
            }

            RectangleF rectangle = (RectangleF)(tabControl1.GetTabRect(e.Index));
            RectangleF rectangle2 = new RectangleF(rectangle.X, rectangle.Y, rectangle.Width, rectangle.Height);
            g.FillRectangle(new SolidBrush(SystemColors.ButtonHighlight), rectangle2);
            StringFormat sformat = new StringFormat();
            sformat.LineAlignment = StringAlignment.Center;
            sformat.Alignment = StringAlignment.Center;
            g.DrawString(((TabControl)sender).TabPages[e.Index].Text, font, brush, rectangle2, sformat);

        }

        /// <summary>
        /// 获取心跳包
        /// </summary>
        private void PLCHeartBit()
        {
            while (!isChoseMat)
            {
                List<SiemensS7Net> list = DicPLC.Values.ToList();
                foreach (SiemensS7Net s7 in list)
                {
                    if (!string.IsNullOrEmpty(heartBitList2[list.IndexOf(s7)]))
                    {
                        PLCResult = s7.ReadByte(dtConfig.Rows[4][1].ToString()); //PLC心跳记录
                        if (PLCResult != null && PLCResult.IsSuccess)
                        {
                            //        OperateResult<byte> tempResult = GlobalPara.s7.ReadByte(dtConfig.Rows[1][4].ToString());
                            if (PLCResult != null && PLCResult.IsSuccess)
                            {
                                if (PLCResult.Content != PLCHeartBitCount)
                                {
                                    //result = s7.ConnectServer();
                                    result = DicPLCResult[s7];
                                    PLCHeartBitCount = PLCResult.Content;
                                    HeartBitFlag = true;
                                    if (IsPLCChangeOff)
                                    {
                                        //重新给PLC工位信息，只写不读
                                        Dictionary<Thread, object[]> listThread = new Dictionary<Thread, object[]>();
                                        for (int i = 0; i < tabControl1.TabPages.Count; i++)
                                        {
                                            // object[] obj = new object[3];
                                            //obj[0] = (tabControl1.TabPages[i].Tag as TabPageTag).ListBtn; obj[1] = 0; obj[2] = tabControl1.TabPages[i].Text;
                                            //   listThread.Add(new Thread(new ParameterizedThreadStart(DockingOpeareForPLCReOpen)), obj);
                                        }
                                        //foreach (Thread t in listThread.Keys)
                                        //{
                                        //    t.IsBackground = true;
                                        //    t.Priority = ThreadPriority.Highest;
                                        //    t.Start(listThread[t]);
                                        //}
                                        IsPLCChangeOff = false;
                                    }
                                }
                                else
                                {
                                    lock (DicPLCResult)
                                    {
                                        DicPLCResult[s7] = s7.ConnectServer();
                                    }
                                    //            HeartBitFlag = false;
                                    IsPLCChangeOff = true;
                                }
                            }
                        }
                        else
                        {
                            lock (DicPLCResult)
                            {
                                DicPLCResult[s7] = s7.ConnectServer();
                            }
                            //    HeartBitFlag = false;
                            IsPLCChangeOff = true;
                        }
                    }
                    Thread.Sleep(2000);
                }
            }
        }

        /// <summary>
        /// 发送心跳包
        /// </summary>
        private void HeartBit()
        {
            try
            {
                while (!isChoseMat)
                {
                    if (HeartBitFlag)
                    {
                        //更新心跳包
                        List<SiemensS7Net> list = DicPLC.Values.ToList();
                        for (int i = 0; i < list.Count; i++)
                        {
                            SiemensS7Net s7 = list[i];
                            if (s7 == null) { continue; }
                            OperateResult result = null;
                            if (DicPLCResult.ContainsKey(s7))
                            {
                                result = DicPLCResult[s7];
                            }
                            if (result == null || !result.IsSuccess)
                            {
                                if (s7 != null)
                                {
                                    lock (DicPLCResult)
                                    {
                                        DicPLCResult[s7] = result = s7.ConnectServer();
                                    }
                                }
                                if (result == null || !result.IsSuccess)
                                {
                                    //statusStrip1.Invoke(new InvokeDelegate(delegate
                                    //{
                                    //    if (i == 0)
                                    //    {
                                    //        toolStripStatusLabel1.Text = s7.IpAddress + "," + " " + "PLC连接失败";
                                    //    }
                                    //    else
                                    //    {
                                    //        toolStripStatusLabel1.Text += ";" + s7.IpAddress + "," + " " + "PLC连接失败";
                                    //    }
                                    //}));
                                }
                                else
                                {
                                    // this.Invoke(new InvokeDelegate(delegate
                                    // {
                                    //    if (i == 0)
                                    //         {
                                    //             toolStripStatusLabel1.Text = s7.IpAddress + "," + " " + "PLC连接成功";
                                    //         }
                                    //         else
                                    //         {
                                    //             toolStripStatusLabel1.Text += ";"+s7.IpAddress + "," + " " + "PLC连接成功";
                                    //         }
                                    // }
                                    //));
                                }
                            }
                            else
                            {
                                if (result != null && result.IsSuccess)
                                {
                                    var tempResult = s7.Write(heartBitList[i], (byte)HeartBitCount);
                                    if (tempResult.IsSuccess)
                                    {
                                        if (i == list.Count - 1)
                                        {
                                            HeartBitCount++;
                                        }
                                        if (HeartBitCount > 0xFF)
                                        {
                                            HeartBitCount = 1;
                                        }
                                        //statusStrip1.Invoke(new InvokeDelegate(delegate
                                        //{
                                        //    if (i == 0)
                                        //    {
                                        //        toolStripStatusLabel1.Text = s7.IpAddress + "," + " " + "PLC连接成功";
                                        //    }
                                        //    else
                                        //    {
                                        //        toolStripStatusLabel1.Text += ";"+s7.IpAddress + "," + " " + "PLC连接成功";
                                        //    }
                                        //}
                                        //));
                                    }
                                    else
                                    {
                                        // this.Invoke(new InvokeDelegate(delegate
                                        //{
                                        //    if (i == 0)
                                        //    {
                                        //        toolStripStatusLabel1.Text = s7.IpAddress + "," + " " + "PLC连接失败";
                                        //    }
                                        //    else
                                        //    {
                                        //        toolStripStatusLabel1.Text += ";" + s7.IpAddress + "," + " " + "PLC连接失败";
                                        //    }
                                        //}
                                        //));
                                    }
                                }
                            }
                        }
                        for (int i = 0; i < list.Count; i++)
                        {
                            this.Invoke(new InvokeDelegate(delegate
                           {
                               if (i == 0)
                               {
                                   toolStripStatusLabel1.Text = list[i].IpAddress + "," + " " + "PLC连接" + (DicPLCResult[list[i]].IsSuccess ? "成功" : "失败");
                               }
                               else
                               {
                                   toolStripStatusLabel1.Text += ";" + list[i].IpAddress + "," + " " + "PLC连接" + (DicPLCResult[list[i]].IsSuccess ? "成功" : "失败");
                               }
                               if ((DicPLCResult[list[i]].IsSuccess))
                               {
                                   PLCTestAlarm = false;
                               }
                               else
                               {
                                   PLCTestAlarm = true;
                               }
                           }
                           ));
                        }
                        Thread.Sleep(500);
                    }
                }
            }
            catch (Exception)
            {

            }
        }

        public void DockingOpeareForPLCReOpen(object o)
        {
            object[] obj = (object[])o;
            DockingOpeareForPLCReOpen((List<Button>)obj[0], (int)obj[1], (string)obj[2]);
        }

        /// <summary>
        /// 工位事件
        /// </summary>
        /// <param name="listBtn"></param>
        public void DockingOpeareForPLCReOpen(List<Button> listBtn, int tag, string lineName)
        {
            if (isChoseMat) { return; }
            ParallelLoopResult result2;
            bool bb = false;
            try
            {
                Stopwatch sw2 = new Stopwatch();
                List<Button> list = (List<Button>)listBtn;
                //   TabPageTag tag = this.tabControl1.TabPages[i].Tag as TabPageTag;
                DataTable dt = (list[0].Parent.Tag as TabPageTag).Table;
                SiemensS7Net s7 = (list[0].Parent.Tag as TabPageTag).S7;
                List<AGVInfoModel> listModel = GlobalPara.AgvInfoDic.Values.ToList();
                List<int> list2 = AGVIDWithPosByCheckPos.Values.ToList();
                {
                    //       for (int i = 0; i < list.Count; i++)
                    result2 = Parallel.ForEach<Button>(list, new ParallelOptions { MaxDegreeOfParallelism = 1 }, btn =>
                    {
                        {
                            {
                                IEnumerable<AGVInfoModel> temp = listModel.Where(o => o.MARKNUM.ToString() == btn.Tag.ToString() && o.ConnectStatus == true);
                                IEnumerable<DataRow> query =
                                         from order in dt.AsEnumerable()
                                         where order["工位地标"].ToString() == btn.Tag.ToString()
                                         select order;
                                if (temp.Count() > 0)
                                {

                                    IEnumerable<AGVInfoModel> temp2 = temp.Where(o => ((o.RUNSTATUS_Cur == 0x41 || o.RUNSTATUS_Cur == 0x44 || o.RUNSTATUS_Cur == 0x46 || (o.MARKFUN == 1 && o.ALARMINFO == "低电压报警"))
                                        && o.ConnectStatus == true && o.AGVNUM != 0));
                                    if (temp2.Count() > 0)
                                    {
                                        List<AGVInfoModel> infos = temp2.ToList();
                                        AGVInfoModel info = infos[0];
                                        btn.Invoke(new InvokeDelegate(delegate
                                        {
                                            //   if (btn.BackColor != Color.FromKnownColor(KnownColor.Yellow))
                                            {



                                                if (AGVIDWithRouteByCheckPos.ContainsKey(info.AGVNUM))
                                                {
                                                    AGVIDWithRouteByCheckPos.Remove(info.AGVNUM);
                                                }
                                                if (AGVIDWithPosByCheckPos.ContainsKey(info.AGVNUM))
                                                {
                                                    AGVIDWithPosByCheckPos.Remove(info.AGVNUM);
                                                }
                                                if (AGVIDWithPosByCheckPos.ContainsValue(info.MARKNUM))
                                                {
                                                    for (int ab = AGVIDWithPosByCheckPos.Keys.Count - 1; ab >= 0; ab--)
                                                    {
                                                        if (AGVIDWithPosByCheckPos[AGVIDWithPosByCheckPos.Keys.ToList()[ab]] == info.MARKNUM)
                                                        {
                                                            AGVIDWithPosByCheckPos.Remove(AGVIDWithPosByCheckPos.Keys.ToList()[ab]);
                                                        }
                                                    }
                                                }
                                                recordReleaseInfo();
                                                //result = s7.ConnectServer();
                                                result = DicPLCResult[s7];
                                                if (result != null && result.IsSuccess)
                                                {
                                                    OperateResult rs = s7.Write(query.ToList()[0]["AGVDB"].ToString(), (byte)info.AGVNUM);
                                                    OperateResult rs2 = null;
                                                    if (info.ALARMCODE != "5")
                                                    {
                                                        rs2 = s7.Write(query.ToList()[0]["行驶状态DB"].ToString(), (byte)GlobalPara.DBRunValues.StopOnStation);
                                                    }
                                                    else //在工位上时 障碍物的状态也给停站状态
                                                    {
                                                        rs2 = s7.Write(query.ToList()[0]["行驶状态DB"].ToString(), (byte)GlobalPara.DBRunValues.StopOnStation);
                                                    }
                                                    s7.Write(query.ToList()[0]["故障DB"].ToString(), (byte)(int.Parse(info.ALARMCODE) - 1));
                                                    if (rs.IsSuccess && rs2.IsSuccess)
                                                    {
                                                        btn.BackColor = Color.Yellow;
                                                        if (btn.Text.Contains("("))
                                                        {
                                                            int textIndex = btn.Text.LastIndexOf("(");
                                                            string orignName = btn.Text.Substring(0, textIndex).Replace("\n", "");
                                                            btn.Text = orignName + "\n" + "(" + info.AGVNUM + ")";
                                                        }
                                                        else
                                                        {
                                                            btn.Text = btn.Text.Replace("\n", "") + "\n" + "(" + info.AGVNUM + ")";
                                                        }
                                                    }
                                                }
                                            }
                                        }));
                                    }
                                    else
                                    {
                                        IEnumerable<AGVInfoModel> temp3 = temp.Where(o => (o.RUNSTATUS_Cur == 0x43 || (o.MARKFUN == 1 && o.ALARMINFO == "低电压停机")) && o.ConnectStatus == true && o.AGVNUM != 0);
                                        if (temp3.Count() > 0)
                                        {
                                            AGVInfoModel info = temp3.ToList()[0];
                                            btn.Invoke(new InvokeDelegate(delegate
                                            {
                                                if (btn.BackColor != Color.FromKnownColor(KnownColor.Red))
                                                {
                                                    //result = s7.ConnectServer();
                                                    result = DicPLCResult[s7];
                                                    if (result != null && result.IsSuccess && info.ALARMCODE != "")
                                                    {
                                                        OperateResult rs = s7.Write(query.ToList()[0]["AGVDB"].ToString(), (byte)info.AGVNUM);
                                                        OperateResult rs2 = null;
                                                        if (info.ALARMCODE != "5" && info.ALARMCODE != "0" && info.ALARMCODE != "9")
                                                        {
                                                            rs2 = s7.Write(query.ToList()[0]["行驶状态DB"].ToString(), (byte)GlobalPara.DBRunValues.Pause);
                                                        }
                                                        else
                                                        {
                                                            rs2 = s7.Write(query.ToList()[0]["行驶状态DB"].ToString(), (byte)GlobalPara.DBRunValues.Running);
                                                        }
                                                        s7.Write(query.ToList()[0]["故障DB"].ToString(), (byte)(int.Parse(info.ALARMCODE) - 1));
                                                        //   if (btn.BackColor != Color.FromKnownColor(KnownColor.Blue))
                                                        {
                                                            if (rs.IsSuccess && rs2.IsSuccess)
                                                            {
                                                                btn.BackColor = Color.Red;
                                                                if (btn.Text.Contains("("))
                                                                {
                                                                    int textIndex = btn.Text.LastIndexOf("(");
                                                                    string orignName = btn.Text.Substring(0, textIndex).Replace("\n", "");
                                                                    btn.Text = orignName + "\n" + "(" + info.AGVNUM + ")";
                                                                }
                                                                else
                                                                {
                                                                    btn.Text = btn.Text.Replace("\n", "") + "\n" + "(" + info.AGVNUM + ")";
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }));
                                            //    if (info.ALARMCODE == "1")
                                            {

                                            }
                                        }
                                        else
                                        {
                                            IEnumerable<AGVInfoModel> temp4 = temp.Where(o => o.RUNSTATUS_Cur == 0x40 && o.ConnectStatus == true && o.AGVNUM != 0);
                                            if (temp4.Count() > 0)
                                            {
                                                AGVInfoModel info = temp4.ToList()[0];
                                                btn.Invoke(new InvokeDelegate(delegate
                                                {
                                                    // if (btn.BackColor != Color.FromKnownColor(KnownColor.Green))
                                                    {

                                                        //result = s7.ConnectServer();
                                                        result = DicPLCResult[s7];
                                                        if (result != null && result.IsSuccess)
                                                        {
                                                            OperateResult rs = s7.Write(query.ToList()[0]["AGVDB"].ToString(), (byte)info.AGVNUM);
                                                            OperateResult rs2 = null;
                                                            rs2 = s7.Write(query.ToList()[0]["行驶状态DB"].ToString(), (byte)GlobalPara.DBRunValues.Running);
                                                            s7.Write(query.ToList()[0]["故障DB"].ToString(), (byte)(int.Parse(info.ALARMCODE) - 1));

                                                            //}
                                                            if (btn.BackColor != Color.FromKnownColor(KnownColor.Blue))
                                                            {
                                                                if (rs.IsSuccess && rs2.IsSuccess)
                                                                {
                                                                    btn.BackColor = Color.Green;
                                                                    if (btn.Text.Contains("("))
                                                                    {
                                                                        int textIndex = btn.Text.LastIndexOf("(");
                                                                        string orignName = btn.Text.Substring(0, textIndex).Replace("\n", "");
                                                                        btn.Text = orignName + "\n" + "(" + info.AGVNUM + ")";
                                                                    }
                                                                    else
                                                                    {
                                                                        btn.Text = btn.Text.Replace("\n", "") + "\n" + "(" + info.AGVNUM + ")";
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }));
                                            }
                                            else
                                            {
                                                btn.Invoke(new InvokeDelegate(delegate
                                                {
                                                    if (tag >= 1)
                                                    {

                                                        if (AGVIDWithPosByCheckPos.ContainsValue(int.Parse(query.ToList()[0]["工位地标"].ToString())))
                                                        {
                                                            List<int> keys = AGVIDWithPosByCheckPos.Keys.ToList();
                                                            for (int a = 0; a < keys.Count; a++)
                                                            {
                                                                if (AGVIDWithPosByCheckPos[keys[a]] == int.Parse(query.ToList()[0]["工位地标"].ToString()))
                                                                {
                                                                    btn.Text = query.ToList()[0]["工位名称"].ToString() + "\n(" + keys[a] + ")";
                                                                    btn.BackColor = Color.Blue;
                                                                    break;
                                                                }
                                                            }
                                                        }
                                                        else
                                                        {
                                                            //     if (btn.BackColor != Color.FromKnownColor(KnownColor.Control))
                                                            {
                                                                OperateResult rs = s7.Write(query.ToList()[0]["AGVDB"].ToString(), (byte)0);
                                                                OperateResult rs2 =
                                                                s7.Write(query.ToList()[0]["行驶状态DB"].ToString(), (byte)GlobalPara.DBRunValues.Unknow);
                                                                s7.Write(query.ToList()[0]["故障DB"].ToString(), (byte)0);
                                                                if (btn.BackColor != Color.FromKnownColor(KnownColor.Blue))
                                                                {
                                                                    if (rs.IsSuccess && rs2.IsSuccess)
                                                                    {
                                                                        btn.BackColor = Color.FromKnownColor(KnownColor.Control);
                                                                        if (btn.Text.Contains("("))
                                                                        {
                                                                            int textIndex = btn.Text.LastIndexOf("(");
                                                                            string orignName = btn.Text.Substring(0, textIndex).Replace("\n", "");
                                                                            btn.Text = orignName;
                                                                        }

                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                    else if (tag == 0)
                                                    {
                                                        //result = s7.ConnectServer();
                                                        result = DicPLCResult[s7];
                                                        btn.BackColor = Color.FromKnownColor(KnownColor.Control);
                                                        if (result != null && result.IsSuccess)
                                                        {
                                                            s7.Write(query.ToList()[0]["AGVDB"].ToString(), (byte)0);
                                                            s7.Write(query.ToList()[0]["行驶状态DB"].ToString(), (byte)GlobalPara.DBRunValues.Unknow);
                                                            s7.Write(query.ToList()[0]["故障DB"].ToString(), (byte)0);
                                                        }
                                                        if (AGVIDWithPosByCheckPos.ContainsValue(int.Parse(query.ToList()[0]["工位地标"].ToString())))
                                                        {
                                                            List<int> keys = AGVIDWithPosByCheckPos.Keys.ToList();
                                                            for (int a = 0; a < keys.Count; a++)
                                                            {
                                                                if (AGVIDWithPosByCheckPos[keys[a]] == int.Parse(query.ToList()[0]["工位地标"].ToString()))
                                                                {
                                                                    btn.Text = query.ToList()[0]["工位名称"].ToString() + "\n(" + keys[a] + ")";
                                                                    btn.BackColor = Color.Blue;
                                                                    break;
                                                                }
                                                            }
                                                        }
                                                    }
                                                }));
                                            }
                                        }
                                    }

                                }
                                else
                                {
                                    //btn.Invoke(new InvokeDelegate(delegate
                                    //{
                                    //    if (tag >= 1)
                                    //    {
                                    //        if (btn.BackColor != Color.FromKnownColor(KnownColor.Control) &&
                                    //            btn.BackColor != Color.FromKnownColor(KnownColor.Blue))
                                    //        {
                                    //            OperateResult rs = GlobalPara.s7.Write(query.ToList()[0]["AGVDB"].ToString(), (byte)0);
                                    //            OperateResult rs2 =
                                    //            GlobalPara.s7.Write(query.ToList()[0]["行驶状态DB"].ToString(), (byte)GlobalPara.DBRunValues.Unknow);
                                    //            GlobalPara.s7.Write(query.ToList()[0]["故障DB"].ToString(), (byte)0);
                                    //            if (rs.IsSuccess && rs2.IsSuccess)
                                    //            {
                                    //                btn.BackColor = Color.FromKnownColor(KnownColor.Control);
                                    //                if (btn.Text.Contains("("))
                                    //                {
                                    //                    int textIndex = btn.Text.LastIndexOf("(");
                                    //                    string orignName = btn.Text.Substring(0, textIndex).Replace("\n", "");
                                    //                    btn.Text = orignName;
                                    //                }
                                    //            }
                                    //        }
                                    //    }
                                    //    else if (tag <= 0)
                                    //    {
                                    //        btn.BackColor = Color.FromKnownColor(KnownColor.Control);
                                    //        if (result != null && result.IsSuccess)
                                    //        {
                                    //            GlobalPara.s7.Write(query.ToList()[0]["AGVDB"].ToString(), (byte)0);
                                    //            GlobalPara.s7.Write(query.ToList()[0]["行驶状态DB"].ToString(), (byte)GlobalPara.DBRunValues.Unknow);
                                    //            GlobalPara.s7.Write(query.ToList()[0]["故障DB"].ToString(), (byte)0);
                                    //        }
                                    //        if (AGVIDWithPosByCheckPos.ContainsValue(int.Parse(query.ToList()[0]["工位地标"].ToString())))
                                    //        {
                                    //            List<int> keys = AGVIDWithPosByCheckPos.Keys.ToList();
                                    //            for (int a = 0; a < keys.Count; a++)
                                    //            {
                                    //                if (AGVIDWithPosByCheckPos[keys[a]] == int.Parse(query.ToList()[0]["工位地标"].ToString()))
                                    //                {
                                    //                    btn.Text = query.ToList()[0]["工位名称"].ToString() + "\n(" + keys[a] + ")";
                                    //                    btn.BackColor = Color.Blue;
                                    //                    break;
                                    //                }
                                    //            }
                                    //        }
                                    //    }
                                    //}));
                                }
                            }
                        }
                    });
                    //  if (result2.IsCompleted)
                    {
                        sw2.Stop();
                        Console.WriteLine(dt.TableName + "任务总共花费{0}s.", sw.Elapsed.TotalSeconds);
                        object[] obj = new object[3];
                        obj[0] = listBtn; obj[1] = ++tag; obj[2] = lineName;
                        if (tag < 3)
                        {
                            Thread.Sleep(100);
                            Thread t2 = new Thread(new ParameterizedThreadStart(DockingOpeareForPLCReOpen)); t2.IsBackground = true;
                            t2.Priority = ThreadPriority.Highest;
                            t2.Start(obj);
                        }
                        // DockingOpeare(list);
                    }

                }
            }
            catch (Exception ex)
            {
                DateTime time = DateTime.Now;
                //MessageBox.Show("线程异常:"+e.ExceptionObject);
                FileStream stream = File.Open(@"Exception\调度程序异常.txt", FileMode.Append, FileAccess.Write);
                StreamWriter writer = new StreamWriter(stream);

                if (ex != null)
                {
                    string msg = string.Format("[{0}]Test:\r\nMessage:{1}\r\nStackTrace:\r\n{2}", time.ToString("yyyy-MM-dd HH:mm:ss"), ex.Message, ex.StackTrace);
                    writer.WriteLine(msg);
                    writer.Close();
                    stream.Close();
                }
                bb = true;

            }
            finally
            {
                //if (bb)
                //{
                //    object[] obj = new object[3];
                //    obj[0] = listBtn; obj[1] = 0; obj[2] = lineName;
                //    Thread.Sleep(100);
                //    Thread t2 = new Thread(new ParameterizedThreadStart(DockingOpeare0)); t2.IsBackground = true;
                //    t2.Priority = ThreadPriority.BelowNormal;
                //    t2.Start(obj);
                //}
                //if (!DockingOK && InitOK.Count == LineDt.Rows.Count)
                //{
                //    DockingOK = true;
                //    Thread t2 = new Thread(new ThreadStart(checkingOperate)); t2.IsBackground = true;
                //    t2.Priority = ThreadPriority.BelowNormal;
                //    t2.Start();
                //    Thread t3 = new Thread(new ThreadStart(TrafficByDispatch)); t3.IsBackground = true;
                //    t3.Priority = ThreadPriority.AboveNormal;
                //    t3.Start();

                //}
            }
        }
        /// <summary>
        /// 处理调度的协议
        /// </summary>
        private void Analzye()
        {
            while (!isChoseMat)
            {
                try
                {
                    if (GlobalPara.dispatchList.Count > 0)
                    {
                        byte[] bytes = GlobalPara.dispatchList[0];
                        if (bytes != null)
                        {
                            AnalzyeBytes(bytes);
                            Console.WriteLine("调度模块收到数据:" + GlobalPara.ByteToHexString(bytes));
                            if (GlobalPara.dispatchList.Contains(bytes))
                            {
                                GlobalPara.dispatchList.Remove(bytes);
                            }
                        }
                        else
                        {
                            if (GlobalPara.dispatchList.Contains(bytes))
                            {
                                GlobalPara.dispatchList.Remove(bytes);
                            }
                        }
                    }
                }
                catch (Exception)
                {
                }
                Thread.Sleep(50);
            }
        }
        public void AnalzyeBytes(byte[] bytes)
        {
            try
            {
                if (bytes != null && bytes.Length >= 14 && bytes[0] == 0xAA && bytes[1] == 0x11 && bytes[bytes.Length - 1] == 0xAB)
                {
                    int agvnum = (int)bytes[5];
                    if (GlobalPara.isSingleControl && GlobalPara.SingleSWAGVNum == agvnum && lastSWAGVNum != agvnum)
                    {
                        lastSWAGVNum = agvnum;
                        if (bytes[2] == 0x22)
                        {
                            MessageBox.Show(agvnum + "号AGV休眠成功！");
                        }
                        else if (bytes[2] == 0x32)
                        {
                            MessageBox.Show(agvnum + "号AGV唤醒成功！");
                        }
                    }
                    else if (!GlobalPara.isSingleControl)
                    {
                        if (bytes[2] == 0x22)
                        {
                            if (!GlobalPara.SleepAGVNumList.Contains(agvnum))
                            {
                                GlobalPara.SleepAGVNumList.Add(agvnum);
                            }
                            if (GlobalPara.WakeUpAGVNumList.Contains(agvnum))
                            {
                                GlobalPara.WakeUpAGVNumList.Remove(agvnum);
                            }
                        }
                        else if (bytes[2] == 0x32)
                        {
                            if (!GlobalPara.WakeUpAGVNumList.Contains(agvnum))
                            {
                                GlobalPara.WakeUpAGVNumList.Add(agvnum);
                            }
                            if (GlobalPara.SleepAGVNumList.Contains(agvnum))
                            {
                                GlobalPara.SleepAGVNumList.Remove(agvnum);
                            }
                        }
                    }
                }
                else if (bytes != null && bytes.Length >= 14 && bytes[0] == 0x10 && bytes[1] == 0x37)
                {
                    int agvnum = (int)bytes[11];
                    if (GlobalPara.AgvInfoDic.ContainsKey(agvnum))
                    {
                        AGVInfoModel agvinfo = GlobalPara.AgvInfoDic[agvnum];
                        if (agvinfo.RUNSTATUS_Cur != 0x43)
                        {
                            agvinfo.RUNSTATUS_Cur = 0x43;
                            agvinfo.ConnectStatus = true;
                            agvinfo.OffLineCount = 0;
                        }

                        for (int i = 0; i < BoxMarkList.Count; i++)
                        {
                            if (BoxMarkList[i] == (agvinfo.MARKNUM.ToString()))
                            {
                                DispatcherTool.ReleaseAgvOnStop(agvinfo.MARKNUM, agvinfo.ROUTENUM, 0, 1);

                                break;
                            }
                        }
                    }
                    else
                    {
                        // for (int i = 0; i < BoxMarkList.Count; i++)
                        {
                            //if (BoxMarkList[i] == (agvinfo.MARKNUM.ToString()))
                            {
                                DispatcherTool.ReleaseAgvOnStop((int)bytes[9], 0, 0, 1);

                                //      break;
                            }
                        }
                    }
                }
                else if (bytes != null && bytes.Length >= 14 && bytes[0] == 0x10 && bytes[1] == 0x38)
                {
                    int agvnum = (int)bytes[11];
                    if (GlobalPara.AgvInfoDic.ContainsKey(agvnum))
                    {
                        AGVInfoModel agvinfo = GlobalPara.AgvInfoDic[agvnum];
                        if (agvinfo.RUNSTATUS_Cur != 0x40)
                        {
                            agvinfo.RUNSTATUS_Cur = 0x40;
                            agvinfo.ConnectStatus = true;
                            agvinfo.OffLineCount = 0;
                        }
                    }
                }
                else if (bytes != null && bytes.Length >= 14 && bytes[0] == 0x10 && bytes[1] == 0x55)
                {
                    bytes[1] = 0x56;
                    byte checkSum = 0x00;
                    for (int i = 0; i < 12; i++)
                    {
                        checkSum ^= bytes[i];
                    }
                    bytes[12] = checkSum;
                    //GlobalPara.communication.SendData(bytes, null);
                }
            }
            catch (Exception ex)
            {

            }
        }

        //时间超时
        void timer_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
        {
            //throw new NotImplementedException();
            try
            {
                lock (afterRelease)
                {
                    if (afterRelease.Count > 0 && !isChoseMat)
                    {
                        for (int i = afterRelease.Count - 1; i >= 0; i--)
                        {
                            string[] temps = afterRelease[i].Split(',');
                            double limitedTime = double.Parse(temps[1]);
                            if (limitedTime > 0)
                            {
                                limitedTime -= timer.Interval;
                                afterRelease[i] = temps[0] + "," + limitedTime + "," + temps[2];
                            }
                            else
                            {
                                int agvnum = int.Parse(temps[0]);
                                int statu = int.Parse(temps[2]);
                                if (GlobalPara.AgvInfoDic.ContainsKey(agvnum))
                                {
                                    AGVInfoModel agvinfo = GlobalPara.AgvInfoDic[agvnum];
                                    if (agvinfo.RUNSTATUS_Cur != statu)
                                    {
                                        //        if (GlobalPara.IsNeedToReplyPLCImmediately)
                                        {
                                            agvinfo.RUNSTATUS_Cur = statu;
                                            agvinfo.AGVRunningCount = 5;
                                            agvinfo.ConnectStatus = true;
                                        }
                                    }
                                }
                                afterRelease.RemoveAt(i);
                            }
                        }
                    }
                    else  //afterRelease.Count < 0 
                    {
                        //lock (afterRelease)
                        //{
                        //    string tempStr = "1,1000,64";
                        //    string[] temps = tempStr.Split(',');
                        //    int agvnum = int.Parse(temps[0]);
                        //    int statu = int.Parse(temps[2]);

                        //    if (GlobalPara.AgvInfoDic.ContainsKey(agvnum))
                        //    {
                        //        AGVInfoModel agvinfo = GlobalPara.AgvInfoDic[agvnum];
                        //        if (agvinfo.RUNSTATUS_Cur != 0)
                        //        {
                        //            agvinfo.RUNSTATUS_Cur = 0;
                        //            agvinfo.ConnectStatus = true;
                        //        } 
                        //    }
                        //    if (!afterRelease.Contains(tempStr))
                        //    {
                        //        afterRelease.Add(tempStr); 
                        //    }

                        //}
                    }
                }
            }
            catch (Exception)
            {

            }

            try
            {
                lock (listObjs)
                {
                    //  List<int> list = new List<int>();
                    if (listObjs.Count > 0)
                    {
                        for (int i = listObjs.Count - 1; i >= 0; i--)
                        {
                            int Secs = (int)listObjs[i]["Secs"];
                            if (Secs > 0) { Secs = Secs - (int)timer.Interval; listObjs[i]["Secs"] = Secs; }
                            else
                            {
                                listObjs.RemoveAt(i);
                            }
                        }
                    }
                }
                lock (GlobalPara.ListReleaseObj)
                {
                    if (GlobalPara.ListReleaseObj.Count > 0)
                    {
                        List<AGVInfoModel> listModel = GlobalPara.AgvInfoDic.Values.ToList();
                        for (int i = GlobalPara.ListReleaseObj.Count - 1; i >= 0; i--)
                        {
                            var temp = listModel.Find(o => o.ConnectStatus && o.AGVNUM == GlobalPara.ListReleaseObj[i].AGVNUM&&o.RUNSTATUS_Cur==0x41);
                            if (temp != null)
                            {
                                DispatcherTool.ReleaseAgvOnStop(GlobalPara.ListReleaseObj[i].MARKNUM, 0, 0, 1);
                            }
                            else
                            {
                                GlobalPara.ListReleaseObj.RemoveAt(i);
                            }
                        }
                    }
                }
            }
            catch (Exception)
            {

            }
        }

        private void 异常解除ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            RemoveError RemoveErrorForm = new RemoveError();
            RemoveErrorForm.button1.Click += new EventHandler(button1_Click);
            RemoveErrorForm.Load += new EventHandler(RemoveErrorForm_Load);

            RemoveErrorForm.Owner = this;
            RemoveErrorForm.ShowDialog();

        }

        void RemoveErrorForm_Load(object sender, EventArgs e)
        {
            RemoveError RemoveErrorForm = (RemoveError)(sender);
            RemoveErrorForm.InitView(AGVIDWithPosByCheckPos, AGVIDWithRouteByCheckPos, checkPosDic);
            if (RemoveErrorForm.listCreateBtns.Count > 0)
            {
                foreach (Button btn in RemoveErrorForm.listCreateBtns)
                {
                    btn.Click += new EventHandler(RemoveErrorForm_btn_Click);
                }
            }
        }

        void RemoveErrorForm_btn_Click(object sender, EventArgs e)
        {
            Button btn = (Button)sender;
            RemoveError RemoveErrorForm = ((RemoveError)(btn.FindForm()));
            int AGVNUM = int.Parse(btn.Tag.ToString());
            if (MessageBox.Show("是否要解除" + AGVNUM + "号AGV锁定?", "警告", MessageBoxButtons.YesNo) == System.Windows.Forms.DialogResult.Yes)
            {
                if (AGVIDWithRouteByCheckPos.ContainsKey(AGVNUM))
                {
                    AGVIDWithRouteByCheckPos.Remove(AGVNUM);
                }
                if (AGVIDWithPosByCheckPos.ContainsKey(AGVNUM))
                {
                    AGVIDWithPosByCheckPos.Remove(AGVNUM);
                }
                if (AGVIDWithPosByCheckPosReal.ContainsKey(AGVNUM))
                {
                    AGVIDWithPosByCheckPosReal.Remove(AGVNUM);
                }
                recordReleaseInfo();
                for (int i = 0; i < tabControl1.TabPages.Count; i++)
                {
                    Button temp = (tabControl1.TabPages[i].Tag as TabPageTag).ListBtn.Find(o => o.Text.Contains("(" + AGVNUM + ")") && o.BackColor == Color.Blue);
                    if (temp != null)
                    {
                        temp.BackColor = Color.FromKnownColor(KnownColor.Control);
                        if (temp.Text.Contains("("))
                        {
                            temp.Text = temp.Text.Replace("\n", "").Substring(0, temp.Text.LastIndexOf("(") - 1);
                        }
                        break;
                    }
                }

                RemoveErrorForm.button1.PerformClick();
            }

        }

        void button1_Click(object sender, EventArgs e)
        {
            RemoveError RemoveErrorForm = ((RemoveError)(((Button)sender).FindForm()));
            RemoveErrorForm.InitView(AGVIDWithPosByCheckPos, AGVIDWithRouteByCheckPos, checkPosDic);
            if (RemoveErrorForm.listCreateBtns.Count > 0)
            {
                foreach (Button btn in RemoveErrorForm.listCreateBtns)
                {
                    btn.Click += new EventHandler(RemoveErrorForm_btn_Click);
                }
            }
        }

        public void SKQPLC()
        {
            for (int i = 0; i < dtSKQPLC.Rows.Count; i++)
            {
                if (dtSKQPLC.Columns.Contains("请求出门DB"))
                {
                    if (!string.IsNullOrEmpty(dtSKQPLC.Rows[i]["请求出门DB"].ToString()))
                    {
                        if (!GlobalPara.plcs.ContainsKey(dtSKQPLC.Rows[i]))
                        {
                            SiemensS7Net s7 = new SiemensS7Net(SiemensPLCS.S1500, dtSKQPLC.Rows[i]["IP地址"].ToString());
                            s7.Rack = (byte)0;
                            s7.Slot = (byte)1;
                            s7.ConnectTimeOut = 500;
                            s7.ReceiveTimeOut = 500;
                            s7.SetPersistentConnection();
                            GlobalPara.plcs.Add(dtSKQPLC.Rows[i], s7);
                        }
                    }
                }
                MyTest.ManagedThreadPoolcs.ManagedThreadPool.QueueUserWorkItem(new WaitCallback(Test), dtSKQPLC.Rows[i]);
                //      Thread.Sleep(50);
            }


            // MyTest.ManagedThreadPoolcs.ManagedThreadPool.QueueUserWorkItem(new WaitCallback(Test), dtTestPLC.Rows[i]); //PLC工站/

           // Thread thread = new Thread(new ThreadStart(Test1));
           // thread.Start();


            //      Thread.Sleep(50);c
            //for (int i = 0; i < dtBigzPLC.Rows.Count; i++)
            //{
            //    MyTest.ManagedThreadPoolcs.ManagedThreadPool.QueueUserWorkItem(new WaitCallback(Test), dtBigzPLC.Rows[i]);
            //    //      Thread.Sleep(50);
            //}
        }

        public byte[] ExcuteSKQMES(System.Net.Sockets.Socket SocketClient, byte[] bytes)
        {
            String resultRead1 = "";
            String resultRead2 = "";
            byte[] result = null;
            try
            {
                {
                    if (bytes.Length >= 8 && bytes[0] == 0x4A && bytes[1] == 0x54 && bytes[2] == 0x58)//帧开头
                    {
                        int dataLength = (int)bytes[3];
                        List<byte> list = new List<byte>();
                        for (int i = 0; i < 4 + dataLength + 2; i++)
                        {
                            list.Add(bytes[i]);
                        }
                        // byte[] CRC = DispatcherTool.CRC16(list.ToArray());
                        //       if (CRC[0] == bytes[4 + dataLength] && CRC[1] == bytes[5 + dataLength])//校验通过
                        {
                            List<byte> listSend = new List<byte>();
                            //GlobalPara.listSKQMes.Add(DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss") + "接收数据来自:" + SocketClient.RemoteEndPoint.ToString() + ",数据是 " + DispatcherTool.ByteToHexString(list.ToArray()));
                            WriteFile("SKQMES对接记录" + DateTime.Now.ToString("yyyy-MM-dd"), DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss") + "接收数据来自:" + SocketClient.RemoteEndPoint.ToString() + ",数据是 " + DispatcherTool.ByteToHexString(list.ToArray()));
                            switch (bytes[4])
                            {
                                case 0xE1://询问工位状态

                                    listSend.Add(0XD1);
                                    if (bytes[5] == 0)
                                    {
                                        foreach (var station in MesStations)
                                        {
                                            listSend.Add((byte)station["Mark"]);
                                            listSend.Add((byte)station["Status"]);
                                            listSend.Add((byte)station["AGVID"]);
                                            listSend.Add((byte)station["AGVStatus"]);
                                        }
                                    }
                                    else
                                    {
                                        var station = MesStations.Find(o => o["Mark"].ToString() == bytes[5].ToString());
                                        if (station != null)
                                        {
                                            listSend.Add((byte)station["Mark"]);
                                            listSend.Add((byte)station["Status"]);
                                            listSend.Add((byte)station["AGVID"]);
                                            listSend.Add((byte)station["AGVStatus"]);
                                        }
                                    }
                                    break;
                                case 0xE2://询问AGV状态
                                    listSend.Add(0XD2);
                                    var agv = GlobalPara.AgvInfoDic.Values.ToList().Find(o => o.AGVNUM == ((int)bytes[5]));
                                    var agv2 = MesStations.Find(o => o["AGVID"].ToString() == bytes[5].ToString());
                                    if (agv != null && agv2 != null)
                                    {
                                        listSend.Add((byte)agv.AGVNUM);
                                        listSend.Add((byte)agv2["AGVStatus"]);
                                        if (agv.ConnectStatus)
                                        {
                                            listSend.Add((byte)1);
                                        }
                                        else
                                        {
                                            listSend.Add((byte)0);
                                        }
                                        listSend.Add((byte)agv.MARKNUM);
                                        listSend.Add((byte)0);
                                        listSend.Add((byte)agv2["ID"]);
                                        listSend.Add((byte)0);
                                        listSend.Add((byte)0);
                                        listSend.Add(SpeedOptByte[agv.SPEEDLEVEL]);
                                        listSend.Add((byte)((int)agv.Battery_Power));
                                    }
                                    break;
                                case 0xE3://控制工位状态
                                    for (int i = 5; i < 4 + dataLength; i = i + 2)
                                    {
                                        lock (MesStations)
                                        {
                                            var station = MesStations.Find(o => o["Mark"].ToString() == bytes[i].ToString());
                                            if (station != null)
                                            {
                                                //if (station.Property("TargetMark") != null)
                                                //{
                                                //    DispatcherTool.ReleaseAgvOnStop((int)bytes[i], 0, int.Parse(station["TargetMark"].ToString()));

                                                //   // DispatcherTool.ReleaseAgvOnStop(info.MARKNUM, 0, 10);
                                                //}
                                                //else
                                                //{
                                                DispatcherTool.ReleaseAgvOnStop((int)bytes[i], 0);
                                                //}
                                                //   WriteFile("SKQMES人工位放行信号" + DateTime.Now.ToString("yyyy-MM-dd"), "在放行点" + (int)station[i]["Mark"] + "上放行！");

                                                // station["Status"] = (int)bytes[i + 1];
                                                //if ((int)bytes[i + 1] == 2)//启动
                                                //{
                                                //    DispatcherTool.ControlAGVBy1071((int)bytes[i], 0);
                                                //}
                                                //else if ((int)bytes[i + 1] == 3)//暂停
                                                //{
                                                //    DispatcherTool.ControlAGVBy1071((int)bytes[i], 1);
                                                //}

                                                listSend.Add(0xF3); listSend.Add(0x01);
                                            }
                                            else
                                            {
                                                listSend.Add(0xF3); listSend.Add(0x00);
                                            }
                                        }
                                    }

                                    break;
                                case 0xE4://控制AGV站点状态
                                    var station3 = MesStations.FindAll(o => o["AGVID"].ToString() == bytes[5].ToString() && bytes[5] != 0);
                                    if (station3 != null)
                                    {
                                        //     var temp = MesStations.Find(o => o["Mark"].ToString() == bytes[6].ToString());
                                        //     if (temp != null)
                                        for (int i = 0; i < station3.Count; i++)
                                        {
                                            //         station2["TargetStation"] = temp["Mark"];
                                            DispatcherTool.ReleaseAgvOnStop((int)station3[i]["Mark"], 0, (int)bytes[6]);

                                            WriteFile("SKQMES人工位放行信号" + DateTime.Now.ToString("yyyy-MM-dd"), "在放行点" + (int)station3[i]["Mark"] + "上放行！");
                                        }



                                    }

                                    listSend.Add(0XF4); listSend.Add(0x01);
                                    break;
                                case 0xE5://控制AGV状态
                                    var station2 = MesStations.Find(o => o["AGVID"].ToString() == bytes[5].ToString());
                                    if (station2 != null)
                                    {
                                        int status = (int)bytes[6];
                                        if (status == 2 || status == 4)
                                        {
                                            DispatcherTool.ControlAGVBy1071((int)station2["AGVID"], 1);
                                            //WriteFile("SKQMES人工位停止信号" + DateTime.Now.ToString("yyyy-MM-dd"), "车子编号"+(int)station2["AGVID"]+"上放行！");
                                        }
                                        else if (status == 1)
                                        {
                                            DispatcherTool.ControlAGVBy1071((int)station2["AGVID"], 0);
                                            //WriteFile("SKQMES人工位放行信号" + DateTime.Now.ToString("yyyy-MM-dd"), "在放行点"+(int)station3[i]["Mark"]+"上放行！");

                                        }

                                    }
                                    listSend.Add(0XF5); listSend.Add(0x01);
                                    break;
                                case 0xE6://控制AGV速度
                                    station2 = MesStations.Find(o => o["AGVID"].ToString() == bytes[5].ToString());
                                    if (station2 != null)
                                    {
                                        int speedd = (int)bytes[6];
                                        if (speedd > 0 && speedd <= 30)
                                        {
                                            DispatcherTool.ControlAGVBy1071((int)station2["AGVID"], 0, 1);
                                        }
                                        else if (speedd > 30 && speedd <= 60)
                                        {
                                            DispatcherTool.ControlAGVBy1071((int)station2["AGVID"], 0, 2);
                                        }
                                        else if (speedd > 60)
                                        {
                                            DispatcherTool.ControlAGVBy1071((int)station2["AGVID"], 0, 3);
                                        }
                                    }
                                    listSend.Add(0XF6); listSend.Add(0x01);
                                    break;
                                case 0xE7://发送SN1码
                                    listSend.Add(0xB1);
                                    //var agvID1 = MesStations.Find(o => o["AGVID"].ToString() == bytes[5].ToString());
                                    //if (agvID1 != null)
                                    //{
                                    PLCSql.PLCSqlSelect(bytes[5].ToString(), "2", ref resultRead1, ref resultRead2); //查询数据
                                    if (resultRead1 != "")
                                    {
                                        listSend.Add(bytes[5]);
                                        byte[] byteArray = System.Text.Encoding.Default.GetBytes(resultRead1);
                                        listSend.AddRange(byteArray.ToArray());
                                        string s = DispatcherTool.ByteToHexString(byteArray.ToArray());
                                        WriteFile("查询SN记录", "AGVID+" + bytes[5].ToString() + "SN1DB+" + resultRead1 + "SN2DB+" + resultRead2 + DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss"));

                                    }


                                    break;
                                case 0xE8://发送SN2码
                                    listSend.Add(0xB2);
                                    PLCSql.PLCSqlSelect(bytes[5].ToString(), "2", ref resultRead1, ref resultRead2); //查询数据
                                    if (resultRead2 != "")
                                    {
                                        listSend.Add(bytes[5]);
                                        byte[] byteArray = System.Text.Encoding.Default.GetBytes(resultRead2);
                                        listSend.AddRange(byteArray.ToArray());
                                        WriteFile("查询SN记录", "AGVID+" + bytes[5].ToString() + "SN1DB+" + resultRead1 + "SN2DB+" + resultRead2 + DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss"));

                                    }

                                    break;

                            }
                            if (listSend.Count > 1)
                            {
                                List<byte> list2 = new List<byte>();
                                list2.Add(bytes[0]); list2.Add(bytes[1]); list2.Add(bytes[2]);
                                list2.Add((byte)listSend.Count);
                                list2.AddRange(listSend.ToArray());
                                byte[] crc = DispatcherTool.CRC16(list2.ToArray());
                                list2.AddRange(crc);

                                result = list2.ToArray();

                                //GlobalPara.listSKQMes.Add(DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss") + "  发送数据到 :" + SocketClient.RemoteEndPoint.ToString() + ",数据是 " + DispatcherTool.ByteToHexString(list2.ToArray()));

                                WriteFile("SKQMES对接记录" + DateTime.Now.ToString("yyyy-MM-dd"), DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss") + "  发送数据到 :" + SocketClient.RemoteEndPoint.ToString() + ",数据是 " + DispatcherTool.ByteToHexString(list2.ToArray()));
                            }
                            List<byte> temp2 = bytes.ToList();
                            temp2.RemoveRange(0, 3 + 1 + dataLength + 2);
                            bytes = new List<byte>().ToArray();
                        }

                    }
                    else
                    {
                        bytes = new List<byte>().ToArray();

                    }
                }
            }
            catch (Exception ex)
            {

            }
            return result;
        }

        public static byte[] SpeedOptByte = { 0x00, 0x06, 0x0C, 0x14 };

        List<Button> listAllBtns = new List<Button>();
        List<JObject> listObjs = new List<JObject>();
        Boolean CarAlarmFlag = false;

        //pack线方法
        public void Test(object Dr)
        {

            if (Dr != null)
            {
                DataRow dr = (DataRow)Dr;
                while (true)
                {
                    Console.WriteLine(dr["ID"].ToString() + ":" + dr["工位名称"].ToString());
                    HslCommunication.Profinet.Siemens.SiemensS7Net s7 = null;
                    try
                    {
                        //   Button btn = listAllBtns.Find(o => o.Tag.ToString() == dr["工位地标"].ToString());
                        //    if (btn == null) { return; }
                        var infos = GlobalPara.AgvInfoDic.Values.ToList();
                        //     btn.Invoke(new InvokeDelegate(delegate
                        //  for (int i = 0; i < dtSKQPLC.Rows.Count; i++)
                        {
                            if (!string.IsNullOrEmpty(dr["PLC类型"].ToString())&& !string.IsNullOrEmpty(dr["IP地址"].ToString()))
                            {
                                switch (dr["PLC类型"].ToString().ToLower())
                                {
                                    case "s1200":
                                        s7 = new HslCommunication.Profinet.Siemens.SiemensS7Net(HslCommunication.Profinet.Siemens.SiemensPLCS.S1200,
                            dr["IP地址"].ToString());
                                        break;
                                    case "s1500":
                                        s7 = new HslCommunication.Profinet.Siemens.SiemensS7Net(HslCommunication.Profinet.Siemens.SiemensPLCS.S1500,
                            dr["IP地址"].ToString());
                                        break;
                                    default:
                                        s7 = new HslCommunication.Profinet.Siemens.SiemensS7Net(HslCommunication.Profinet.Siemens.SiemensPLCS.S1500,
                                dr["IP地址"].ToString());
                                        break;

                                }

                                s7.Rack = (byte)0;
                                s7.Slot = (byte)1;
                                s7.ConnectTimeOut = 500;
                                s7.ReceiveTimeOut = 500;
                                var connet = s7.ConnectServer();
                                //    s7.LogNet = new HslCommunication.LogNet.LogNetSingle("logs.txt");


                                if (!connet.IsSuccess)
                                {


                                    //GlobalPara.listSKQPLC.Add(DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss") + "  向PLC(" + dr["IP地址"].ToString() + ")的地址请求连接失败");
                                    WriteFile("SKQPLC对接失败记录" + DateTime.Now.ToString("yyyy-MM-dd") + "" + dr["IP地址"].ToString() + "", DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss") + "  向PLC(" + dr["IP地址"].ToString() + ")的地址请求连接失败");
                                    // return;
                                    //     PLCPackAlarm = true;
                                    lock (AlarmPackStations)
                                    {
                                        if (!AlarmPackStations.Contains(dr["工位名称"].ToString()))
                                        {
                                            AlarmPackStations.Add(dr["工位名称"].ToString());
                                        }
                                    }
                                    continue;
                                }
                                else
                                {
                                    //         PLCPackAlarm = false;
                                    lock (AlarmPackStations)
                                    {
                                        if (AlarmPackStations.Contains(dr["工位名称"].ToString()))
                                        {
                                            AlarmPackStations.RemoveAll(o => o == dr["工位名称"].ToString());
                                        }
                                    }
                                }

                                if (dr.Table.Columns.Contains("PLC心跳DB") && dr.Table.Columns.Contains("中控心跳DB"))
                                {
                                    if (!string.IsNullOrEmpty(dr["PLC心跳DB"].ToString()) && !string.IsNullOrEmpty(dr["中控心跳DB"].ToString()))
                                    {
                                        var result = s7.ReadBool(dr["PLC心跳DB"].ToString());
                                        if (result != null && result.IsSuccess)
                                        {
                                            s7.Write(dr["中控心跳DB"].ToString(), result.Content);
                                        }
                                    }
                                }

                                bool IsInOtherInMarks = false;
                                if (dr.Table.Columns.Contains("其他进入中地标"))
                                {
                                    if (!string.IsNullOrEmpty(dr["其他进入中地标"].ToString()))
                                    {
                                        List<string> list = dr["其他进入中地标"].ToString().Split(';').ToList();
                                        var infoList = infos.FindAll(o => list.Contains(o.MARKNUM.ToString()) && o.ConnectStatus && (o.RUNSTATUS_Cur == 0x40 || o.RUNSTATUS_Cur == 0x41));
                                        if (infoList != null && infoList.Count >= 1)
                                        {
                                            IsInOtherInMarks = true;
                                            s7.Write(dr["进入中DB"].ToString(), true);
                                        }
                                        else
                                        {
                                            //          s7.Write(dr["进入中DB"].ToString(), false);
                                        }
                                    }
                                }



                                #region  请求地标判断放行
                                if (dr.Table.Columns.Contains("请求地标"))
                                {
                                    if (!string.IsNullOrEmpty(dr["请求地标"].ToString()))
                                    {
                                        var infoList = infos.FindAll(o => o.MARKNUM.ToString() == dr["请求地标"].ToString() && o.ConnectStatus);
                                        if (infoList.Count > 1)
                                        {
                                            var info = infoList.Find(o => o.RUNSTATUS_Cur == 0x40);//运行
                                            bool b2 = true;
                                            if (info != null)
                                            {

                                                s7.Write(dr["进入中DB"].ToString(), true);
                                                if (dr.Table.Columns.Contains("进入互锁DB"))
                                                {
                                                    if (!string.IsNullOrEmpty(dr["进入互锁DB"].ToString()))
                                                    {
                                                        var result2 = s7.ReadBool(dr["进入互锁DB"].ToString());
                                                        if (result2 != null && result2.IsSuccess)
                                                        {
                                                            if (result2.Content == false)
                                                            {
                                                                DispatcherTool.ControlAGVBy1071(info.AGVNUM, 1);
                                                                WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "(放行地标：" + info.MARKNUM + ",放行路线：0" + ", " + ",车号:" + info.AGVNUM + ",进入互锁DB为false) ");
                                                                info.EmergencyFlag = true;
                                                                s7.Write(dr["进入中DB"].ToString(), false);
                                                            }
                                                        }
                                                    }
                                                }

                                                var result = s7.ReadBool(dr["急停控制DB"].ToString());
                                                if (result != null && result.IsSuccess)
                                                {
                                                    if (result.Content == false)
                                                    {
                                                        DispatcherTool.ControlAGVBy1071(info.AGVNUM, 1);
                                                        WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "(放行地标：" + info.MARKNUM + ",放行路线：0" + ", " + ",车号:" + info.AGVNUM + ",急停) ");
                                                        info.EmergencyFlag = true;
                                                    }
                                                }
                                              
                                                b2 = false;
                                                //         WriteFile("SKQPLC对接记录" + DateTime.Now.ToString("yyyy-MM-dd") + "" + dr["IP地址"].ToString() + "", DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss") + "  向PLC(" + dr["IP地址"].ToString() + ")的地址" + dr["进入中DB"].ToString() + ",写入数据:true(AGV在进入地标运行中,等待地标大于1台车),车号:" + info.AGVNUM);

                                            }
                                            if (b2)
                                            {
                                                info = infoList.Find(o => o.RUNSTATUS_Cur == 0x41);  //暂停
                                                if (info != null)
                                                {
                                                    s7.Write(dr["进入中DB"].ToString(), false);
                                                    var result = s7.ReadBool(dr["允许DB"].ToString());
                                                    bool b = true;
                                                    if (result != null && result.IsSuccess)
                                                    {
                                                        bool bb = true;
                                                        if (dr.Table.Columns.Contains("进入互锁DB"))
                                                        {
                                                            if (!string.IsNullOrEmpty(dr["进入互锁DB"].ToString()))
                                                            {
                                                                var result2 = s7.ReadBool(dr["进入互锁DB"].ToString());
                                                                if (result2 != null && result2.IsSuccess)
                                                                {
                                                                    if (result2.Content == false)
                                                                    {
                                                                        bb = false;
                                                                    }
                                                                }
                                                                else
                                                                {
                                                                    bb = false;
                                                                }
                                                            }
                                                        }
                                                        if (result.Content == true && bb)
                                                        {
                                                            b = false;
                                                          //  s7.Write(dr["进入中DB"].ToString(), true);
                                                            Thread.Sleep(1000);
                                                            s7.Write(dr["请求DB"].ToString(), false);

                                                            DispatcherTool.ReleaseAgvOnStop(info.MARKNUM, 0, 10);
                                                            var temp = GlobalPara.ListReleaseObj.Find(o => o.AGVNUM == info.AGVNUM && info.ConnectStatus);
                                                            if (temp == null)
                                                            {
                                                                GlobalPara.ListReleaseObj.Add(info);
                                                            }
                                                            WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "(放行地标：" + info.MARKNUM + ",放行路线：0" + ", " + ",车号:" + info.AGVNUM + ",进入自动位) ");

                                                            //         WriteFile("SKQPLC对接记录" + DateTime.Now.ToString("yyyy-MM-dd") + "" + dr["IP地址"].ToString() + "", DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss") + "  向PLC(" + dr["IP地址"].ToString() + ")的地址" + dr["进入中DB"].ToString() + ",写入数据:true(PLC允许进入),车号:" + infoList[0].AGVNUM);
                                                        }
                                                    }
                                                    if (b)
                                                    {
                                                        s7.Write(dr["请求DB"].ToString(), true);
                                                        //     WriteFile("SKQPLC对接记录" + DateTime.Now.ToString("yyyy-MM-dd") + "" + dr["IP地址"].ToString() + "", DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss") + "  向PLC(" + dr["IP地址"].ToString() + ")的地址" + dr["请求DB"].ToString() + ",写入数据:true(AGV在等待点地标，请求PLC进入),车号:" + infoList[0].AGVNUM);
                                                    }
                                                    //         WriteFile("SKQPLC对接记录" + DateTime.Now.ToString("yyyy-MM-dd") + "" + dr["IP地址"].ToString() + "", DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss") + "  向PLC(" + dr["IP地址"].ToString() + ")的地址" + dr["进入中DB"].ToString() + ",写入数据:true(AGV在进入地标运行中,等待地标大于1台车),车号:" + info.AGVNUM);
                                                }
                                                else
                                                {
                                                    s7.Write(dr["进入中DB"].ToString(), false);
                                                    var result = s7.ReadBool(dr["急停控制DB"].ToString());

                                                    if (dr.Table.Columns.Contains("进入互锁DB"))
                                                    {
                                                        if (!string.IsNullOrEmpty(dr["进入互锁DB"].ToString()))
                                                        {
                                                            var info3 = infoList.Find(o => o.RUNSTATUS_Cur == 0x43);
                                                            if (info3 != null)
                                                            {
                                                                var result2 = s7.ReadBool(dr["进入互锁DB"].ToString());
                                                                if (result2 != null && result2.IsSuccess)
                                                                {
                                                                    if (result2.Content == true && info3.EmergencyFlag && result.Content == true)
                                                                    {

                                                                        DispatcherTool.ControlAGVBy1071(info3.AGVNUM, 0);
                                                                        WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "(放行地标：" + info3.MARKNUM + ",放行路线：0" + ", " + ",车号:" + info3.AGVNUM + ",进入互锁DB为true) ");
                                                                        info3.EmergencyFlag = false;
                                                                        s7.Write(dr["进入中DB"].ToString(), true);
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                    //         WriteFile("SKQPLC对接记录" + DateTime.Now.ToString("yyyy-MM-dd") + "" + dr["IP地址"].ToString() + "", DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss") + "  向PLC(" + dr["IP地址"].ToString() + ")的地址" + dr["进入中DB"].ToString() + ",写入数据:false(无AGV在进入地标运行,等待地标大于1台车),车号:" + info.AGVNUM);
                                                }
                                            }
                                            else
                                            {

                                            }
                                        }
                                        else if (infoList.Count == 1)
                                        {
                                            if (infoList[0].RUNSTATUS_Cur == 0x40)
                                            {
                                                //if (dr["IP地址"].ToString() == "192.168.101.34")
                                                //{
                                                //add by cjs 20211126 for conminitite with plc begin--  到位之后开始通讯
                                                if (s7 != null)
                                                {
                                                    string resultRead1 = "";
                                                    string resultRead2 = "";

                                                    if (dr.Table.Columns.Contains("SN1发送DB") && dr.Table.Columns.Contains("SN2发送DB"))
                                                    {

                                                        //  PLCSql.PLCSqlSelect(infoList[0].AGVNUM.ToString(), "2", ref resultRead1, ref resultRead2); //查询数据

                                                        if (!string.IsNullOrEmpty(dr["SN1发送DB"].ToString()))
                                                        {

                                                            //OperateResult rs2 = s7.Write(dr["AGVDB"].ToString(), info.AGVNUM.ToString());
                                                            if (resultRead1 != null)
                                                            {
                                                                int s = resultRead1.Length;
                                                                OperateResult rs = s7.Write(dr["SN1发送DB"].ToString(), resultRead1.Trim());

                                                            }

                                                        }

                                                        if (!string.IsNullOrEmpty(dr["SN2发送DB"].ToString()) && resultRead2 != null)
                                                        {

                                                            OperateResult rs1 = s7.Write(dr["SN2发送DB"].ToString(), resultRead2.Trim());
                                                        }

                                                        // WriteFile("查询SN记录", "AGVID+" + info.AGVNUM.ToString() + "SN1DB+" + resultRead1 + "SN2DB+" + resultRead2 + DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss"));

                                                    }
                                                }
                                                //add by cjs 20211126 for conminitite with plc  end

                                                //}

                                                var result = s7.ReadBool(dr["急停控制DB"].ToString());
                                                if (result != null && result.IsSuccess)
                                                {
                                                    if (result.Content == false)
                                                    {
                                                        DispatcherTool.ControlAGVBy1071(infoList[0].AGVNUM, 1);
                                                        WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "(放行地标：" + infoList[0].MARKNUM + ",放行路线：0" + ", " + ",车号:" + infoList[0].AGVNUM + ",急停) ");
                                                        infoList[0].EmergencyFlag = true;
                                                    }
                                                }


                                                s7.Write(dr["进入中DB"].ToString(), true);
                                                s7.Write(dr["请求DB"].ToString(), false);
                                                //       WriteFile("SKQPLC对接记录" + DateTime.Now.ToString("yyyy-MM-dd") + "" + dr["IP地址"].ToString() + "", DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss") + "  向PLC(" + dr["IP地址"].ToString() + ")的地址" + dr["进入中DB"].ToString() + ",写入数据:true(AGV在进入地标运行中),车号:" + infoList[0].AGVNUM);
                                                if (dr.Table.Columns.Contains("进入互锁DB"))
                                                {
                                                    if (!string.IsNullOrEmpty(dr["进入互锁DB"].ToString()))
                                                    {
                                                        var result2 = s7.ReadBool(dr["进入互锁DB"].ToString());
                                                        if (result2 != null && result2.IsSuccess)
                                                        {
                                                            if (result2.Content == false)
                                                            {
                                                                DispatcherTool.ControlAGVBy1071(infoList[0].AGVNUM, 1);
                                                                WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "(放行地标：" + infoList[0].MARKNUM + ",放行路线：0" + ", " + ",车号:" + infoList[0].AGVNUM + ",进入互锁DB为false) ");
                                                                infoList[0].EmergencyFlag = true;
                                                                s7.Write(dr["进入中DB"].ToString(), false);
                                                            }
                                                        }
                                                    }
                                                }
                                               
                                            }
                                            else if (infoList[0].RUNSTATUS_Cur == 0x41)
                                            {
                                                s7.Write(dr["进入中DB"].ToString(), false);
                                                var result = s7.ReadBool(dr["允许DB"].ToString());
                                                bool b = true;
                                                if (result != null && result.IsSuccess)
                                                {
                                                    bool bb = true;
                                                    if (dr.Table.Columns.Contains("进入互锁DB"))
                                                    {
                                                        if (!string.IsNullOrEmpty(dr["进入互锁DB"].ToString()))
                                                        {
                                                            var result2 = s7.ReadBool(dr["进入互锁DB"].ToString());
                                                            if (result2 != null && result2.IsSuccess)
                                                            {
                                                                if (result2.Content == false)
                                                                {
                                                                    bb = false;
                                                                }
                                                            }
                                                            else
                                                            {
                                                                bb = false;
                                                            }
                                                        }
                                                    }
                                                    if (result.Content == true && bb)
                                                    {
                                                        b = false;
                                                        s7.Write(dr["进入中DB"].ToString(), true);
                                                        Thread.Sleep(1000);
                                                        s7.Write(dr["请求DB"].ToString(), false);

                                                        DispatcherTool.ReleaseAgvOnStop(infoList[0].MARKNUM, 0, 10);
                                                        WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "(放行地标：" + infoList[0].MARKNUM + ",放行路线：0" + ", " + ",车号:" + infoList[0].AGVNUM + ",进入自动位) ");


                                                        //         WriteFile("SKQPLC对接记录" + DateTime.Now.ToString("yyyy-MM-dd") + "" + dr["IP地址"].ToString() + "", DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss") + "  向PLC(" + dr["IP地址"].ToString() + ")的地址" + dr["进入中DB"].ToString() + ",写入数据:true(PLC允许进入),车号:" + infoList[0].AGVNUM);
                                                    }
                                                }
                                                if (b)
                                                {
                                                    s7.Write(dr["请求DB"].ToString(), true);
                                                    //     WriteFile("SKQPLC对接记录" + DateTime.Now.ToString("yyyy-MM-dd") + "" + dr["IP地址"].ToString() + "", DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss") + "  向PLC(" + dr["IP地址"].ToString() + ")的地址" + dr["请求DB"].ToString() + ",写入数据:true(AGV在等待点地标，请求PLC进入),车号:" + infoList[0].AGVNUM);
                                                }
                                            }
                                            else
                                            {

                                                var result = s7.ReadBool(dr["急停控制DB"].ToString());

                                                s7.Write(dr["进入中DB"].ToString(), false);
                                                if (dr.Table.Columns.Contains("进入互锁DB"))
                                                {
                                                    if (!string.IsNullOrEmpty(dr["进入互锁DB"].ToString()))
                                                    {
                                                        var info3 = infoList.Find(o => o.RUNSTATUS_Cur == 0x43);
                                                        if (info3 != null)
                                                        {
                                                            var result2 = s7.ReadBool(dr["进入互锁DB"].ToString());
                                                            if (result2 != null && result2.IsSuccess)
                                                            {
                                                                if (result2.Content == true && info3.EmergencyFlag && result.Content == true)
                                                                {
                                                                    DispatcherTool.ControlAGVBy1071(info3.AGVNUM, 0);
                                                                    WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "(放行地标：" + info3.MARKNUM + ",放行路线：0" + ", " + ",车号:" + info3.AGVNUM + ",进入互锁DB为true) ");
                                                                    info3.EmergencyFlag = false;
                                                                    s7.Write(dr["进入中DB"].ToString(), true);
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                                //      WriteFile("SKQPLC对接记录" + DateTime.Now.ToString("yyyy-MM-dd") + "" + dr["IP地址"].ToString() + "", DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss") + "  向PLC(" + dr["IP地址"].ToString() + ")的地址" + dr["进入中DB"].ToString() + ",写入数据:false(AGV状态不符合),车号:" + infoList[0].AGVNUM);
                                            }
                                        }
                                        else
                                        {
                                            if (!IsInOtherInMarks)
                                            {
                                                s7.Write(dr["进入中DB"].ToString(), false);
                                            }
                                            s7.Write(dr["请求DB"].ToString(), false);
                                            //    WriteFile("SKQPLC对接记录" + DateTime.Now.ToString("yyyy-MM-dd") + "" + dr["IP地址"].ToString() + "", DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss") + "  向PLC(" + dr["IP地址"].ToString() + ")的地址" + dr["进入中DB"].ToString() + ",写入数据:false(无车在进入地标运行),车号:无");
                                        }
                                    }
                                }
                                #endregion
                                bool IsInOtherOutMarks = false;
                                if (dr.Table.Columns.Contains("其他离开中地标"))
                                {
                                    if (!string.IsNullOrEmpty(dr["其他离开中地标"].ToString()))
                                    {
                                        List<string> list = dr["其他离开中地标"].ToString().Split(';').ToList();
                                        var infoList = infos.FindAll(o => list.Contains(o.MARKNUM.ToString()) && o.ConnectStatus && (o.RUNSTATUS_Cur == 0x40 || o.RUNSTATUS_Cur == 0x41));
                                        if (infoList != null && infoList.Count >= 1)
                                        {
                                            IsInOtherOutMarks = true;
                                            s7.Write(dr["离开DB"].ToString(), true);
                                        }
                                        else
                                        {
                                            //      s7.Write(dr["离开DB"].ToString(), false);
                                        }
                                    }
                                }


                                #region   工位地标判断放行
                                if (!string.IsNullOrEmpty(dr["工位地标"].ToString()))
                                {
                                    var t2 = listObjs.Find(o => o["Mark"].ToString() == dr["工位地标"].ToString());
                                    if (t2 != null)
                                    {
                                        continue;
                                    }

                                    var infoList = infos.FindAll(o => o.MARKNUM.ToString() == dr["工位地标"].ToString() && o.ConnectStatus);
                                    if (infoList != null && infoList.Count >= 1)
                                    {
                                        // foreach (var info in infoList)
                                        var info = infoList.Find(o => o.RUNSTATUS_Cur == 0x41 || o.RUNSTATUS_Cur == 0x44); //停止
                                        if (info != null)
                                        {

                                            if (!string.IsNullOrEmpty(dr["急停控制DB"].ToString()))
                                            {
                                           
                                                if (connet.IsSuccess)
                                                {
                                                    var result11 = s7.ReadBool(dr["急停控制DB"].ToString());  //线束信号

                                                    if (result11 != null && result11.IsSuccess)
                                                    {
                                                        if (result11.Content == false)
                                                        {

                                                            info.EmergencyCar = false;
                                                        }
                                                        else
                                                        {
                                                            info.EmergencyCar = true;
                                                        }
                                                    }
                                                }
                                            }


                                            if (!string.IsNullOrEmpty(dr["AGVDB"].ToString()))
                                            {
                                                var reulsttt = s7.ReadByte(dr["AGVDB"].ToString());
                                                if (reulsttt != null && reulsttt.IsSuccess)
                                                {
                                                    if (reulsttt.Content != (byte)info.AGVNUM)
                                                    {
                                                        WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "向PLC写入车号数据:" + info.AGVNUM + ",地标:" + info.MARKNUM + "车号:" + info.AGVNUM + ",当前路线为:" + info.ROUTENUM + ",状态为" + info.RUNSTATUS_Cur);
                                                    }
                                                }
                                                var resultt = s7.Write(dr["AGVDB"].ToString(), (byte)info.AGVNUM);
                                                //if (info.RUNSTATUS_Cur == 0x41 || info.RUNSTATUS_Cur == 0x44)
                                                {
                                                    var reulsttt2 = s7.ReadBool(dr["到位DB"].ToString());
                                                    if (reulsttt2 != null && reulsttt2.IsSuccess)
                                                    {
                                                        if (reulsttt2.Content != true)
                                                        {
                                                            WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "向PLC写入到位数据:true,地标:" + info.MARKNUM + "车号:" + info.AGVNUM + ",当前路线为:" + info.ROUTENUM + ",状态为" + info.RUNSTATUS_Cur);
                                                        }
                                                    }
                                                    resultt = s7.Write(dr["到位DB"].ToString(), true);




                                                    var reulsttt22 = s7.ReadBool(dr["离开DB"].ToString());
                                                    if (reulsttt22 != null && reulsttt22.IsSuccess)
                                                    {
                                                        if (reulsttt22.Content != false)
                                                        {
                                                            WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "向PLC写入离开DB数据:false(到位),地标:" + info.MARKNUM + "车号:" + info.AGVNUM + ",当前路线为:" + info.ROUTENUM + ",状态为" + info.RUNSTATUS_Cur);
                                                        }
                                                    }
                                                    if (!IsInOtherOutMarks)
                                                    {
                                                        resultt = s7.Write(dr["离开DB"].ToString(), false);
                                                    }

                                                    resultt = s7.Write(dr["离开DB"].ToString(), false);
                                                    //      if (btn.BackColor != Color.Blue)
                                                    {
                                                        //          btn.BackColor = Color.Yellow;
                                                    }

                                                    {
                                                        string resultRead1 = "", resultRead2 = "";
                                                        PLCSql.PLCSqlSelect(info.AGVNUM.ToString(), "2", ref resultRead1, ref resultRead2);
                                                        WriteFile("查询SN记录" + DateTime.Now.ToString("yyyy-MM-dd"), "AGVID+" + info.AGVNUM.ToString() + "SN1DB+" + resultRead1 + "SN2DB+" + resultRead2 + DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss"));
                                                        OperateResult rs1 = s7.Write(dr["SN1发送DB"].ToString(), resultRead1);

                                                        if (!string.IsNullOrEmpty(dr["SN2发送DB"].ToString()))
                                                        {

                                                            OperateResult rs2 = s7.Write(dr["SN2发送DB"].ToString(), resultRead2);
                                                        }
                                                        if (!string.IsNullOrEmpty(dr["修改完成DB"].ToString()))
                                                        {

                                                            OperateResult rs = s7.Write(dr["修改完成DB"].ToString(), true);
                                                        }
                                                    }
                                                    string addr = dr["放行DB"].ToString();
                                                    var result = s7.ReadBool(addr);
                                                    if (result != null && result.IsSuccess)
                                                    {
                                                        bool bb = true;
                                                        if (dr.Table.Columns.Contains("离开互锁DB"))
                                                        {
                                                            if (!string.IsNullOrEmpty(dr["离开互锁DB"].ToString()))
                                                            {
                                                                var result2 = s7.ReadBool(dr["离开互锁DB"].ToString());
                                                                if (result2 != null && result2.IsSuccess)
                                                                {
                                                                    if (result2.Content == false)
                                                                    {
                                                                        WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "离开互锁DB值:" + result2.Content);
                                                                        bb = false;
                                                                    }
                                                                }
                                                            }
                                                        }

                                                        if (result.Content == true && bb )
                                                        {
                                                            var result2 = s7.ReadInt16(dr["放行路径DB"].ToString());


                                                            if (result2 != null && result2.IsSuccess)  //加上允许放行信号   // && info.AllowReleaseFlag
                                                            {
                                                           //     WriteFile("工位点记录-"+ dr["IP地址"].ToString() + "-"  + DateTime.Now.ToString("yyyy-MM-dd"),"放行路径DB值:"+result2.Content);
                                                                if (result2.Content == (short.Parse("1")))//OK路线
                                                                {
                                                                    //lock (afterRelease)
                                                                    //{
                                                                    //    string tempStr = info.AGVNUM + ",400,64";
                                                                    //    if (!afterRelease.Contains(tempStr))
                                                                    //    {
                                                                    //        afterRelease.Add(tempStr);
                                                                    //    }

                                                                    OperateResult rs1 = s7.Write(dr["SN1发送DB"].ToString(), "");

                                                                    if (!string.IsNullOrEmpty(dr["SN2发送DB"].ToString()))
                                                                    {

                                                                        OperateResult rs2 = s7.Write(dr["SN2发送DB"].ToString(), "");
                                                                    }
                                                                    if (!string.IsNullOrEmpty(dr["修改完成DB"].ToString()))
                                                                    {

                                                                        OperateResult rs = s7.Write(dr["修改完成DB"].ToString(), false);
                                                                    }


                                                                    DispatcherTool.ReleaseAgvOnStop(info.MARKNUM, 0, 10);
                                                                    if (!string.IsNullOrEmpty(dr["请求地标"].ToString()))
                                                                    {
                                                                        var tempp = listObjs.Find(o => o["Mark"].ToString() == info.MARKNUM.ToString());
                                                                        if (tempp == null)
                                                                        {
                                                                            JObject obj = new JObject();
                                                                            obj["Mark"] = info.MARKNUM;
                                                                            obj["AGVID"] = info.AGVNUM;
                                                                            obj["Secs"] = 2000;
                                                                            listObjs.Add(obj);
                                                                        }
                                                                        s7.Write(dr["到位DB"].ToString(), false);
                                                                        s7.Write(dr["离开DB"].ToString(), true);
                                                                    }
                                                                    WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "(放行地标：" + info.MARKNUM + ",放行路线：0" + ", " + ",车号:" + info.AGVNUM + ",OK放行) ");


                                                                }
                                                                else if (result2.Content > 1)  //NG路线
                                                                {
                                                                    //lock (afterRelease)
                                                                    //{
                                                                    //    string tempStr = info.AGVNUM + ",400,64";
                                                                    //    if (!afterRelease.Contains(tempStr))
                                                                    //    {
                                                                    //        afterRelease.Add(tempStr);
                                                                    //    }
                                                                    //}

                                                                    OperateResult rs1 = s7.Write(dr["SN1发送DB"].ToString(), "");

                                                                    if (!string.IsNullOrEmpty(dr["SN2发送DB"].ToString()))
                                                                    {

                                                                        OperateResult rs2 = s7.Write(dr["SN2发送DB"].ToString(), "");
                                                                    }
                                                                    if (!string.IsNullOrEmpty(dr["修改完成DB"].ToString()))
                                                                    {

                                                                        OperateResult rs = s7.Write(dr["修改完成DB"].ToString(), false);
                                                                    }

                                                                    if (!string.IsNullOrEmpty(dr["修改完成DB"].ToString()))
                                                                    {
                                                                        OperateResult rs = s7.Write(dr["修改完成DB"].ToString(), false);
                                                                    }

                                                                    DispatcherTool.ReleaseAgvOnStop(info.MARKNUM, int.Parse(dr["NG路线"].ToString()), 10);

                                                                    WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "(放行地标：" + info.MARKNUM + ",放行路线：" + dr["NG路线"].ToString() + ", " + ",车号:" + info.AGVNUM + ",NG放行) ");
                                                                }

                                                                var reulsttt33 = s7.ReadBool(dr["修改完成DB"].ToString());
                                                                if (reulsttt33 != null && reulsttt33.IsSuccess)
                                                                {
                                                                    if (reulsttt22.Content != false)
                                                                    {
                                                                        OperateResult rs = s7.Write(dr["修改完成DB"].ToString(), false);
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                    result = s7.ReadBool(dr["屏蔽DB"].ToString());  //收到屏蔽信号 直接放行
                                                    if (result != null && result.IsSuccess)
                                                    {
                                                        if (result.Content == true)
                                                        {
                                                            // DispatcherTool.ReleaseAgvOnStop(info.MARKNUM, 0, 10);
                                                            info.AllowMesReleaseFlag = true;

                                                            WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "(放行地标：" + info.MARKNUM + ",放行路线：0" + ", " + ",车号:" + info.AGVNUM + ",屏蔽放行) ");
                                                        }
                                                    }
                                                    int AlarmCode = int.Parse(info.ALARMCODE);
                                                    if (AlarmCode == 1 || AlarmCode == 5 || AlarmCode == 9 || AlarmCode == 256)
                                                    {
                                                        s7.Write(dr["是否故障DB"].ToString(), false);

                                                    }
                                                    else
                                                    {
                                                        s7.Write(dr["是否故障DB"].ToString(), true);
                                                        CarAlarmFlag = true;
                                                    }
                                                    if (AlarmCode == 256) { AlarmCode = 1; }
                                                    //reulsttt = s7.ReadByte(dr["行驶状态DB"].ToString());
                                                    //if (reulsttt != null && reulsttt.IsSuccess)
                                                    //{
                                                    //    if (reulsttt.Content != (byte)(AlarmCode - 1))
                                                    //    {
                                                    //        WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "向PLC写入行驶状态数据:" + ((AlarmCode - 1)) + ",地标:" + info.MARKNUM + "车号:" + info.AGVNUM + ",当前路线为:" + info.ROUTENUM + ",状态为" + info.RUNSTATUS_Cur);
                                                    //    }
                                                    //}
                                                    //s7.Write(dr["行驶状态DB"].ToString(), (byte)(AlarmCode - 1));
                                                }

                                            }
                                            continue;
                                        }
                                        else
                                        {
                                            var info2 = infoList.Find(o => o.RUNSTATUS_Cur == 0x40); //运行
                                            if (info2 != null)
                                            {
                                                info2.IsReachFlag = false;
                                                info2.EmergencyFlag = false;

                                                if (!string.IsNullOrEmpty(dr["急停控制DB"].ToString()))
                                                {
                                                    var result = s7.ReadBool(dr["急停控制DB"].ToString());
                                                    if (result != null && result.IsSuccess)
                                                    {
                                                        if (result.Content == false)
                                                        {
                                                            DispatcherTool.ControlAGVBy1071(info2.AGVNUM, 1);
                                                            WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "(放行地标：" + info2.MARKNUM + ",放行路线：0" + ", " + ",车号:" + info2.AGVNUM + ",急停) ");
                                                            info2.EmergencyFlag = true;
                                                        }

                                                    }
                                                }


                                                if (!string.IsNullOrEmpty(dr["AGVDB"].ToString()))
                                                {

                                                    var reulsttt = s7.ReadByte(dr["AGVDB"].ToString());
                                                    if (reulsttt != null && reulsttt.IsSuccess)
                                                    {
                                                        if (reulsttt.Content != (byte)info2.AGVNUM)
                                                        {
                                                            WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "向PLC写入车号数据:" + info2.AGVNUM + ",地标:" + info2.MARKNUM + "车号:" + info2.AGVNUM + ",当前路线为:" + info2.ROUTENUM + ",状态为" + info2.RUNSTATUS_Cur);
                                                        }
                                                    }
                                                    var reulsttt2 = s7.ReadBool(dr["到位DB"].ToString());
                                                    if (reulsttt2 != null && reulsttt2.IsSuccess)
                                                    {
                                                        if (reulsttt2.Content != false)
                                                        {
                                                            WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "向PLC写入到位数据:false,地标:" + info2.MARKNUM + "车号:" + info2.AGVNUM + ",当前路线为:" + info2.ROUTENUM + ",状态为" + info2.RUNSTATUS_Cur);
                                                        }
                                                    }
                                                    s7.Write(dr["AGVDB"].ToString(), (byte)info2.AGVNUM);

                                                    s7.Write(dr["到位DB"].ToString(), false);
                                                    var reulsttt22 = s7.ReadBool(dr["离开DB"].ToString());
                                                    if (reulsttt22 != null && reulsttt22.IsSuccess)
                                                    {
                                                        if (reulsttt22.Content != true)
                                                        {
                                                            WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "向PLC写入离开DB数据:true(离站),地标:" + info2.MARKNUM + "车号:" + info2.AGVNUM + ",当前路线为:" + info2.ROUTENUM + ",状态为" + info2.RUNSTATUS_Cur);
                                                        }
                                                    }
                                                    s7.Write(dr["离开DB"].ToString(), true);
                                                    //      if (btn.BackColor != Color.Blue)
                                                    {
                                                        //          btn.BackColor = Color.Green;
                                                    }


                                                    int AlarmCode = int.Parse(info2.ALARMCODE);
                                                    if (AlarmCode == 1 || AlarmCode == 5 || AlarmCode == 9 || AlarmCode == 256)
                                                    {
                                                        s7.Write(dr["是否故障DB"].ToString(), false);
                                                    }
                                                    else
                                                    {
                                                        s7.Write(dr["是否故障DB"].ToString(), true);
                                                        CarAlarmFlag = true;
                                                    }

                                                    if (AlarmCode == 256) { AlarmCode = 1; }
                                                    //  reulsttt = s7.ReadByte(dr["行驶状态DB"].ToString());
                                                    //if (reulsttt != null && reulsttt.IsSuccess)
                                                    //{
                                                    //    if (reulsttt.Content != (byte)(AlarmCode - 1))
                                                    //    {
                                                    //        WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "向PLC写入行驶状态数据:" + ((AlarmCode - 1)) + ",地标:" + info2.MARKNUM + "车号:" + info2.AGVNUM + ",当前路线为:" + info2.ROUTENUM + ",状态为" + info2.RUNSTATUS_Cur);
                                                    //    }
                                                    //}
                                                    //  s7.Write(dr["行驶状态DB"].ToString(), (byte)(AlarmCode - 1));
                                                    if (dr.Table.Columns.Contains("离开互锁DB"))
                                                    {
                                                        if (!string.IsNullOrEmpty(dr["离开互锁DB"].ToString()))
                                                        {
                                                            var result2 = s7.ReadBool(dr["离开互锁DB"].ToString());
                                                            if (result2 != null && result2.IsSuccess)
                                                            {
                                                                if (result2.Content == false)
                                                                {
                                                                    DispatcherTool.ControlAGVBy1071(info2.AGVNUM, 1); //不互锁 放行
                                                                    WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "(放行地标：" + info2.MARKNUM + ",放行路线：0" + ", " + ",车号:" + info2.AGVNUM + ",离开互锁DB值为false) ");
                                                                    info2.EmergencyFlag = true;
                                                                }
                                                            }
                                                        }
                                                    }
                                                    if (dr.Table.Columns.Contains("请求出门DB"))
                                                    {
                                                        if (!string.IsNullOrEmpty(dr["请求出门DB"].ToString()))
                                                        {
                                                            s7.Write(dr["请求出门DB"].ToString(), false);
                                                           
                                                            {
                                                                if (!GlobalPara.ReleaseMarkList.Contains(info2.MARKNUM.ToString()))
                                                                {
                                                                    GlobalPara.ReleaseMarkList.Add(info2.MARKNUM.ToString());
                                                                    WriteFile("点灭放行盒记录" + DateTime.Now.ToString("yyyy-MM-dd"), "工位放行成功，等待点灭，当前放行地标:" + info2.MARKNUM);

                                                                }
                                                            }
                                                        }
                                                    }
                                                    continue;
                                                }
                                            }
                                            else
                                            {

                                                var info3 = infoList.Find(o => o.RUNSTATUS_Cur == 0x43);
                                                if (info3 != null)
                                                {
                                                    info3.IsReachFlag = false;

                                                    if (!string.IsNullOrEmpty(dr["SN1发送DB"].ToString()))
                                                    {
                                                        OperateResult rs1 = s7.Write(dr["SN1发送DB"].ToString(), "");
                                                    }


                                                    if (!string.IsNullOrEmpty(dr["SN2发送DB"].ToString()))
                                                    {

                                                        OperateResult rs2 = s7.Write(dr["SN2发送DB"].ToString(), "");
                                                    }
                                                    if (!string.IsNullOrEmpty(dr["修改完成DB"].ToString()))
                                                    {

                                                        OperateResult rs = s7.Write(dr["修改完成DB"].ToString(), false);
                                                    }

                                                    if (!string.IsNullOrEmpty("急停控制DB"))
                                                    {
                                                        var result = s7.ReadBool(dr["急停控制DB"].ToString());
                                                        if (result != null && result.IsSuccess)
                                                        {
                                                            if (result.Content == true && info3.EmergencyFlag)
                                                            {
                                                                //  DispatcherTool.ControlAGVBy1071(info3.AGVNUM, 0);
                                                                WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "(放行地标：" + info3.MARKNUM + ",放行路线：0" + ", " + ",车号:" + info3.AGVNUM + ",离开互锁DB值为true) ");

                                                            }
                                                        }
                                                    }



                                                    if (!string.IsNullOrEmpty("AGVDB"))
                                                    {
                                                        var reulsttt = s7.ReadByte(dr["AGVDB"].ToString());
                                                        if (reulsttt != null && reulsttt.IsSuccess)
                                                        {
                                                            if (reulsttt.Content != (byte)info3.AGVNUM)
                                                            {
                                                                WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "向PLC写入车号数据:" + info3.AGVNUM + ",地标:" + info3.MARKNUM + "车号:" + info3.AGVNUM + ",当前路线为:" + info3.ROUTENUM + ",状态为" + info3.RUNSTATUS_Cur);
                                                            }
                                                        }
                                                        s7.Write(dr["AGVDB"].ToString(), (byte)info3.AGVNUM);
                                                        var reulsttt2 = s7.ReadBool(dr["到位DB"].ToString());
                                                        if (reulsttt2 != null && reulsttt2.IsSuccess)
                                                        {
                                                            if (reulsttt2.Content != false)
                                                            {
                                                                WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "向PLC写入到位数据:false,地标:" + info3.MARKNUM + "车号:" + info3.AGVNUM + ",当前路线为:" + info3.ROUTENUM + ",状态为" + info3.RUNSTATUS_Cur);
                                                            }
                                                        }
                                                        s7.Write(dr["到位DB"].ToString(), false);
                                                        var reulsttt22 = s7.ReadBool(dr["离开DB"].ToString());
                                                        if (reulsttt22 != null && reulsttt22.IsSuccess)
                                                        {
                                                            if (reulsttt22.Content != false)
                                                            {
                                                                WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "向PLC写入离开DB数据:false(暂停),地标:" + info3.MARKNUM + "车号:" + info3.AGVNUM + ",当前路线为:" + info3.ROUTENUM + ",状态为" + info3.RUNSTATUS_Cur);
                                                            }
                                                        }
                                                        if (!IsInOtherOutMarks)
                                                        {
                                                            s7.Write(dr["离开DB"].ToString(), false);
                                                            s7.Write(dr["已离开DB"].ToString(), false);
                                                        }
                                                        //           if (btn.BackColor != Color.Blue)
                                                        {
                                                            //               btn.BackColor = Color.Red;
                                                        }

                                                        //if (result != null && result.IsSuccess)
                                                        //{
                                                        //    if (result.Content == true && info3.EmergencyFlag)
                                                        //    {
                                                        //        DispatcherTool.ControlAGVBy1071(info3.AGVNUM, 0, 10);
                                                        //        WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "(放行地标：" + info3.MARKNUM + ",放行路线：0" + ", " + ",车号:" + info3.AGVNUM + ",释放急停) ");
                                                        //        info3.EmergencyFlag = false;
                                                        //    }
                                                        //}
                                                        int AlarmCode = int.Parse(info3.ALARMCODE);
                                                        if (AlarmCode == 1 || AlarmCode == 5 || AlarmCode == 9 || AlarmCode == 256)
                                                        {
                                                            s7.Write(dr["是否故障DB"].ToString(), false);
                                                        }
                                                        else
                                                        {
                                                            s7.Write(dr["是否故障DB"].ToString(), true);
                                                            CarAlarmFlag = true;
                                                        }
                                                        if (AlarmCode == 256) { AlarmCode = 1; }
                                                        //reulsttt = s7.ReadByte(dr["行驶状态DB"].ToString());
                                                        //if (reulsttt != null && reulsttt.IsSuccess)
                                                        //{
                                                        //    if (reulsttt.Content != (byte)(AlarmCode - 1))
                                                        //    {
                                                        //        WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "向PLC写入行驶状态数据:" + ((AlarmCode - 1)) + ",地标:" + info3.MARKNUM + "车号:" + info3.AGVNUM + ",当前路线为:" + info3.ROUTENUM + ",状态为" + info3.RUNSTATUS_Cur);
                                                        //    }
                                                        //}



                                                        //s7.Write(dr["行驶状态DB"].ToString(), (byte)(AlarmCode - 1));

                                                        var result = s7.ReadBool(dr["急停控制DB"].ToString());

                                                        if (dr.Table.Columns.Contains("离开互锁DB"))
                                                        {
                                                            if (!string.IsNullOrEmpty(dr["离开互锁DB"].ToString()))
                                                            {
                                                                var result2 = s7.ReadBool(dr["离开互锁DB"].ToString());
                                                                if (result2 != null && result2.IsSuccess)
                                                                {
                                                                    if (result2.Content == true && result.Content == true && info3.EmergencyFlag)
                                                                    {
                                                                        DispatcherTool.ControlAGVBy1071(info3.AGVNUM, 0);
                                                                        WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "(放行地标：" + info3.MARKNUM + ",放行路线：0" + ", " + ",车号:" + info3.AGVNUM + ",离开互锁DB值为true) ");
                                                                        info3.EmergencyFlag = false;
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                    continue;
                                                }
                                            }


                                        }

                                        //if (btn.Text.Contains("("))
                                        //{
                                        //    int textIndex = btn.Text.LastIndexOf("(");
                                        //    string orignName = btn.Text.Substring(0, textIndex).Replace("\n", "");
                                        //    btn.Text = orignName + "\n" + "(" + info.AGVNUM + ")";
                                        //}
                                        //else
                                        //{
                                        //    btn.Text = btn.Text.Replace("\n", "") + "\n" + "(" + info.AGVNUM + ")";
                                        //}

                                    }
                                    else
                                    {

                                        if (!string.IsNullOrEmpty(dr["AGVDB"].ToString()))
                                        {
                                            var reulsttt = s7.ReadByte(dr["AGVDB"].ToString());
                                            if (reulsttt != null && reulsttt.IsSuccess)
                                            {
                                                if (reulsttt.Content != (byte)0)
                                                {
                                                    WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "向PLC写入车号数据:0,当前工位无AGV");
                                                }
                                            }
                                            s7.Write(dr["AGVDB"].ToString(), (byte)0);
                                            s7.Write(dr["是否故障DB"].ToString(), false);
                                            //reulsttt = s7.ReadByte(dr["行驶状态DB"].ToString());
                                            //if (reulsttt != null && reulsttt.IsSuccess)
                                            //{
                                            //    if (reulsttt.Content != 0)
                                            //    {
                                            //        WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "向PLC写入行驶状态数据:0,当前工位无AGV");
                                            //    }
                                            //}
                                            //s7.Write(dr["行驶状态DB"].ToString(), (byte)0);
                                            var reulsttt2 = s7.ReadBool(dr["到位DB"].ToString());
                                            if (reulsttt2 != null && reulsttt2.IsSuccess)
                                            {
                                                if (reulsttt2.Content != false)
                                                {
                                                    WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "向PLC写入到位数据:false,当前工位无AGV");
                                                }
                                            }
                                            s7.Write(dr["到位DB"].ToString(), false);
                                            var reulsttt22 = s7.ReadBool(dr["离开DB"].ToString());
                                            if (reulsttt22 != null && reulsttt22.IsSuccess)
                                            {
                                                if (reulsttt22.Content != false)
                                                {
                                                    WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "向PLC写入离开DB数据:false,无车离开");
                                                }
                                            }
                                            if (!IsInOtherOutMarks)
                                            {
                                                s7.Write(dr["离开DB"].ToString(), false);

                                            }

                                            s7.Write(dr["已离开DB"].ToString(), false);
                                            //   if (btn.BackColor != Color.Blue)
                                            {
                                                //       btn.BackColor = SystemColors.Control;
                                            }
                                        }
                                    }
                                }
                                #endregion


                                #region   离开工位点
                                if (dr.Table.Columns.Contains("离开工位") && dr.Table.Columns.Contains("已离开DB"))
                                {

                                    if (!string.IsNullOrEmpty(dr["离开工位"].ToString()))
                                    {

                                        var infoList = infos.FindAll(o => o.MARKNUM.ToString() == dr["离开工位"].ToString() && o.ConnectStatus && o.RUNSTATUS_Cur == 0x41);   //&& (|| o.RUNSTATUS_Cur == 0x40)
                                        if (infoList.Count >= 1)
                                        {

                                            WriteFile("离开工位记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "3333有车到达离开工位地标" + dr["离开工位"].ToString());

                                            if (!string.IsNullOrEmpty(dr["已离开DB"].ToString()))
                                            {
                                                s7.Write(dr["已离开DB"].ToString(), true);
                                                s7.Write(dr["离开DB"].ToString(), false);
                                                Thread.Sleep(1200);
                                            }

                                        }
                                        else
                                        {
                                            if (!string.IsNullOrEmpty(dr["已离开DB"].ToString()))
                                            {
                                                s7.Write(dr["已离开DB"].ToString(), false);
                                            }
                                        }
                                    }
                                }
                                #endregion
                            }//));
                        }
                    }
                    catch (Exception)
                    {
                        // WriteFile("离开工位记录111-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "5555有车到达离开" + ex.Message);

                    }
                    finally
                    {
                        if (s7 != null)
                        {
                            s7.ConnectClose();
                        }
                    }
                    Thread.Sleep(500);
                }
            }
        }


        public void Test1()
        {

            while (true)
            {

                for (int i = 0; i < dtTestPLC.Rows.Count; i++)
                {
                    if (dtTestPLC.Rows[i] != null)
                    {
                        DataRow dr = (DataRow)dtTestPLC.Rows[i];

                        Console.WriteLine(dr["ID"].ToString() + ":" + dr["工位名称"].ToString());
                        HslCommunication.Profinet.Siemens.SiemensS7Net s7 = null;
                        try
                        {
                            //   Button btn = listAllBtns.Find(o => o.Tag.ToString() == dr["工位地标"].ToString());
                            //    if (btn == null) { return; }
                            var infos = GlobalPara.AgvInfoDic.Values.ToList();
                            //     btn.Invoke(new InvokeDelegate(delegate
                            //  for (int i = 0; i < dtSKQPLC.Rows.Count; i++)
                            {
                                if (!string.IsNullOrEmpty(dr["PLC类型"].ToString()))
                                {
                                    switch (dr["PLC类型"].ToString())
                                    {
                                        case "s1200":
                                            s7 = new HslCommunication.Profinet.Siemens.SiemensS7Net(HslCommunication.Profinet.Siemens.SiemensPLCS.S1200,
                                dr["IP地址"].ToString());
                                            break;
                                        case "s1500":
                                            s7 = new HslCommunication.Profinet.Siemens.SiemensS7Net(HslCommunication.Profinet.Siemens.SiemensPLCS.S1500,
                                dr["IP地址"].ToString());
                                            break;
                                        default:
                                            s7 = new HslCommunication.Profinet.Siemens.SiemensS7Net(HslCommunication.Profinet.Siemens.SiemensPLCS.S1500,
                                    dr["IP地址"].ToString());
                                            break;

                                    }

                                    s7.Rack = (byte)0;
                                    s7.Slot = (byte)1;
                                    s7.ConnectTimeOut = 1000;
                                    s7.ReceiveTimeOut = 1000;
                                    var connet = s7.ConnectServer();
                                    //    s7.LogNet = new HslCommunication.LogNet.LogNetSingle("logs.txt");


                                    if (!connet.IsSuccess)
                                    {

                                        GlobalPara.PLCTestDic.Add(dr["IP地址"].ToString(), s7);
                                        //GlobalPara.listSKQPLC.Add(DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss") + "  向PLC(" + dr["IP地址"].ToString() + ")的地址请求连接失败");
                                        WriteFile("SKQPLC对接记录" + DateTime.Now.ToString("yyyy-MM-dd") + "" + dr["IP地址"].ToString() + "", DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss") + "  向PLC(" + dr["IP地址"].ToString() + ")的地址请求连接失败");
                                        // return;
                                        //     PLCPackAlarm = true;

                                        lock (AlarmPackStations)
                                        {
                                            if (!AlarmPackStations.Contains(dr["工位名称"].ToString()))
                                            {
                                                AlarmPackStations.Add(dr["工位名称"].ToString());
                                            }
                                        }
                                        continue;
                                    }
                                    else
                                    {
                                        //         PLCPackAlarm = false;
                                        lock (AlarmPackStations)
                                        {
                                            if (AlarmPackStations.Contains(dr["工位名称"].ToString()))
                                            {
                                                AlarmPackStations.RemoveAll(o => o == dr["工位名称"].ToString());
                                            }
                                        }
                                    }

                                    if (dr.Table.Columns.Contains("PLC心跳DB") && dr.Table.Columns.Contains("中控心跳DB"))
                                    {
                                        if (!string.IsNullOrEmpty(dr["PLC心跳DB"].ToString()) && !string.IsNullOrEmpty(dr["中控心跳DB"].ToString()))
                                        {
                                            var result = s7.ReadBool(dr["PLC心跳DB"].ToString());
                                            if (result != null && result.IsSuccess)
                                            {
                                                s7.Write(dr["中控心跳DB"].ToString(), result.Content);
                                            }
                                        }
                                    }

                                    bool IsInOtherInMarks = false;
                                    if (dr.Table.Columns.Contains("其他进入中地标"))
                                    {
                                        if (!string.IsNullOrEmpty(dr["其他进入中地标"].ToString()))
                                        {
                                            List<string> list = dr["其他进入中地标"].ToString().Split(';').ToList();
                                            var infoList = infos.FindAll(o => list.Contains(o.MARKNUM.ToString()) && o.ConnectStatus && (o.RUNSTATUS_Cur == 0x40 || o.RUNSTATUS_Cur == 0x41));
                                            if (infoList != null && infoList.Count >= 1)
                                            {
                                                IsInOtherInMarks = true;
                                                s7.Write(dr["进入中DB"].ToString(), true);
                                            }
                                            else
                                            {
                                                //          s7.Write(dr["进入中DB"].ToString(), false);
                                            }
                                        }
                                    }


                                    #region  请求地标判断放行
                                    if (!string.IsNullOrEmpty(dr["请求地标"].ToString()))
                                    {
                                        var infoList = infos.FindAll(o => o.MARKNUM.ToString() == dr["请求地标"].ToString() && o.ConnectStatus);
                                        if (infoList.Count > 1)
                                        {
                                            var info = infoList.Find(o => o.RUNSTATUS_Cur == 0x40);//运行
                                            bool b2 = true;
                                            if (info != null)
                                            {

                                                s7.Write(dr["进入中DB"].ToString(), true);
                                                if (dr.Table.Columns.Contains("进入互锁DB"))
                                                {
                                                    if (!string.IsNullOrEmpty(dr["进入互锁DB"].ToString()))
                                                    {
                                                        var result2 = s7.ReadBool(dr["进入互锁DB"].ToString());
                                                        if (result2 != null && result2.IsSuccess)
                                                        {
                                                            if (result2.Content == false)
                                                            {
                                                                DispatcherTool.ControlAGVBy1071(info.AGVNUM, 1);
                                                                WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "(放行地标：" + info.MARKNUM + ",放行路线：0" + ", " + ",车号:" + info.AGVNUM + ",进入互锁DB为false) ");
                                                                info.EmergencyFlag = true;
                                                                s7.Write(dr["进入中DB"].ToString(), false);
                                                            }
                                                        }
                                                    }
                                                }

                                                var result = s7.ReadBool(dr["急停控制DB"].ToString());
                                                if (result != null && result.IsSuccess)
                                                {
                                                    if (result.Content == false)
                                                    {
                                                        DispatcherTool.ControlAGVBy1071(info.AGVNUM, 1);
                                                        WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "(放行地标：" + info.MARKNUM + ",放行路线：0" + ", " + ",车号:" + info.AGVNUM + ",急停) ");
                                                        info.EmergencyFlag = true;
                                                    }
                                                }

                                                b2 = false;
                                                //         WriteFile("SKQPLC对接记录" + DateTime.Now.ToString("yyyy-MM-dd") + "" + dr["IP地址"].ToString() + "", DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss") + "  向PLC(" + dr["IP地址"].ToString() + ")的地址" + dr["进入中DB"].ToString() + ",写入数据:true(AGV在进入地标运行中,等待地标大于1台车),车号:" + info.AGVNUM);

                                            }
                                            if (b2)
                                            {
                                                info = infoList.Find(o => o.RUNSTATUS_Cur == 0x41);  //暂停
                                                if (info != null)
                                                {
                                                    s7.Write(dr["进入中DB"].ToString(), false);
                                                    var result = s7.ReadBool(dr["允许DB"].ToString());
                                                    bool b = true;
                                                    if (result != null && result.IsSuccess)
                                                    {
                                                        bool bb = true;
                                                        if (dr.Table.Columns.Contains("进入互锁DB"))
                                                        {
                                                            if (!string.IsNullOrEmpty(dr["进入互锁DB"].ToString()))
                                                            {
                                                                var result2 = s7.ReadBool(dr["进入互锁DB"].ToString());
                                                                if (result2 != null && result2.IsSuccess)
                                                                {
                                                                    if (result2.Content == false)
                                                                    {
                                                                        bb = false;
                                                                    }
                                                                }
                                                                else
                                                                {
                                                                    bb = false;
                                                                }
                                                            }
                                                        }
                                                        if (result.Content == true && bb)
                                                        {
                                                            b = false;
                                                            s7.Write(dr["进入中DB"].ToString(), true);
                                                            Thread.Sleep(1000);
                                                            s7.Write(dr["请求DB"].ToString(), false);

                                                            DispatcherTool.ReleaseAgvOnStop(info.MARKNUM, 0, 10);
                                                            WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "(放行地标：" + info.MARKNUM + ",放行路线：0" + ", " + ",车号:" + info.AGVNUM + ",进入自动位) ");

                                                            //         WriteFile("SKQPLC对接记录" + DateTime.Now.ToString("yyyy-MM-dd") + "" + dr["IP地址"].ToString() + "", DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss") + "  向PLC(" + dr["IP地址"].ToString() + ")的地址" + dr["进入中DB"].ToString() + ",写入数据:true(PLC允许进入),车号:" + infoList[0].AGVNUM);
                                                        }
                                                    }
                                                    if (b)
                                                    {
                                                        s7.Write(dr["请求DB"].ToString(), true);
                                                        //     WriteFile("SKQPLC对接记录" + DateTime.Now.ToString("yyyy-MM-dd") + "" + dr["IP地址"].ToString() + "", DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss") + "  向PLC(" + dr["IP地址"].ToString() + ")的地址" + dr["请求DB"].ToString() + ",写入数据:true(AGV在等待点地标，请求PLC进入),车号:" + infoList[0].AGVNUM);
                                                    }
                                                    //         WriteFile("SKQPLC对接记录" + DateTime.Now.ToString("yyyy-MM-dd") + "" + dr["IP地址"].ToString() + "", DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss") + "  向PLC(" + dr["IP地址"].ToString() + ")的地址" + dr["进入中DB"].ToString() + ",写入数据:true(AGV在进入地标运行中,等待地标大于1台车),车号:" + info.AGVNUM);
                                                }
                                                else
                                                {
                                                    s7.Write(dr["进入中DB"].ToString(), false);
                                                    var result = s7.ReadBool(dr["急停控制DB"].ToString());

                                                    if (dr.Table.Columns.Contains("进入互锁DB"))
                                                    {
                                                        if (!string.IsNullOrEmpty(dr["进入互锁DB"].ToString()))
                                                        {
                                                            var info3 = infoList.Find(o => o.RUNSTATUS_Cur == 0x43);
                                                            if (info3 != null)
                                                            {
                                                                var result2 = s7.ReadBool(dr["进入互锁DB"].ToString());
                                                                if (result2 != null && result2.IsSuccess)
                                                                {
                                                                    if (result2.Content == true && info3.EmergencyFlag && result.Content == true)
                                                                    {

                                                                        DispatcherTool.ControlAGVBy1071(info3.AGVNUM, 0);
                                                                        WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "(放行地标：" + info3.MARKNUM + ",放行路线：0" + ", " + ",车号:" + info3.AGVNUM + ",进入互锁DB为true) ");
                                                                        info3.EmergencyFlag = false;
                                                                        s7.Write(dr["进入中DB"].ToString(), true);
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                    //         WriteFile("SKQPLC对接记录" + DateTime.Now.ToString("yyyy-MM-dd") + "" + dr["IP地址"].ToString() + "", DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss") + "  向PLC(" + dr["IP地址"].ToString() + ")的地址" + dr["进入中DB"].ToString() + ",写入数据:false(无AGV在进入地标运行,等待地标大于1台车),车号:" + info.AGVNUM);
                                                }
                                            }
                                            else
                                            {

                                            }
                                        }
                                        else if (infoList.Count == 1)
                                        {
                                            if (infoList[0].RUNSTATUS_Cur == 0x40)
                                            {
                                                //if (dr["IP地址"].ToString() == "192.168.101.34")
                                                //{
                                                //add by cjs 20211126 for conminitite with plc begin--  到位之后开始通讯
                                                if (s7 != null)
                                                {
                                                    string resultRead1 = "";
                                                    string resultRead2 = "";

                                                    if (dr.Table.Columns.Contains("SN1发送DB") && dr.Table.Columns.Contains("SN2发送DB"))
                                                    {

                                                        //  PLCSql.PLCSqlSelect(infoList[0].AGVNUM.ToString(), "2", ref resultRead1, ref resultRead2); //查询数据

                                                        if (!string.IsNullOrEmpty(dr["SN1发送DB"].ToString()))
                                                        {

                                                            //OperateResult rs2 = s7.Write(dr["AGVDB"].ToString(), info.AGVNUM.ToString());
                                                            if (resultRead1 != null)
                                                            {
                                                                int s = resultRead1.Length;
                                                                OperateResult rs = s7.Write(dr["SN1发送DB"].ToString(), resultRead1.Trim());

                                                            }

                                                        }

                                                        if (!string.IsNullOrEmpty(dr["SN2发送DB"].ToString()) && resultRead2 != null)
                                                        {

                                                            OperateResult rs1 = s7.Write(dr["SN2发送DB"].ToString(), resultRead2.Trim());
                                                        }

                                                        // WriteFile("查询SN记录", "AGVID+" + info.AGVNUM.ToString() + "SN1DB+" + resultRead1 + "SN2DB+" + resultRead2 + DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss"));

                                                    }
                                                }
                                                //add by cjs 20211126 for conminitite with plc  end

                                                //}

                                                var result = s7.ReadBool(dr["急停控制DB"].ToString());
                                                if (result != null && result.IsSuccess)
                                                {
                                                    if (result.Content == false)
                                                    {
                                                        DispatcherTool.ControlAGVBy1071(infoList[0].AGVNUM, 1);
                                                        WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "(放行地标：" + infoList[0].MARKNUM + ",放行路线：0" + ", " + ",车号:" + infoList[0].AGVNUM + ",急停) ");
                                                        infoList[0].EmergencyFlag = true;
                                                    }
                                                }


                                                s7.Write(dr["进入中DB"].ToString(), true);
                                                s7.Write(dr["请求DB"].ToString(), false);
                                                //       WriteFile("SKQPLC对接记录" + DateTime.Now.ToString("yyyy-MM-dd") + "" + dr["IP地址"].ToString() + "", DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss") + "  向PLC(" + dr["IP地址"].ToString() + ")的地址" + dr["进入中DB"].ToString() + ",写入数据:true(AGV在进入地标运行中),车号:" + infoList[0].AGVNUM);
                                                if (dr.Table.Columns.Contains("进入互锁DB"))
                                                {
                                                    if (!string.IsNullOrEmpty(dr["进入互锁DB"].ToString()))
                                                    {
                                                        var result2 = s7.ReadBool(dr["进入互锁DB"].ToString());
                                                        if (result2 != null && result2.IsSuccess)
                                                        {
                                                            if (result2.Content == false)
                                                            {
                                                                DispatcherTool.ControlAGVBy1071(infoList[0].AGVNUM, 1);
                                                                WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "(放行地标：" + infoList[0].MARKNUM + ",放行路线：0" + ", " + ",车号:" + infoList[0].AGVNUM + ",进入互锁DB为false) ");
                                                                infoList[0].EmergencyFlag = true;
                                                                s7.Write(dr["进入中DB"].ToString(), false);
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                            else if (infoList[0].RUNSTATUS_Cur == 0x41)
                                            {
                                                s7.Write(dr["进入中DB"].ToString(), false);
                                                var result = s7.ReadBool(dr["允许DB"].ToString());
                                                bool b = true;
                                                if (result != null && result.IsSuccess)
                                                {
                                                    bool bb = true;
                                                    if (dr.Table.Columns.Contains("进入互锁DB"))
                                                    {
                                                        if (!string.IsNullOrEmpty(dr["进入互锁DB"].ToString()))
                                                        {
                                                            var result2 = s7.ReadBool(dr["进入互锁DB"].ToString());
                                                            if (result2 != null && result2.IsSuccess)
                                                            {
                                                                if (result2.Content == false)
                                                                {
                                                                    bb = false;
                                                                }
                                                            }
                                                            else
                                                            {
                                                                bb = false;
                                                            }
                                                        }
                                                    }
                                                    if (result.Content == true && bb)
                                                    {
                                                        b = false;
                                                        s7.Write(dr["进入中DB"].ToString(), true);
                                                        Thread.Sleep(1000);
                                                        s7.Write(dr["请求DB"].ToString(), false);

                                                        DispatcherTool.ReleaseAgvOnStop(infoList[0].MARKNUM, 0, 10);
                                                        WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "(放行地标：" + infoList[0].MARKNUM + ",放行路线：0" + ", " + ",车号:" + infoList[0].AGVNUM + ",进入自动位) ");


                                                        //         WriteFile("SKQPLC对接记录" + DateTime.Now.ToString("yyyy-MM-dd") + "" + dr["IP地址"].ToString() + "", DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss") + "  向PLC(" + dr["IP地址"].ToString() + ")的地址" + dr["进入中DB"].ToString() + ",写入数据:true(PLC允许进入),车号:" + infoList[0].AGVNUM);
                                                    }
                                                }
                                                if (b)
                                                {
                                                    s7.Write(dr["请求DB"].ToString(), true);
                                                    //     WriteFile("SKQPLC对接记录" + DateTime.Now.ToString("yyyy-MM-dd") + "" + dr["IP地址"].ToString() + "", DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss") + "  向PLC(" + dr["IP地址"].ToString() + ")的地址" + dr["请求DB"].ToString() + ",写入数据:true(AGV在等待点地标，请求PLC进入),车号:" + infoList[0].AGVNUM);
                                                }
                                            }
                                            else
                                            {

                                                var result = s7.ReadBool(dr["急停控制DB"].ToString());

                                                s7.Write(dr["进入中DB"].ToString(), false);
                                                if (dr.Table.Columns.Contains("进入互锁DB"))
                                                {
                                                    if (!string.IsNullOrEmpty(dr["进入互锁DB"].ToString()))
                                                    {
                                                        var info3 = infoList.Find(o => o.RUNSTATUS_Cur == 0x43);
                                                        if (info3 != null)
                                                        {
                                                            var result2 = s7.ReadBool(dr["进入互锁DB"].ToString());
                                                            if (result2 != null && result2.IsSuccess)
                                                            {
                                                                if (result2.Content == true && info3.EmergencyFlag && result.Content == true)
                                                                {
                                                                    DispatcherTool.ControlAGVBy1071(info3.AGVNUM, 0);
                                                                    WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "(放行地标：" + info3.MARKNUM + ",放行路线：0" + ", " + ",车号:" + info3.AGVNUM + ",进入互锁DB为true) ");
                                                                    info3.EmergencyFlag = false;
                                                                    s7.Write(dr["进入中DB"].ToString(), true);
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                                //      WriteFile("SKQPLC对接记录" + DateTime.Now.ToString("yyyy-MM-dd") + "" + dr["IP地址"].ToString() + "", DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss") + "  向PLC(" + dr["IP地址"].ToString() + ")的地址" + dr["进入中DB"].ToString() + ",写入数据:false(AGV状态不符合),车号:" + infoList[0].AGVNUM);
                                            }
                                        }
                                        else
                                        {
                                            if (!IsInOtherInMarks)
                                            {
                                                s7.Write(dr["进入中DB"].ToString(), false);
                                            }
                                            s7.Write(dr["请求DB"].ToString(), false);
                                            //    WriteFile("SKQPLC对接记录" + DateTime.Now.ToString("yyyy-MM-dd") + "" + dr["IP地址"].ToString() + "", DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss") + "  向PLC(" + dr["IP地址"].ToString() + ")的地址" + dr["进入中DB"].ToString() + ",写入数据:false(无车在进入地标运行),车号:无");
                                        }
                                    }
                                    #endregion
                                    bool IsInOtherOutMarks = false;
                                    if (dr.Table.Columns.Contains("其他离开中地标"))
                                    {
                                        if (!string.IsNullOrEmpty(dr["其他离开中地标"].ToString()))
                                        {
                                            List<string> list = dr["其他离开中地标"].ToString().Split(';').ToList();
                                            var infoList = infos.FindAll(o => list.Contains(o.MARKNUM.ToString()) && o.ConnectStatus && (o.RUNSTATUS_Cur == 0x40 || o.RUNSTATUS_Cur == 0x41));
                                            if (infoList != null && infoList.Count >= 1)
                                            {
                                                IsInOtherOutMarks = true;
                                                s7.Write(dr["离开DB"].ToString(), true);
                                            }
                                            else
                                            {
                                                //      s7.Write(dr["离开DB"].ToString(), false);
                                            }
                                        }
                                    }


                                    #region   工位地标判断放行
                                    if (!string.IsNullOrEmpty(dr["工位地标"].ToString()))
                                    {
                                        var t2 = listObjs.Find(o => o["Mark"].ToString() == dr["工位地标"].ToString());
                                        if (t2 != null)
                                        {
                                            continue;
                                        }

                                        var infoList = infos.FindAll(o => o.MARKNUM.ToString() == dr["工位地标"].ToString() && o.ConnectStatus);
                                        if (infoList != null && infoList.Count >= 1)
                                        {
                                            // foreach (var info in infoList)
                                            var info = infoList.Find(o => o.RUNSTATUS_Cur == 0x41 || o.RUNSTATUS_Cur == 0x44); //停止
                                            if (info != null)
                                            {


                                                if (!string.IsNullOrEmpty(dr["急停控制DB"].ToString()))
                                                {
                                                    var result11 = s7.ReadBool(dr["急停控制DB"].ToString());  //线束信号
                                                    if (result11 != null && result11.IsSuccess)
                                                    {
                                                        if (result11.Content == false)
                                                        {

                                                            info.EmergencyCar = false;
                                                        }
                                                        else
                                                        {
                                                            info.EmergencyCar = true;
                                                        }
                                                    }
                                                }


                                                if (!string.IsNullOrEmpty(dr["AGVDB"].ToString()))
                                                {
                                                    var reulsttt = s7.ReadByte(dr["AGVDB"].ToString());
                                                    if (reulsttt != null && reulsttt.IsSuccess)
                                                    {
                                                        if (reulsttt.Content != (byte)info.AGVNUM)
                                                        {
                                                            WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "向PLC写入车号数据:" + info.AGVNUM + ",地标:" + info.MARKNUM + "车号:" + info.AGVNUM + ",当前路线为:" + info.ROUTENUM + ",状态为" + info.RUNSTATUS_Cur);
                                                        }
                                                    }
                                                    var resultt = s7.Write(dr["AGVDB"].ToString(), (byte)info.AGVNUM);
                                                    //if (info.RUNSTATUS_Cur == 0x41 || info.RUNSTATUS_Cur == 0x44)
                                                    {
                                                        var reulsttt2 = s7.ReadBool(dr["到位DB"].ToString());
                                                        if (reulsttt2 != null && reulsttt2.IsSuccess)
                                                        {
                                                            if (reulsttt2.Content != true)
                                                            {
                                                                WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "向PLC写入到位数据:true,地标:" + info.MARKNUM + "车号:" + info.AGVNUM + ",当前路线为:" + info.ROUTENUM + ",状态为" + info.RUNSTATUS_Cur);
                                                            }
                                                        }
                                                        resultt = s7.Write(dr["到位DB"].ToString(), true);




                                                        var reulsttt22 = s7.ReadBool(dr["离开DB"].ToString());
                                                        if (reulsttt22 != null && reulsttt22.IsSuccess)
                                                        {
                                                            if (reulsttt22.Content != false)
                                                            {
                                                                WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "向PLC写入离开DB数据:false(到位),地标:" + info.MARKNUM + "车号:" + info.AGVNUM + ",当前路线为:" + info.ROUTENUM + ",状态为" + info.RUNSTATUS_Cur);
                                                            }
                                                        }
                                                        if (!IsInOtherOutMarks)
                                                        {
                                                            resultt = s7.Write(dr["离开DB"].ToString(), false);
                                                        }

                                                        resultt = s7.Write(dr["离开DB"].ToString(), false);
                                                        //      if (btn.BackColor != Color.Blue)
                                                        {
                                                            //          btn.BackColor = Color.Yellow;
                                                        }
                                                        string addr = dr["放行DB"].ToString();
                                                        var result = s7.ReadBool(addr);
                                                        if (result != null && result.IsSuccess)
                                                        {
                                                            bool bb = true;
                                                            if (dr.Table.Columns.Contains("离开互锁DB"))
                                                            {
                                                                if (!string.IsNullOrEmpty(dr["离开互锁DB"].ToString()))
                                                                {
                                                                    var result2 = s7.ReadBool(dr["离开互锁DB"].ToString());
                                                                    if (result2 != null && result2.IsSuccess)
                                                                    {
                                                                        if (result2.Content == false)
                                                                        {
                                                                            WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "离开互锁DB值:" + result2.Content);
                                                                            bb = false;
                                                                        }
                                                                    }
                                                                }
                                                            }

                                                            if (result.Content == true && bb )
                                                            {
                                                                var result2 = s7.ReadInt16(dr["放行路径DB"].ToString());


                                                                if (result2 != null && result2.IsSuccess)  //加上允许放行信号   // && info.AllowReleaseFlag
                                                                {
                                                                    //       WriteFile("工位点记录-"+ dr["IP地址"].ToString() + "-"  + DateTime.Now.ToString("yyyy-MM-dd"),"放行路径DB值:"+result2.Content);
                                                                    if (result2.Content == (short.Parse("1")))//OK路线
                                                                    {
                                                                        //lock (afterRelease)
                                                                        //{
                                                                        //    string tempStr = info.AGVNUM + ",400,64";
                                                                        //    if (!afterRelease.Contains(tempStr))
                                                                        //    {
                                                                        //        afterRelease.Add(tempStr);
                                                                        //    }

                                                                        OperateResult rs1 = s7.Write(dr["SN1发送DB"].ToString(), "");

                                                                        if (!string.IsNullOrEmpty(dr["SN2发送DB"].ToString()))
                                                                        {

                                                                            OperateResult rs2 = s7.Write(dr["SN2发送DB"].ToString(), "");
                                                                        }
                                                                        if (!string.IsNullOrEmpty(dr["修改完成DB"].ToString()))
                                                                        {

                                                                            OperateResult rs = s7.Write(dr["修改完成DB"].ToString(), false);
                                                                        }


                                                                        DispatcherTool.ReleaseAgvOnStop(info.MARKNUM, 0, 10);
                                                                        if (!string.IsNullOrEmpty(dr["请求地标"].ToString()))
                                                                        {
                                                                            var tempp = listObjs.Find(o => o["Mark"].ToString() == info.MARKNUM.ToString());
                                                                            if (tempp == null)
                                                                            {
                                                                                JObject obj = new JObject();
                                                                                obj["Mark"] = info.MARKNUM;
                                                                                obj["AGVID"] = info.AGVNUM;
                                                                                obj["Secs"] = 2000;
                                                                                listObjs.Add(obj);
                                                                            }
                                                                            s7.Write(dr["到位DB"].ToString(), false);
                                                                            s7.Write(dr["离开DB"].ToString(), true);
                                                                        }
                                                                        WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "(放行地标：" + info.MARKNUM + ",放行路线：0" + ", " + ",车号:" + info.AGVNUM + ",OK放行) ");


                                                                    }
                                                                    else if (result2.Content > 1)  //NG路线
                                                                    {
                                                                        //lock (afterRelease)
                                                                        //{
                                                                        //    string tempStr = info.AGVNUM + ",400,64";
                                                                        //    if (!afterRelease.Contains(tempStr))
                                                                        //    {
                                                                        //        afterRelease.Add(tempStr);
                                                                        //    }
                                                                        //}

                                                                        OperateResult rs1 = s7.Write(dr["SN1发送DB"].ToString(), "");

                                                                        if (!string.IsNullOrEmpty(dr["SN2发送DB"].ToString()))
                                                                        {

                                                                            OperateResult rs2 = s7.Write(dr["SN2发送DB"].ToString(), "");
                                                                        }
                                                                        if (!string.IsNullOrEmpty(dr["修改完成DB"].ToString()))
                                                                        {

                                                                            OperateResult rs = s7.Write(dr["修改完成DB"].ToString(), false);
                                                                        }

                                                                        if (!string.IsNullOrEmpty(dr["修改完成DB"].ToString()))
                                                                        {
                                                                            OperateResult rs = s7.Write(dr["修改完成DB"].ToString(), false);
                                                                        }

                                                                        DispatcherTool.ReleaseAgvOnStop(info.MARKNUM, int.Parse(dr["NG路线"].ToString()), 10);

                                                                        WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "(放行地标：" + info.MARKNUM + ",放行路线：" + dr["NG路线"].ToString() + ", " + ",车号:" + info.AGVNUM + ",NG放行) ");
                                                                    }

                                                                    var reulsttt33 = s7.ReadBool(dr["修改完成DB"].ToString());
                                                                    if (reulsttt33 != null && reulsttt33.IsSuccess)
                                                                    {
                                                                        if (reulsttt22.Content != false)
                                                                        {
                                                                            OperateResult rs = s7.Write(dr["修改完成DB"].ToString(), false);
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                        result = s7.ReadBool(dr["屏蔽DB"].ToString());  //收到屏蔽信号 直接放行
                                                        if (result != null && result.IsSuccess)
                                                        {
                                                            if (result.Content == true)
                                                            {
                                                                // DispatcherTool.ReleaseAgvOnStop(info.MARKNUM, 0, 10);
                                                                info.AllowMesReleaseFlag = true;
                                                                WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "(放行地标：" + info.MARKNUM + ",放行路线：0" + ", " + ",车号:" + info.AGVNUM + ",屏蔽放行) ");
                                                            }
                                                        }
                                                        int AlarmCode = int.Parse(info.ALARMCODE);
                                                        if (AlarmCode == 1 || AlarmCode == 5 || AlarmCode == 9 || AlarmCode == 256)
                                                        {
                                                            s7.Write(dr["是否故障DB"].ToString(), false);

                                                        }
                                                        else
                                                        {
                                                            s7.Write(dr["是否故障DB"].ToString(), true);
                                                            CarAlarmFlag = true;
                                                        }
                                                        if (AlarmCode == 256) { AlarmCode = 1; }
                                                        reulsttt = s7.ReadByte(dr["行驶状态DB"].ToString());
                                                        if (reulsttt != null && reulsttt.IsSuccess)
                                                        {
                                                            if (reulsttt.Content != (byte)(AlarmCode - 1))
                                                            {
                                                                WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "向PLC写入行驶状态数据:" + ((AlarmCode - 1)) + ",地标:" + info.MARKNUM + "车号:" + info.AGVNUM + ",当前路线为:" + info.ROUTENUM + ",状态为" + info.RUNSTATUS_Cur);
                                                            }
                                                        }
                                                        s7.Write(dr["行驶状态DB"].ToString(), (byte)(AlarmCode - 1));
                                                    }

                                                }
                                                continue;
                                            }
                                            else
                                            {
                                                var info2 = infoList.Find(o => o.RUNSTATUS_Cur == 0x40); //运行
                                                if (info2 != null)
                                                {
                                                    info2.IsReachFlag = false;
                                                    info2.EmergencyFlag = false;

                                                    if (!string.IsNullOrEmpty(dr["急停控制DB"].ToString()))
                                                    {
                                                        var result = s7.ReadBool(dr["急停控制DB"].ToString());
                                                        if (result != null && result.IsSuccess)
                                                        {
                                                            if (result.Content == false)
                                                            {
                                                                DispatcherTool.ControlAGVBy1071(info2.AGVNUM, 1);
                                                                WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "(放行地标：" + info2.MARKNUM + ",放行路线：0" + ", " + ",车号:" + info2.AGVNUM + ",急停) ");
                                                                info2.EmergencyFlag = true;
                                                            }

                                                        }
                                                    }


                                                    if (!string.IsNullOrEmpty(dr["AGVDB"].ToString()))
                                                    {

                                                        var reulsttt = s7.ReadByte(dr["AGVDB"].ToString());
                                                        if (reulsttt != null && reulsttt.IsSuccess)
                                                        {
                                                            if (reulsttt.Content != (byte)info2.AGVNUM)
                                                            {
                                                                WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "向PLC写入车号数据:" + info2.AGVNUM + ",地标:" + info2.MARKNUM + "车号:" + info2.AGVNUM + ",当前路线为:" + info2.ROUTENUM + ",状态为" + info2.RUNSTATUS_Cur);
                                                            }
                                                        }
                                                        var reulsttt2 = s7.ReadBool(dr["到位DB"].ToString());
                                                        if (reulsttt2 != null && reulsttt2.IsSuccess)
                                                        {
                                                            if (reulsttt2.Content != false)
                                                            {
                                                                WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "向PLC写入到位数据:false,地标:" + info2.MARKNUM + "车号:" + info2.AGVNUM + ",当前路线为:" + info2.ROUTENUM + ",状态为" + info2.RUNSTATUS_Cur);
                                                            }
                                                        }
                                                        s7.Write(dr["AGVDB"].ToString(), (byte)info2.AGVNUM);

                                                        s7.Write(dr["到位DB"].ToString(), false);
                                                        var reulsttt22 = s7.ReadBool(dr["离开DB"].ToString());
                                                        if (reulsttt22 != null && reulsttt22.IsSuccess)
                                                        {
                                                            if (reulsttt22.Content != true)
                                                            {
                                                                WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "向PLC写入离开DB数据:true(离站),地标:" + info2.MARKNUM + "车号:" + info2.AGVNUM + ",当前路线为:" + info2.ROUTENUM + ",状态为" + info2.RUNSTATUS_Cur);
                                                            }
                                                        }
                                                        s7.Write(dr["离开DB"].ToString(), true);
                                                        //      if (btn.BackColor != Color.Blue)
                                                        {
                                                            //          btn.BackColor = Color.Green;
                                                        }


                                                        int AlarmCode = int.Parse(info2.ALARMCODE);
                                                        if (AlarmCode == 1 || AlarmCode == 5 || AlarmCode == 9 || AlarmCode == 256)
                                                        {
                                                            s7.Write(dr["是否故障DB"].ToString(), false);
                                                        }
                                                        else
                                                        {
                                                            s7.Write(dr["是否故障DB"].ToString(), true);
                                                            CarAlarmFlag = true;
                                                        }

                                                        if (AlarmCode == 256) { AlarmCode = 1; }
                                                        //  reulsttt = s7.ReadByte(dr["行驶状态DB"].ToString());
                                                        if (reulsttt != null && reulsttt.IsSuccess)
                                                        {
                                                            if (reulsttt.Content != (byte)(AlarmCode - 1))
                                                            {
                                                                WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "向PLC写入行驶状态数据:" + ((AlarmCode - 1)) + ",地标:" + info2.MARKNUM + "车号:" + info2.AGVNUM + ",当前路线为:" + info2.ROUTENUM + ",状态为" + info2.RUNSTATUS_Cur);
                                                            }
                                                        }
                                                        //  s7.Write(dr["行驶状态DB"].ToString(), (byte)(AlarmCode - 1));
                                                        if (dr.Table.Columns.Contains("离开互锁DB"))
                                                        {
                                                            if (!string.IsNullOrEmpty(dr["离开互锁DB"].ToString()))
                                                            {
                                                                var result2 = s7.ReadBool(dr["离开互锁DB"].ToString());
                                                                if (result2 != null && result2.IsSuccess)
                                                                {
                                                                    if (result2.Content == false)
                                                                    {
                                                                        DispatcherTool.ControlAGVBy1071(info2.AGVNUM, 1); //不互锁 放行
                                                                        WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "(放行地标：" + info2.MARKNUM + ",放行路线：0" + ", " + ",车号:" + info2.AGVNUM + ",离开互锁DB值为false) ");
                                                                        info2.EmergencyFlag = true;
                                                                    }
                                                                }
                                                            }
                                                        }
                                                        continue;
                                                    }
                                                }
                                                else
                                                {

                                                    var info3 = infoList.Find(o => o.RUNSTATUS_Cur == 0x43);
                                                    if (info3 != null)
                                                    {
                                                        info3.IsReachFlag = false;

                                                        if (!string.IsNullOrEmpty(dr["SN1发送DB"].ToString()))
                                                        {
                                                            OperateResult rs1 = s7.Write(dr["SN1发送DB"].ToString(), "");
                                                        }


                                                        if (!string.IsNullOrEmpty(dr["SN2发送DB"].ToString()))
                                                        {

                                                            OperateResult rs2 = s7.Write(dr["SN2发送DB"].ToString(), "");
                                                        }
                                                        if (!string.IsNullOrEmpty(dr["修改完成DB"].ToString()))
                                                        {

                                                            OperateResult rs = s7.Write(dr["修改完成DB"].ToString(), false);
                                                        }

                                                        if (!string.IsNullOrEmpty("急停控制DB"))
                                                        {
                                                            var result = s7.ReadBool(dr["急停控制DB"].ToString());
                                                            if (result != null && result.IsSuccess)
                                                            {
                                                                if (result.Content == true && info3.EmergencyFlag)
                                                                {
                                                                    //  DispatcherTool.ControlAGVBy1071(info3.AGVNUM, 0);
                                                                    WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "(放行地标：" + info3.MARKNUM + ",放行路线：0" + ", " + ",车号:" + info3.AGVNUM + ",离开互锁DB值为true) ");

                                                                }
                                                            }
                                                        }



                                                        if (!string.IsNullOrEmpty("AGVDB"))
                                                        {
                                                            var reulsttt = s7.ReadByte(dr["AGVDB"].ToString());
                                                            if (reulsttt != null && reulsttt.IsSuccess)
                                                            {
                                                                if (reulsttt.Content != (byte)info3.AGVNUM)
                                                                {
                                                                    WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "向PLC写入车号数据:" + info3.AGVNUM + ",地标:" + info3.MARKNUM + "车号:" + info3.AGVNUM + ",当前路线为:" + info3.ROUTENUM + ",状态为" + info3.RUNSTATUS_Cur);
                                                                }
                                                            }
                                                            s7.Write(dr["AGVDB"].ToString(), (byte)info3.AGVNUM);
                                                            var reulsttt2 = s7.ReadBool(dr["到位DB"].ToString());
                                                            if (reulsttt2 != null && reulsttt2.IsSuccess)
                                                            {
                                                                if (reulsttt2.Content != false)
                                                                {
                                                                    WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "向PLC写入到位数据:false,地标:" + info3.MARKNUM + "车号:" + info3.AGVNUM + ",当前路线为:" + info3.ROUTENUM + ",状态为" + info3.RUNSTATUS_Cur);
                                                                }
                                                            }
                                                            s7.Write(dr["到位DB"].ToString(), false);
                                                            var reulsttt22 = s7.ReadBool(dr["离开DB"].ToString());
                                                            if (reulsttt22 != null && reulsttt22.IsSuccess)
                                                            {
                                                                if (reulsttt22.Content != false)
                                                                {
                                                                    WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "向PLC写入离开DB数据:false(暂停),地标:" + info3.MARKNUM + "车号:" + info3.AGVNUM + ",当前路线为:" + info3.ROUTENUM + ",状态为" + info3.RUNSTATUS_Cur);
                                                                }
                                                            }
                                                            if (!IsInOtherOutMarks)
                                                            {
                                                                s7.Write(dr["离开DB"].ToString(), false);
                                                                s7.Write(dr["已离开DB"].ToString(), false);
                                                            }
                                                            //           if (btn.BackColor != Color.Blue)
                                                            {
                                                                //               btn.BackColor = Color.Red;
                                                            }

                                                            //if (result != null && result.IsSuccess)
                                                            //{
                                                            //    if (result.Content == true && info3.EmergencyFlag)
                                                            //    {
                                                            //        DispatcherTool.ControlAGVBy1071(info3.AGVNUM, 0, 10);
                                                            //        WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "(放行地标：" + info3.MARKNUM + ",放行路线：0" + ", " + ",车号:" + info3.AGVNUM + ",释放急停) ");
                                                            //        info3.EmergencyFlag = false;
                                                            //    }
                                                            //}
                                                            int AlarmCode = int.Parse(info3.ALARMCODE);
                                                            if (AlarmCode == 1 || AlarmCode == 5 || AlarmCode == 9 || AlarmCode == 256)
                                                            {
                                                                s7.Write(dr["是否故障DB"].ToString(), false);
                                                            }
                                                            else
                                                            {
                                                                s7.Write(dr["是否故障DB"].ToString(), true);
                                                                CarAlarmFlag = true;
                                                            }
                                                            if (AlarmCode == 256) { AlarmCode = 1; }
                                                            reulsttt = s7.ReadByte(dr["行驶状态DB"].ToString());
                                                            if (reulsttt != null && reulsttt.IsSuccess)
                                                            {
                                                                if (reulsttt.Content != (byte)(AlarmCode - 1))
                                                                {
                                                                    WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "向PLC写入行驶状态数据:" + ((AlarmCode - 1)) + ",地标:" + info3.MARKNUM + "车号:" + info3.AGVNUM + ",当前路线为:" + info3.ROUTENUM + ",状态为" + info3.RUNSTATUS_Cur);
                                                                }
                                                            }



                                                            s7.Write(dr["行驶状态DB"].ToString(), (byte)(AlarmCode - 1));

                                                            var result = s7.ReadBool(dr["急停控制DB"].ToString());

                                                            if (dr.Table.Columns.Contains("离开互锁DB"))
                                                            {
                                                                if (!string.IsNullOrEmpty(dr["离开互锁DB"].ToString()))
                                                                {
                                                                    var result2 = s7.ReadBool(dr["离开互锁DB"].ToString());
                                                                    if (result2 != null && result2.IsSuccess)
                                                                    {
                                                                        if (result2.Content == true && result.Content == true && info3.EmergencyFlag)
                                                                        {
                                                                            DispatcherTool.ControlAGVBy1071(info3.AGVNUM, 0);
                                                                            WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "(放行地标：" + info3.MARKNUM + ",放行路线：0" + ", " + ",车号:" + info3.AGVNUM + ",离开互锁DB值为true) ");
                                                                            info3.EmergencyFlag = false;
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                        continue;
                                                    }
                                                }


                                            }

                                            //if (btn.Text.Contains("("))
                                            //{
                                            //    int textIndex = btn.Text.LastIndexOf("(");
                                            //    string orignName = btn.Text.Substring(0, textIndex).Replace("\n", "");
                                            //    btn.Text = orignName + "\n" + "(" + info.AGVNUM + ")";
                                            //}
                                            //else
                                            //{
                                            //    btn.Text = btn.Text.Replace("\n", "") + "\n" + "(" + info.AGVNUM + ")";
                                            //}

                                        }
                                        else
                                        {

                                            if (!string.IsNullOrEmpty(dr["AGVDB"].ToString()))
                                            {
                                                var reulsttt = s7.ReadByte(dr["AGVDB"].ToString());
                                                if (reulsttt != null && reulsttt.IsSuccess)
                                                {
                                                    if (reulsttt.Content != (byte)0)
                                                    {
                                                        WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "向PLC写入车号数据:0,当前工位无AGV");
                                                    }
                                                }
                                                s7.Write(dr["AGVDB"].ToString(), (byte)0);
                                                s7.Write(dr["是否故障DB"].ToString(), false);
                                                reulsttt = s7.ReadByte(dr["行驶状态DB"].ToString());
                                                if (reulsttt != null && reulsttt.IsSuccess)
                                                {
                                                    if (reulsttt.Content != 0)
                                                    {
                                                        WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "向PLC写入行驶状态数据:0,当前工位无AGV");
                                                    }
                                                }
                                                s7.Write(dr["行驶状态DB"].ToString(), (byte)0);
                                                var reulsttt2 = s7.ReadBool(dr["到位DB"].ToString());
                                                if (reulsttt2 != null && reulsttt2.IsSuccess)
                                                {
                                                    if (reulsttt2.Content != false)
                                                    {
                                                        WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "向PLC写入到位数据:false,当前工位无AGV");
                                                    }
                                                }
                                                s7.Write(dr["到位DB"].ToString(), false);
                                                var reulsttt22 = s7.ReadBool(dr["离开DB"].ToString());
                                                if (reulsttt22 != null && reulsttt22.IsSuccess)
                                                {
                                                    if (reulsttt22.Content != false)
                                                    {
                                                        WriteFile("工位点记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "向PLC写入离开DB数据:false,无车离开");
                                                    }
                                                }
                                                if (!IsInOtherOutMarks)
                                                {
                                                    s7.Write(dr["离开DB"].ToString(), false);

                                                }

                                                s7.Write(dr["已离开DB"].ToString(), false);
                                                //   if (btn.BackColor != Color.Blue)
                                                {
                                                    //       btn.BackColor = SystemColors.Control;
                                                }
                                            }
                                        }
                                    }
                                    #endregion


                                    #region   离开工位点
                                    if (dr.Table.Columns.Contains("离开工位") && dr.Table.Columns.Contains("已离开DB"))
                                    {

                                        if (!string.IsNullOrEmpty(dr["离开工位"].ToString()))
                                        {

                                            var infoList = infos.FindAll(o => o.MARKNUM.ToString() == dr["离开工位"].ToString() && o.ConnectStatus && o.RUNSTATUS_Cur == 0x41);   //&& (|| o.RUNSTATUS_Cur == 0x40)
                                            if (infoList.Count >= 1)
                                            {

                                                WriteFile("离开工位记录-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "3333有车到达离开工位地标" + dr["离开工位"].ToString());

                                                if (!string.IsNullOrEmpty(dr["已离开DB"].ToString()))
                                                {
                                                    s7.Write(dr["已离开DB"].ToString(), true);
                                                    s7.Write(dr["离开DB"].ToString(), false);
                                                }

                                            }
                                            else
                                            {
                                                if (!string.IsNullOrEmpty(dr["已离开DB"].ToString()))
                                                {
                                                    s7.Write(dr["已离开DB"].ToString(), false);
                                                }
                                            }
                                        }
                                    }
                                    #endregion
                                }//));
                            }
                        }
                        catch (Exception)
                        {
                            //   WriteFile("离开工位记录111-" + dr["IP地址"].ToString() + "-" + DateTime.Now.ToString("yyyy-MM-dd"), "程序异常" + ex.StackTrace);

                        }
                        finally
                        {
                            if (s7 != null)
                            {
                                s7.ConnectClose();
                            }
                        }
                        Thread.Sleep(1000);
                    }
                }
            }
        }




        public void SendLightDate()
        {




        }


        public void PostPelletIdStatus3(StationInfo infos, string ApiAdress)
        {
            string address = "http://10.197.244.100:10057";

            string url = address + ApiAdress;
            string id = DateTime.Now.ToString("yyyyMMddhhmmssffff");
            string s = $"123 {id}";
            AGVInfo info = new AGVInfo();
            PLCSql.PLCMESSelect(infos.AGVNum.ToString(), "2", ref info);  //查询数据
            info.Behavior = 2;
            info.stationName = infos.StationName;
            info.Time = DateTime.Now;

            bool res = WcsApi.Post(url, null, info, out string data, out string msg);
            string str = $"AGV异常上报：{res}，信息：{msg}，数据：{data}";

            string Responses = $"当前站异常AGV信息：工站名={info.stationName},mark ={infos.Mark}, AGVID = {info.AgvCode}，ProductCode = {info.ProductCode}，HolderBarCode = {info.HolderBarCode}，ProductType = {info.ProductType},返回时间 = {DateTime.Now.ToString()}";//，产品个数 = {products.Count}

            WriteFile("AGV异常上报-" + DateTime.Now.ToString("yyyy-MM-dd"), Responses);

        }


        public void PostPelletIdStatus(StationInfo infos, string ApiAdress)
        {
            string address = "http://10.197.244.100:10057";

            string url = address + ApiAdress;
            string id = DateTime.Now.ToString("yyyyMMddhhmmssffff");
            string s = $"123 {id}";
            AGVInfo info = new AGVInfo();
            PLCSql.PLCMESSelect(infos.AGVNum.ToString(), "2", ref info);  //查询数据

            info.stationName = infos.StationName;
            info.Time = DateTime.Now;

            bool res = WcsApi.Post(url, null, info, out string data, out string msg);
            string str = $"到港上报：{res}，信息：{msg}，数据：{data}";

            string Responses = $"当前站AGV信息：工站名={info.stationName},mark ={infos.Mark}, AGVID = {info.AgvCode}，ProductCode = {info.ProductCode}，HolderBarCode = {info.HolderBarCode}，ProductType = {info.ProductType},返回时间 = {DateTime.Now.ToString()}";//，产品个数 = {products.Count}

            WriteFile("到港上报-" + DateTime.Now.ToString("yyyy-MM-dd"), Responses);

        }


        public AGVInfo GetStationInfo(int agvNum)
        {
            string mark = "";
            AGVInfo Agvinfo = new AGVInfo();
            //foreach (DataRow dr in GlobalPara.dtSKQPLCs.Rows)
            //{
            //    if (dr["工位名称"].ToString() == statiom)
            //    {
            //        mark = dr["工位地标"].ToString();
            //        break;
            //    }
            //}

            try
            {
                //  while (AGVPosW)
                //{
                //List<AGVInfoModel> listModel = GlobalPara.AgvInfoDic.Values.ToList();
                //List<AGVInfoModel> results = listModel.FindAll(o => o.MARKNUM.ToString() == statiom && o.ConnectStatus == true); //停止点有车
                //if (results != null && results.Count > 0)
                //{
                //    foreach (AGVInfoModel info in results)
                //    {
                //if (info != null)
                //{
                PLCSql.PLCMESSelect(agvNum.ToString(), "2", ref Agvinfo);

                //    }
                //}
                //    }
                //    Thread.Sleep(500);
                //}   //AGVpos为false代表未叫车 才进循环
            }
            catch (Exception ex)
            {

            }

            return Agvinfo;

        }


        private void sN修改ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            SNChange sn = new SNChange();
            sn.Show();
        }

        private void sN绑定修改ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            SNShow sn = new SNShow();
            sn.Show();
        }
    }
}
